/****
!<CPS_v1 type="PRIMITIVE"/>
****/
/*--------------------------- superwrap.c ------------------------------*/
/*--------------------------- superwrap.c ------------------------------*/
/*--------------------------- superwrap.c ------------------------------*/


/****
!<license>
!-------------------------------------------------------------------------------
! Copyright (c) 2007 ConocoPhillips Company
!
! Permission is hereby granted, free of charge, to any person obtaining a copy
! of this software and associated documentation files (the "Software"), to deal
! in the Software without restriction, including without limitation the rights
! to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
! copies of the Software, and to permit persons to whom the Software is
! furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in all
! copies or substantial portions of the Software.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
! IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
! FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
! AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
! LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
! OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
! SOFTWARE.
!-------------------------------------------------------------------------------
!</license>


!<brief_doc>
!-------------------------------------------------------------------------------
!                        C P S   P R I M I T I V E
!
! Name       : superwrap
! Category   : cfe
! Written    : 2003-11-03   by: Tom Stoeckley
! Revised    : 2005-04-28   by: Tom Stoeckley
!              2020-4-4		added
! FILTIIR,HEADFIT,SPSRPS,XPS,FXINTERP,FKINTERP,FXDNOISE,
! TXINTERP,CADZOW,KPSTM2D
! Maturity   : beta
! Purpose    : C wrappers around CPS processes (used by superproc).
! Portability: No known limitations.
!
! Automatically generated by program SPS_BUILD_SUPERPROC.
! Generated using SUPERWRAP_CPROC1_TEMPLATE and SUPERWRAP_CPROC2_TEMPLATE.
! Dates and revision history refer to revisions of SUPERWRAP_CPROC1_TEMPLATE.
!
!-------------------------------------------------------------------------------
!</brief_doc>


!<history_doc>
!-------------------------------------------------------------------------------
!                     AUXILIARY FILE REVISION HISTORY 
!
!     Date        Author     Description
!     ----        ------     -----------
!  3. 2005-04-28  Stoeckley  Change this to THIS so superwrap.c can be
!                             compiled with C++.
!  2. 2003-11-04  Stoeckley  Add MATURITY key.
!  1. 2003-11-03  Stoeckley  Initial version of SUPERWRAP_CPROC1_TEMPLATE.
!
!-------------------------------------------------------------------------------
!</history_doc>
****/


/*--------------------------- start of coding ------------------------------*/
/*--------------------------- start of coding ------------------------------*/
/*--------------------------- start of coding ------------------------------*/


char superwrap_ident[100] =
"$Id: superwrap_cproc1_template,v 1.3 2005/04/28 20:18:33 Stoeckley prod sps $";

#include "superproc_crou.h"



/*------------------------------- ABAL -------------------------------*/
/*------------------------------- ABAL -------------------------------*/
/*------------------------------- ABAL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define abal_superwrap_create            abal_superwrap_create_
#define abal_superwrap_init              abal_superwrap_init_
#define abal_superwrap_update            abal_superwrap_update_
#define abal_superwrap_oneset            abal_superwrap_oneset_ 
#define abal_superwrap_twosets           abal_superwrap_twosets_
#define abal_superwrap_wrapup            abal_superwrap_wrapup_
#define abal_superwrap_delete            abal_superwrap_delete_
#elif defined NEED_CAPITALS
#define abal_superwrap_create            ABAL_SUPERWRAP_CREATE
#define abal_superwrap_init              ABAL_SUPERWRAP_INIT
#define abal_superwrap_update            ABAL_SUPERWRAP_UPDATE
#define abal_superwrap_oneset            ABAL_SUPERWRAP_ONESET 
#define abal_superwrap_twosets           ABAL_SUPERWRAP_TWOSETS
#define abal_superwrap_wrapup            ABAL_SUPERWRAP_WRAPUP
#define abal_superwrap_delete            ABAL_SUPERWRAP_DELETE
#endif


ProcessCreate     abal_superwrap_create;
ProcessInitialize abal_superwrap_init;
ProcessUpdate     abal_superwrap_update;
ProcessOneset     abal_superwrap_oneset;
ProcessTwosets    abal_superwrap_twosets;
ProcessWrapup     abal_superwrap_wrapup;
ProcessDelete     abal_superwrap_delete;


void superwrap_abal_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = abal_superwrap_create;
  THIS->initialize = abal_superwrap_init;
  THIS->update     = abal_superwrap_update;
  THIS->oneset     = abal_superwrap_oneset;
  THIS->twosets    = abal_superwrap_twosets;
  THIS->wrapup     = abal_superwrap_wrapup;
  THIS->delete     = abal_superwrap_delete;
}



/*------------------------------- ABRA -------------------------------*/
/*------------------------------- ABRA -------------------------------*/
/*------------------------------- ABRA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define abra_superwrap_create            abra_superwrap_create_
#define abra_superwrap_init              abra_superwrap_init_
#define abra_superwrap_update            abra_superwrap_update_
#define abra_superwrap_oneset            abra_superwrap_oneset_ 
#define abra_superwrap_twosets           abra_superwrap_twosets_
#define abra_superwrap_wrapup            abra_superwrap_wrapup_
#define abra_superwrap_delete            abra_superwrap_delete_
#elif defined NEED_CAPITALS
#define abra_superwrap_create            ABRA_SUPERWRAP_CREATE
#define abra_superwrap_init              ABRA_SUPERWRAP_INIT
#define abra_superwrap_update            ABRA_SUPERWRAP_UPDATE
#define abra_superwrap_oneset            ABRA_SUPERWRAP_ONESET 
#define abra_superwrap_twosets           ABRA_SUPERWRAP_TWOSETS
#define abra_superwrap_wrapup            ABRA_SUPERWRAP_WRAPUP
#define abra_superwrap_delete            ABRA_SUPERWRAP_DELETE
#endif


ProcessCreate     abra_superwrap_create;
ProcessInitialize abra_superwrap_init;
ProcessUpdate     abra_superwrap_update;
ProcessOneset     abra_superwrap_oneset;
ProcessTwosets    abra_superwrap_twosets;
ProcessWrapup     abra_superwrap_wrapup;
ProcessDelete     abra_superwrap_delete;


void superwrap_abra_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = abra_superwrap_create;
  THIS->initialize = abra_superwrap_init;
  THIS->update     = abra_superwrap_update;
  THIS->oneset     = abra_superwrap_oneset;
  THIS->twosets    = abra_superwrap_twosets;
  THIS->wrapup     = abra_superwrap_wrapup;
  THIS->delete     = abra_superwrap_delete;
}



/*------------------------------- ACORR -------------------------------*/
/*------------------------------- ACORR -------------------------------*/
/*------------------------------- ACORR -------------------------------*/


#ifdef NEED_UNDERSCORE
#define acorr_superwrap_create            acorr_superwrap_create_
#define acorr_superwrap_init              acorr_superwrap_init_
#define acorr_superwrap_update            acorr_superwrap_update_
#define acorr_superwrap_oneset            acorr_superwrap_oneset_ 
#define acorr_superwrap_twosets           acorr_superwrap_twosets_
#define acorr_superwrap_wrapup            acorr_superwrap_wrapup_
#define acorr_superwrap_delete            acorr_superwrap_delete_
#elif defined NEED_CAPITALS
#define acorr_superwrap_create            ACORR_SUPERWRAP_CREATE
#define acorr_superwrap_init              ACORR_SUPERWRAP_INIT
#define acorr_superwrap_update            ACORR_SUPERWRAP_UPDATE
#define acorr_superwrap_oneset            ACORR_SUPERWRAP_ONESET 
#define acorr_superwrap_twosets           ACORR_SUPERWRAP_TWOSETS
#define acorr_superwrap_wrapup            ACORR_SUPERWRAP_WRAPUP
#define acorr_superwrap_delete            ACORR_SUPERWRAP_DELETE
#endif


ProcessCreate     acorr_superwrap_create;
ProcessInitialize acorr_superwrap_init;
ProcessUpdate     acorr_superwrap_update;
ProcessOneset     acorr_superwrap_oneset;
ProcessTwosets    acorr_superwrap_twosets;
ProcessWrapup     acorr_superwrap_wrapup;
ProcessDelete     acorr_superwrap_delete;


void superwrap_acorr_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = acorr_superwrap_create;
  THIS->initialize = acorr_superwrap_init;
  THIS->update     = acorr_superwrap_update;
  THIS->oneset     = acorr_superwrap_oneset;
  THIS->twosets    = acorr_superwrap_twosets;
  THIS->wrapup     = acorr_superwrap_wrapup;
  THIS->delete     = acorr_superwrap_delete;
}



/*------------------------------- ADNS -------------------------------*/
/*------------------------------- ADNS -------------------------------*/
/*------------------------------- ADNS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define adns_superwrap_create            adns_superwrap_create_
#define adns_superwrap_init              adns_superwrap_init_
#define adns_superwrap_update            adns_superwrap_update_
#define adns_superwrap_oneset            adns_superwrap_oneset_ 
#define adns_superwrap_twosets           adns_superwrap_twosets_
#define adns_superwrap_wrapup            adns_superwrap_wrapup_
#define adns_superwrap_delete            adns_superwrap_delete_
#elif defined NEED_CAPITALS
#define adns_superwrap_create            ADNS_SUPERWRAP_CREATE
#define adns_superwrap_init              ADNS_SUPERWRAP_INIT
#define adns_superwrap_update            ADNS_SUPERWRAP_UPDATE
#define adns_superwrap_oneset            ADNS_SUPERWRAP_ONESET 
#define adns_superwrap_twosets           ADNS_SUPERWRAP_TWOSETS
#define adns_superwrap_wrapup            ADNS_SUPERWRAP_WRAPUP
#define adns_superwrap_delete            ADNS_SUPERWRAP_DELETE
#endif


ProcessCreate     adns_superwrap_create;
ProcessInitialize adns_superwrap_init;
ProcessUpdate     adns_superwrap_update;
ProcessOneset     adns_superwrap_oneset;
ProcessTwosets    adns_superwrap_twosets;
ProcessWrapup     adns_superwrap_wrapup;
ProcessDelete     adns_superwrap_delete;


void superwrap_adns_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = adns_superwrap_create;
  THIS->initialize = adns_superwrap_init;
  THIS->update     = adns_superwrap_update;
  THIS->oneset     = adns_superwrap_oneset;
  THIS->twosets    = adns_superwrap_twosets;
  THIS->wrapup     = adns_superwrap_wrapup;
  THIS->delete     = adns_superwrap_delete;
}



/*------------------------------- ADPSUB -------------------------------*/
/*------------------------------- ADPSUB -------------------------------*/
/*------------------------------- ADPSUB -------------------------------*/


#ifdef NEED_UNDERSCORE
#define adpsub_superwrap_create            adpsub_superwrap_create_
#define adpsub_superwrap_init              adpsub_superwrap_init_
#define adpsub_superwrap_update            adpsub_superwrap_update_
#define adpsub_superwrap_oneset            adpsub_superwrap_oneset_ 
#define adpsub_superwrap_twosets           adpsub_superwrap_twosets_
#define adpsub_superwrap_wrapup            adpsub_superwrap_wrapup_
#define adpsub_superwrap_delete            adpsub_superwrap_delete_
#elif defined NEED_CAPITALS
#define adpsub_superwrap_create            ADPSUB_SUPERWRAP_CREATE
#define adpsub_superwrap_init              ADPSUB_SUPERWRAP_INIT
#define adpsub_superwrap_update            ADPSUB_SUPERWRAP_UPDATE
#define adpsub_superwrap_oneset            ADPSUB_SUPERWRAP_ONESET 
#define adpsub_superwrap_twosets           ADPSUB_SUPERWRAP_TWOSETS
#define adpsub_superwrap_wrapup            ADPSUB_SUPERWRAP_WRAPUP
#define adpsub_superwrap_delete            ADPSUB_SUPERWRAP_DELETE
#endif


ProcessCreate     adpsub_superwrap_create;
ProcessInitialize adpsub_superwrap_init;
ProcessUpdate     adpsub_superwrap_update;
ProcessOneset     adpsub_superwrap_oneset;
ProcessTwosets    adpsub_superwrap_twosets;
ProcessWrapup     adpsub_superwrap_wrapup;
ProcessDelete     adpsub_superwrap_delete;


void superwrap_adpsub_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = adpsub_superwrap_create;
  THIS->initialize = adpsub_superwrap_init;
  THIS->update     = adpsub_superwrap_update;
  THIS->oneset     = adpsub_superwrap_oneset;
  THIS->twosets    = adpsub_superwrap_twosets;
  THIS->wrapup     = adpsub_superwrap_wrapup;
  THIS->delete     = adpsub_superwrap_delete;
}



/*------------------------------- ALAMO -------------------------------*/
/*------------------------------- ALAMO -------------------------------*/
/*------------------------------- ALAMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define alamo_superwrap_create            alamo_superwrap_create_
#define alamo_superwrap_init              alamo_superwrap_init_
#define alamo_superwrap_update            alamo_superwrap_update_
#define alamo_superwrap_oneset            alamo_superwrap_oneset_ 
#define alamo_superwrap_twosets           alamo_superwrap_twosets_
#define alamo_superwrap_wrapup            alamo_superwrap_wrapup_
#define alamo_superwrap_delete            alamo_superwrap_delete_
#elif defined NEED_CAPITALS
#define alamo_superwrap_create            ALAMO_SUPERWRAP_CREATE
#define alamo_superwrap_init              ALAMO_SUPERWRAP_INIT
#define alamo_superwrap_update            ALAMO_SUPERWRAP_UPDATE
#define alamo_superwrap_oneset            ALAMO_SUPERWRAP_ONESET 
#define alamo_superwrap_twosets           ALAMO_SUPERWRAP_TWOSETS
#define alamo_superwrap_wrapup            ALAMO_SUPERWRAP_WRAPUP
#define alamo_superwrap_delete            ALAMO_SUPERWRAP_DELETE
#endif


ProcessCreate     alamo_superwrap_create;
ProcessInitialize alamo_superwrap_init;
ProcessUpdate     alamo_superwrap_update;
ProcessOneset     alamo_superwrap_oneset;
ProcessTwosets    alamo_superwrap_twosets;
ProcessWrapup     alamo_superwrap_wrapup;
ProcessDelete     alamo_superwrap_delete;


void superwrap_alamo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = alamo_superwrap_create;
  THIS->initialize = alamo_superwrap_init;
  THIS->update     = alamo_superwrap_update;
  THIS->oneset     = alamo_superwrap_oneset;
  THIS->twosets    = alamo_superwrap_twosets;
  THIS->wrapup     = alamo_superwrap_wrapup;
  THIS->delete     = alamo_superwrap_delete;
}



/*------------------------------- AMPDG -------------------------------*/
/*------------------------------- AMPDG -------------------------------*/
/*------------------------------- AMPDG -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ampdg_superwrap_create            ampdg_superwrap_create_
#define ampdg_superwrap_init              ampdg_superwrap_init_
#define ampdg_superwrap_update            ampdg_superwrap_update_
#define ampdg_superwrap_oneset            ampdg_superwrap_oneset_ 
#define ampdg_superwrap_twosets           ampdg_superwrap_twosets_
#define ampdg_superwrap_wrapup            ampdg_superwrap_wrapup_
#define ampdg_superwrap_delete            ampdg_superwrap_delete_
#elif defined NEED_CAPITALS
#define ampdg_superwrap_create            AMPDG_SUPERWRAP_CREATE
#define ampdg_superwrap_init              AMPDG_SUPERWRAP_INIT
#define ampdg_superwrap_update            AMPDG_SUPERWRAP_UPDATE
#define ampdg_superwrap_oneset            AMPDG_SUPERWRAP_ONESET 
#define ampdg_superwrap_twosets           AMPDG_SUPERWRAP_TWOSETS
#define ampdg_superwrap_wrapup            AMPDG_SUPERWRAP_WRAPUP
#define ampdg_superwrap_delete            AMPDG_SUPERWRAP_DELETE
#endif


ProcessCreate     ampdg_superwrap_create;
ProcessInitialize ampdg_superwrap_init;
ProcessUpdate     ampdg_superwrap_update;
ProcessOneset     ampdg_superwrap_oneset;
ProcessTwosets    ampdg_superwrap_twosets;
ProcessWrapup     ampdg_superwrap_wrapup;
ProcessDelete     ampdg_superwrap_delete;


void superwrap_ampdg_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ampdg_superwrap_create;
  THIS->initialize = ampdg_superwrap_init;
  THIS->update     = ampdg_superwrap_update;
  THIS->oneset     = ampdg_superwrap_oneset;
  THIS->twosets    = ampdg_superwrap_twosets;
  THIS->wrapup     = ampdg_superwrap_wrapup;
  THIS->delete     = ampdg_superwrap_delete;
}



/*------------------------------- APIN -------------------------------*/
/*------------------------------- APIN -------------------------------*/
/*------------------------------- APIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define apin_superwrap_create            apin_superwrap_create_
#define apin_superwrap_init              apin_superwrap_init_
#define apin_superwrap_update            apin_superwrap_update_
#define apin_superwrap_oneset            apin_superwrap_oneset_ 
#define apin_superwrap_twosets           apin_superwrap_twosets_
#define apin_superwrap_wrapup            apin_superwrap_wrapup_
#define apin_superwrap_delete            apin_superwrap_delete_
#elif defined NEED_CAPITALS
#define apin_superwrap_create            APIN_SUPERWRAP_CREATE
#define apin_superwrap_init              APIN_SUPERWRAP_INIT
#define apin_superwrap_update            APIN_SUPERWRAP_UPDATE
#define apin_superwrap_oneset            APIN_SUPERWRAP_ONESET 
#define apin_superwrap_twosets           APIN_SUPERWRAP_TWOSETS
#define apin_superwrap_wrapup            APIN_SUPERWRAP_WRAPUP
#define apin_superwrap_delete            APIN_SUPERWRAP_DELETE
#endif


ProcessCreate     apin_superwrap_create;
ProcessInitialize apin_superwrap_init;
ProcessUpdate     apin_superwrap_update;
ProcessOneset     apin_superwrap_oneset;
ProcessTwosets    apin_superwrap_twosets;
ProcessWrapup     apin_superwrap_wrapup;
ProcessDelete     apin_superwrap_delete;


void superwrap_apin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = apin_superwrap_create;
  THIS->initialize = apin_superwrap_init;
  THIS->update     = apin_superwrap_update;
  THIS->oneset     = apin_superwrap_oneset;
  THIS->twosets    = apin_superwrap_twosets;
  THIS->wrapup     = apin_superwrap_wrapup;
  THIS->delete     = apin_superwrap_delete;
}



/*------------------------------- ATRIN -------------------------------*/
/*------------------------------- ATRIN -------------------------------*/
/*------------------------------- ATRIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define atrin_superwrap_create            atrin_superwrap_create_
#define atrin_superwrap_init              atrin_superwrap_init_
#define atrin_superwrap_update            atrin_superwrap_update_
#define atrin_superwrap_oneset            atrin_superwrap_oneset_ 
#define atrin_superwrap_twosets           atrin_superwrap_twosets_
#define atrin_superwrap_wrapup            atrin_superwrap_wrapup_
#define atrin_superwrap_delete            atrin_superwrap_delete_
#elif defined NEED_CAPITALS
#define atrin_superwrap_create            ATRIN_SUPERWRAP_CREATE
#define atrin_superwrap_init              ATRIN_SUPERWRAP_INIT
#define atrin_superwrap_update            ATRIN_SUPERWRAP_UPDATE
#define atrin_superwrap_oneset            ATRIN_SUPERWRAP_ONESET 
#define atrin_superwrap_twosets           ATRIN_SUPERWRAP_TWOSETS
#define atrin_superwrap_wrapup            ATRIN_SUPERWRAP_WRAPUP
#define atrin_superwrap_delete            ATRIN_SUPERWRAP_DELETE
#endif


ProcessCreate     atrin_superwrap_create;
ProcessInitialize atrin_superwrap_init;
ProcessUpdate     atrin_superwrap_update;
ProcessOneset     atrin_superwrap_oneset;
ProcessTwosets    atrin_superwrap_twosets;
ProcessWrapup     atrin_superwrap_wrapup;
ProcessDelete     atrin_superwrap_delete;


void superwrap_atrin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = atrin_superwrap_create;
  THIS->initialize = atrin_superwrap_init;
  THIS->update     = atrin_superwrap_update;
  THIS->oneset     = atrin_superwrap_oneset;
  THIS->twosets    = atrin_superwrap_twosets;
  THIS->wrapup     = atrin_superwrap_wrapup;
  THIS->delete     = atrin_superwrap_delete;
}



/*------------------------------- ATROT -------------------------------*/
/*------------------------------- ATROT -------------------------------*/
/*------------------------------- ATROT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define atrot_superwrap_create            atrot_superwrap_create_
#define atrot_superwrap_init              atrot_superwrap_init_
#define atrot_superwrap_update            atrot_superwrap_update_
#define atrot_superwrap_oneset            atrot_superwrap_oneset_ 
#define atrot_superwrap_twosets           atrot_superwrap_twosets_
#define atrot_superwrap_wrapup            atrot_superwrap_wrapup_
#define atrot_superwrap_delete            atrot_superwrap_delete_
#elif defined NEED_CAPITALS
#define atrot_superwrap_create            ATROT_SUPERWRAP_CREATE
#define atrot_superwrap_init              ATROT_SUPERWRAP_INIT
#define atrot_superwrap_update            ATROT_SUPERWRAP_UPDATE
#define atrot_superwrap_oneset            ATROT_SUPERWRAP_ONESET 
#define atrot_superwrap_twosets           ATROT_SUPERWRAP_TWOSETS
#define atrot_superwrap_wrapup            ATROT_SUPERWRAP_WRAPUP
#define atrot_superwrap_delete            ATROT_SUPERWRAP_DELETE
#endif


ProcessCreate     atrot_superwrap_create;
ProcessInitialize atrot_superwrap_init;
ProcessUpdate     atrot_superwrap_update;
ProcessOneset     atrot_superwrap_oneset;
ProcessTwosets    atrot_superwrap_twosets;
ProcessWrapup     atrot_superwrap_wrapup;
ProcessDelete     atrot_superwrap_delete;


void superwrap_atrot_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = atrot_superwrap_create;
  THIS->initialize = atrot_superwrap_init;
  THIS->update     = atrot_superwrap_update;
  THIS->oneset     = atrot_superwrap_oneset;
  THIS->twosets    = atrot_superwrap_twosets;
  THIS->wrapup     = atrot_superwrap_wrapup;
  THIS->delete     = atrot_superwrap_delete;
}




/*------------------------------- AVAGRAD -------------------------------*/
/*------------------------------- AVAGRAD -------------------------------*/
/*------------------------------- AVAGRAD -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avagrad_superwrap_create            avagrad_superwrap_create_
#define avagrad_superwrap_init              avagrad_superwrap_init_
#define avagrad_superwrap_update            avagrad_superwrap_update_
#define avagrad_superwrap_oneset            avagrad_superwrap_oneset_ 
#define avagrad_superwrap_twosets           avagrad_superwrap_twosets_
#define avagrad_superwrap_wrapup            avagrad_superwrap_wrapup_
#define avagrad_superwrap_delete            avagrad_superwrap_delete_
#elif defined NEED_CAPITALS
#define avagrad_superwrap_create            AVAGRAD_SUPERWRAP_CREATE
#define avagrad_superwrap_init              AVAGRAD_SUPERWRAP_INIT
#define avagrad_superwrap_update            AVAGRAD_SUPERWRAP_UPDATE
#define avagrad_superwrap_oneset            AVAGRAD_SUPERWRAP_ONESET 
#define avagrad_superwrap_twosets           AVAGRAD_SUPERWRAP_TWOSETS
#define avagrad_superwrap_wrapup            AVAGRAD_SUPERWRAP_WRAPUP
#define avagrad_superwrap_delete            AVAGRAD_SUPERWRAP_DELETE
#endif


ProcessCreate     avagrad_superwrap_create;
ProcessInitialize avagrad_superwrap_init;
ProcessUpdate     avagrad_superwrap_update;
ProcessOneset     avagrad_superwrap_oneset;
ProcessTwosets    avagrad_superwrap_twosets;
ProcessWrapup     avagrad_superwrap_wrapup;
ProcessDelete     avagrad_superwrap_delete;


void superwrap_avagrad_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avagrad_superwrap_create;
  THIS->initialize = avagrad_superwrap_init;
  THIS->update     = avagrad_superwrap_update;
  THIS->oneset     = avagrad_superwrap_oneset;
  THIS->twosets    = avagrad_superwrap_twosets;
  THIS->wrapup     = avagrad_superwrap_wrapup;
  THIS->delete     = avagrad_superwrap_delete;
}



/*------------------------------- AVAST -------------------------------*/
/*------------------------------- AVAST -------------------------------*/
/*------------------------------- AVAST -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avast_superwrap_create            avast_superwrap_create_
#define avast_superwrap_init              avast_superwrap_init_
#define avast_superwrap_update            avast_superwrap_update_
#define avast_superwrap_oneset            avast_superwrap_oneset_ 
#define avast_superwrap_twosets           avast_superwrap_twosets_
#define avast_superwrap_wrapup            avast_superwrap_wrapup_
#define avast_superwrap_delete            avast_superwrap_delete_
#elif defined NEED_CAPITALS
#define avast_superwrap_create            AVAST_SUPERWRAP_CREATE
#define avast_superwrap_init              AVAST_SUPERWRAP_INIT
#define avast_superwrap_update            AVAST_SUPERWRAP_UPDATE
#define avast_superwrap_oneset            AVAST_SUPERWRAP_ONESET 
#define avast_superwrap_twosets           AVAST_SUPERWRAP_TWOSETS
#define avast_superwrap_wrapup            AVAST_SUPERWRAP_WRAPUP
#define avast_superwrap_delete            AVAST_SUPERWRAP_DELETE
#endif


ProcessCreate     avast_superwrap_create;
ProcessInitialize avast_superwrap_init;
ProcessUpdate     avast_superwrap_update;
ProcessOneset     avast_superwrap_oneset;
ProcessTwosets    avast_superwrap_twosets;
ProcessWrapup     avast_superwrap_wrapup;
ProcessDelete     avast_superwrap_delete;


void superwrap_avast_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avast_superwrap_create;
  THIS->initialize = avast_superwrap_init;
  THIS->update     = avast_superwrap_update;
  THIS->oneset     = avast_superwrap_oneset;
  THIS->twosets    = avast_superwrap_twosets;
  THIS->wrapup     = avast_superwrap_wrapup;
  THIS->delete     = avast_superwrap_delete;
}



/*------------------------------- AVOANS -------------------------------*/
/*------------------------------- AVOANS -------------------------------*/
/*------------------------------- AVOANS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avoans_superwrap_create            avoans_superwrap_create_
#define avoans_superwrap_init              avoans_superwrap_init_
#define avoans_superwrap_update            avoans_superwrap_update_
#define avoans_superwrap_oneset            avoans_superwrap_oneset_ 
#define avoans_superwrap_twosets           avoans_superwrap_twosets_
#define avoans_superwrap_wrapup            avoans_superwrap_wrapup_
#define avoans_superwrap_delete            avoans_superwrap_delete_
#elif defined NEED_CAPITALS
#define avoans_superwrap_create            AVOANS_SUPERWRAP_CREATE
#define avoans_superwrap_init              AVOANS_SUPERWRAP_INIT
#define avoans_superwrap_update            AVOANS_SUPERWRAP_UPDATE
#define avoans_superwrap_oneset            AVOANS_SUPERWRAP_ONESET 
#define avoans_superwrap_twosets           AVOANS_SUPERWRAP_TWOSETS
#define avoans_superwrap_wrapup            AVOANS_SUPERWRAP_WRAPUP
#define avoans_superwrap_delete            AVOANS_SUPERWRAP_DELETE
#endif


ProcessCreate     avoans_superwrap_create;
ProcessInitialize avoans_superwrap_init;
ProcessUpdate     avoans_superwrap_update;
ProcessOneset     avoans_superwrap_oneset;
ProcessTwosets    avoans_superwrap_twosets;
ProcessWrapup     avoans_superwrap_wrapup;
ProcessDelete     avoans_superwrap_delete;


void superwrap_avoans_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avoans_superwrap_create;
  THIS->initialize = avoans_superwrap_init;
  THIS->update     = avoans_superwrap_update;
  THIS->oneset     = avoans_superwrap_oneset;
  THIS->twosets    = avoans_superwrap_twosets;
  THIS->wrapup     = avoans_superwrap_wrapup;
  THIS->delete     = avoans_superwrap_delete;
}



/*------------------------------- AVOCORR -------------------------------*/
/*------------------------------- AVOCORR -------------------------------*/
/*------------------------------- AVOCORR -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avocorr_superwrap_create            avocorr_superwrap_create_
#define avocorr_superwrap_init              avocorr_superwrap_init_
#define avocorr_superwrap_update            avocorr_superwrap_update_
#define avocorr_superwrap_oneset            avocorr_superwrap_oneset_ 
#define avocorr_superwrap_twosets           avocorr_superwrap_twosets_
#define avocorr_superwrap_wrapup            avocorr_superwrap_wrapup_
#define avocorr_superwrap_delete            avocorr_superwrap_delete_
#elif defined NEED_CAPITALS
#define avocorr_superwrap_create            AVOCORR_SUPERWRAP_CREATE
#define avocorr_superwrap_init              AVOCORR_SUPERWRAP_INIT
#define avocorr_superwrap_update            AVOCORR_SUPERWRAP_UPDATE
#define avocorr_superwrap_oneset            AVOCORR_SUPERWRAP_ONESET 
#define avocorr_superwrap_twosets           AVOCORR_SUPERWRAP_TWOSETS
#define avocorr_superwrap_wrapup            AVOCORR_SUPERWRAP_WRAPUP
#define avocorr_superwrap_delete            AVOCORR_SUPERWRAP_DELETE
#endif


ProcessCreate     avocorr_superwrap_create;
ProcessInitialize avocorr_superwrap_init;
ProcessUpdate     avocorr_superwrap_update;
ProcessOneset     avocorr_superwrap_oneset;
ProcessTwosets    avocorr_superwrap_twosets;
ProcessWrapup     avocorr_superwrap_wrapup;
ProcessDelete     avocorr_superwrap_delete;


void superwrap_avocorr_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avocorr_superwrap_create;
  THIS->initialize = avocorr_superwrap_init;
  THIS->update     = avocorr_superwrap_update;
  THIS->oneset     = avocorr_superwrap_oneset;
  THIS->twosets    = avocorr_superwrap_twosets;
  THIS->wrapup     = avocorr_superwrap_wrapup;
  THIS->delete     = avocorr_superwrap_delete;
}



/*------------------------------- AVONRM -------------------------------*/
/*------------------------------- AVONRM -------------------------------*/
/*------------------------------- AVONRM -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avonrm_superwrap_create            avonrm_superwrap_create_
#define avonrm_superwrap_init              avonrm_superwrap_init_
#define avonrm_superwrap_update            avonrm_superwrap_update_
#define avonrm_superwrap_oneset            avonrm_superwrap_oneset_ 
#define avonrm_superwrap_twosets           avonrm_superwrap_twosets_
#define avonrm_superwrap_wrapup            avonrm_superwrap_wrapup_
#define avonrm_superwrap_delete            avonrm_superwrap_delete_
#elif defined NEED_CAPITALS
#define avonrm_superwrap_create            AVONRM_SUPERWRAP_CREATE
#define avonrm_superwrap_init              AVONRM_SUPERWRAP_INIT
#define avonrm_superwrap_update            AVONRM_SUPERWRAP_UPDATE
#define avonrm_superwrap_oneset            AVONRM_SUPERWRAP_ONESET 
#define avonrm_superwrap_twosets           AVONRM_SUPERWRAP_TWOSETS
#define avonrm_superwrap_wrapup            AVONRM_SUPERWRAP_WRAPUP
#define avonrm_superwrap_delete            AVONRM_SUPERWRAP_DELETE
#endif


ProcessCreate     avonrm_superwrap_create;
ProcessInitialize avonrm_superwrap_init;
ProcessUpdate     avonrm_superwrap_update;
ProcessOneset     avonrm_superwrap_oneset;
ProcessTwosets    avonrm_superwrap_twosets;
ProcessWrapup     avonrm_superwrap_wrapup;
ProcessDelete     avonrm_superwrap_delete;


void superwrap_avonrm_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avonrm_superwrap_create;
  THIS->initialize = avonrm_superwrap_init;
  THIS->update     = avonrm_superwrap_update;
  THIS->oneset     = avonrm_superwrap_oneset;
  THIS->twosets    = avonrm_superwrap_twosets;
  THIS->wrapup     = avonrm_superwrap_wrapup;
  THIS->delete     = avonrm_superwrap_delete;
}



/*------------------------------- AVOPCOMP -------------------------------*/
/*------------------------------- AVOPCOMP -------------------------------*/
/*------------------------------- AVOPCOMP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avopcomp_superwrap_create            avopcomp_superwrap_create_
#define avopcomp_superwrap_init              avopcomp_superwrap_init_
#define avopcomp_superwrap_update            avopcomp_superwrap_update_
#define avopcomp_superwrap_oneset            avopcomp_superwrap_oneset_ 
#define avopcomp_superwrap_twosets           avopcomp_superwrap_twosets_
#define avopcomp_superwrap_wrapup            avopcomp_superwrap_wrapup_
#define avopcomp_superwrap_delete            avopcomp_superwrap_delete_
#elif defined NEED_CAPITALS
#define avopcomp_superwrap_create            AVOPCOMP_SUPERWRAP_CREATE
#define avopcomp_superwrap_init              AVOPCOMP_SUPERWRAP_INIT
#define avopcomp_superwrap_update            AVOPCOMP_SUPERWRAP_UPDATE
#define avopcomp_superwrap_oneset            AVOPCOMP_SUPERWRAP_ONESET 
#define avopcomp_superwrap_twosets           AVOPCOMP_SUPERWRAP_TWOSETS
#define avopcomp_superwrap_wrapup            AVOPCOMP_SUPERWRAP_WRAPUP
#define avopcomp_superwrap_delete            AVOPCOMP_SUPERWRAP_DELETE
#endif


ProcessCreate     avopcomp_superwrap_create;
ProcessInitialize avopcomp_superwrap_init;
ProcessUpdate     avopcomp_superwrap_update;
ProcessOneset     avopcomp_superwrap_oneset;
ProcessTwosets    avopcomp_superwrap_twosets;
ProcessWrapup     avopcomp_superwrap_wrapup;
ProcessDelete     avopcomp_superwrap_delete;


void superwrap_avopcomp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avopcomp_superwrap_create;
  THIS->initialize = avopcomp_superwrap_init;
  THIS->update     = avopcomp_superwrap_update;
  THIS->oneset     = avopcomp_superwrap_oneset;
  THIS->twosets    = avopcomp_superwrap_twosets;
  THIS->wrapup     = avopcomp_superwrap_wrapup;
  THIS->delete     = avopcomp_superwrap_delete;
}



/*------------------------------- AVOSTS -------------------------------*/
/*------------------------------- AVOSTS -------------------------------*/
/*------------------------------- AVOSTS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avosts_superwrap_create            avosts_superwrap_create_
#define avosts_superwrap_init              avosts_superwrap_init_
#define avosts_superwrap_update            avosts_superwrap_update_
#define avosts_superwrap_oneset            avosts_superwrap_oneset_ 
#define avosts_superwrap_twosets           avosts_superwrap_twosets_
#define avosts_superwrap_wrapup            avosts_superwrap_wrapup_
#define avosts_superwrap_delete            avosts_superwrap_delete_
#elif defined NEED_CAPITALS
#define avosts_superwrap_create            AVOSTS_SUPERWRAP_CREATE
#define avosts_superwrap_init              AVOSTS_SUPERWRAP_INIT
#define avosts_superwrap_update            AVOSTS_SUPERWRAP_UPDATE
#define avosts_superwrap_oneset            AVOSTS_SUPERWRAP_ONESET 
#define avosts_superwrap_twosets           AVOSTS_SUPERWRAP_TWOSETS
#define avosts_superwrap_wrapup            AVOSTS_SUPERWRAP_WRAPUP
#define avosts_superwrap_delete            AVOSTS_SUPERWRAP_DELETE
#endif


ProcessCreate     avosts_superwrap_create;
ProcessInitialize avosts_superwrap_init;
ProcessUpdate     avosts_superwrap_update;
ProcessOneset     avosts_superwrap_oneset;
ProcessTwosets    avosts_superwrap_twosets;
ProcessWrapup     avosts_superwrap_wrapup;
ProcessDelete     avosts_superwrap_delete;


void superwrap_avosts_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avosts_superwrap_create;
  THIS->initialize = avosts_superwrap_init;
  THIS->update     = avosts_superwrap_update;
  THIS->oneset     = avosts_superwrap_oneset;
  THIS->twosets    = avosts_superwrap_twosets;
  THIS->wrapup     = avosts_superwrap_wrapup;
  THIS->delete     = avosts_superwrap_delete;
}



/*------------------------------- AVOVAN -------------------------------*/
/*------------------------------- AVOVAN -------------------------------*/
/*------------------------------- AVOVAN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avovan_superwrap_create            avovan_superwrap_create_
#define avovan_superwrap_init              avovan_superwrap_init_
#define avovan_superwrap_update            avovan_superwrap_update_
#define avovan_superwrap_oneset            avovan_superwrap_oneset_ 
#define avovan_superwrap_twosets           avovan_superwrap_twosets_
#define avovan_superwrap_wrapup            avovan_superwrap_wrapup_
#define avovan_superwrap_delete            avovan_superwrap_delete_
#elif defined NEED_CAPITALS
#define avovan_superwrap_create            AVOVAN_SUPERWRAP_CREATE
#define avovan_superwrap_init              AVOVAN_SUPERWRAP_INIT
#define avovan_superwrap_update            AVOVAN_SUPERWRAP_UPDATE
#define avovan_superwrap_oneset            AVOVAN_SUPERWRAP_ONESET 
#define avovan_superwrap_twosets           AVOVAN_SUPERWRAP_TWOSETS
#define avovan_superwrap_wrapup            AVOVAN_SUPERWRAP_WRAPUP
#define avovan_superwrap_delete            AVOVAN_SUPERWRAP_DELETE
#endif


ProcessCreate     avovan_superwrap_create;
ProcessInitialize avovan_superwrap_init;
ProcessUpdate     avovan_superwrap_update;
ProcessOneset     avovan_superwrap_oneset;
ProcessTwosets    avovan_superwrap_twosets;
ProcessWrapup     avovan_superwrap_wrapup;
ProcessDelete     avovan_superwrap_delete;


void superwrap_avovan_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avovan_superwrap_create;
  THIS->initialize = avovan_superwrap_init;
  THIS->update     = avovan_superwrap_update;
  THIS->oneset     = avovan_superwrap_oneset;
  THIS->twosets    = avovan_superwrap_twosets;
  THIS->wrapup     = avovan_superwrap_wrapup;
  THIS->delete     = avovan_superwrap_delete;
}



/*------------------------------- AVOVIT -------------------------------*/
/*------------------------------- AVOVIT -------------------------------*/
/*------------------------------- AVOVIT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define avovit_superwrap_create            avovit_superwrap_create_
#define avovit_superwrap_init              avovit_superwrap_init_
#define avovit_superwrap_update            avovit_superwrap_update_
#define avovit_superwrap_oneset            avovit_superwrap_oneset_ 
#define avovit_superwrap_twosets           avovit_superwrap_twosets_
#define avovit_superwrap_wrapup            avovit_superwrap_wrapup_
#define avovit_superwrap_delete            avovit_superwrap_delete_
#elif defined NEED_CAPITALS
#define avovit_superwrap_create            AVOVIT_SUPERWRAP_CREATE
#define avovit_superwrap_init              AVOVIT_SUPERWRAP_INIT
#define avovit_superwrap_update            AVOVIT_SUPERWRAP_UPDATE
#define avovit_superwrap_oneset            AVOVIT_SUPERWRAP_ONESET 
#define avovit_superwrap_twosets           AVOVIT_SUPERWRAP_TWOSETS
#define avovit_superwrap_wrapup            AVOVIT_SUPERWRAP_WRAPUP
#define avovit_superwrap_delete            AVOVIT_SUPERWRAP_DELETE
#endif


ProcessCreate     avovit_superwrap_create;
ProcessInitialize avovit_superwrap_init;
ProcessUpdate     avovit_superwrap_update;
ProcessOneset     avovit_superwrap_oneset;
ProcessTwosets    avovit_superwrap_twosets;
ProcessWrapup     avovit_superwrap_wrapup;
ProcessDelete     avovit_superwrap_delete;


void superwrap_avovit_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = avovit_superwrap_create;
  THIS->initialize = avovit_superwrap_init;
  THIS->update     = avovit_superwrap_update;
  THIS->oneset     = avovit_superwrap_oneset;
  THIS->twosets    = avovit_superwrap_twosets;
  THIS->wrapup     = avovit_superwrap_wrapup;
  THIS->delete     = avovit_superwrap_delete;
}




/*------------------------------- BUNCH -------------------------------*/
/*------------------------------- BUNCH -------------------------------*/
/*------------------------------- BUNCH -------------------------------*/


#ifdef NEED_UNDERSCORE
#define bunch_superwrap_create            bunch_superwrap_create_
#define bunch_superwrap_init              bunch_superwrap_init_
#define bunch_superwrap_update            bunch_superwrap_update_
#define bunch_superwrap_oneset            bunch_superwrap_oneset_ 
#define bunch_superwrap_twosets           bunch_superwrap_twosets_
#define bunch_superwrap_wrapup            bunch_superwrap_wrapup_
#define bunch_superwrap_delete            bunch_superwrap_delete_
#elif defined NEED_CAPITALS
#define bunch_superwrap_create            BUNCH_SUPERWRAP_CREATE
#define bunch_superwrap_init              BUNCH_SUPERWRAP_INIT
#define bunch_superwrap_update            BUNCH_SUPERWRAP_UPDATE
#define bunch_superwrap_oneset            BUNCH_SUPERWRAP_ONESET 
#define bunch_superwrap_twosets           BUNCH_SUPERWRAP_TWOSETS
#define bunch_superwrap_wrapup            BUNCH_SUPERWRAP_WRAPUP
#define bunch_superwrap_delete            BUNCH_SUPERWRAP_DELETE
#endif


ProcessCreate     bunch_superwrap_create;
ProcessInitialize bunch_superwrap_init;
ProcessUpdate     bunch_superwrap_update;
ProcessOneset     bunch_superwrap_oneset;
ProcessTwosets    bunch_superwrap_twosets;
ProcessWrapup     bunch_superwrap_wrapup;
ProcessDelete     bunch_superwrap_delete;


void superwrap_bunch_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = bunch_superwrap_create;
  THIS->initialize = bunch_superwrap_init;
  THIS->update     = bunch_superwrap_update;
  THIS->oneset     = bunch_superwrap_oneset;
  THIS->twosets    = bunch_superwrap_twosets;
  THIS->wrapup     = bunch_superwrap_wrapup;
  THIS->delete     = bunch_superwrap_delete;
}



/*------------------------------- C4WE -------------------------------*/
/*------------------------------- C4WE -------------------------------*/
/*------------------------------- C4WE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define c4we_superwrap_create            c4we_superwrap_create_
#define c4we_superwrap_init              c4we_superwrap_init_
#define c4we_superwrap_update            c4we_superwrap_update_
#define c4we_superwrap_oneset            c4we_superwrap_oneset_ 
#define c4we_superwrap_twosets           c4we_superwrap_twosets_
#define c4we_superwrap_wrapup            c4we_superwrap_wrapup_
#define c4we_superwrap_delete            c4we_superwrap_delete_
#elif defined NEED_CAPITALS
#define c4we_superwrap_create            C4WE_SUPERWRAP_CREATE
#define c4we_superwrap_init              C4WE_SUPERWRAP_INIT
#define c4we_superwrap_update            C4WE_SUPERWRAP_UPDATE
#define c4we_superwrap_oneset            C4WE_SUPERWRAP_ONESET 
#define c4we_superwrap_twosets           C4WE_SUPERWRAP_TWOSETS
#define c4we_superwrap_wrapup            C4WE_SUPERWRAP_WRAPUP
#define c4we_superwrap_delete            C4WE_SUPERWRAP_DELETE
#endif


ProcessCreate     c4we_superwrap_create;
ProcessInitialize c4we_superwrap_init;
ProcessUpdate     c4we_superwrap_update;
ProcessOneset     c4we_superwrap_oneset;
ProcessTwosets    c4we_superwrap_twosets;
ProcessWrapup     c4we_superwrap_wrapup;
ProcessDelete     c4we_superwrap_delete;


void superwrap_c4we_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = c4we_superwrap_create;
  THIS->initialize = c4we_superwrap_init;
  THIS->update     = c4we_superwrap_update;
  THIS->oneset     = c4we_superwrap_oneset;
  THIS->twosets    = c4we_superwrap_twosets;
  THIS->wrapup     = c4we_superwrap_wrapup;
  THIS->delete     = c4we_superwrap_delete;
}


/*------------------------------- CADZOW -------------------------------*/
/*------------------------------- CADZOW -------------------------------*/
/*------------------------------- CADZOW -------------------------------*/


#ifdef NEED_UNDERSCORE
#define cadzow_superwrap_create            cadzow_superwrap_create_
#define cadzow_superwrap_init              cadzow_superwrap_init_
#define cadzow_superwrap_update            cadzow_superwrap_update_
#define cadzow_superwrap_oneset            cadzow_superwrap_oneset_
#define cadzow_superwrap_twosets           cadzow_superwrap_twosets_
#define cadzow_superwrap_wrapup            cadzow_superwrap_wrapup_
#define cadzow_superwrap_delete            cadzow_superwrap_delete_
#elif defined NEED_CAPITALS
#define cadzow_superwrap_create            CADZOW_SUPERWRAP_CREATE
#define cadzow_superwrap_init              CADZOW_SUPERWRAP_INIT
#define cadzow_superwrap_update            CADZOW_SUPERWRAP_UPDATE
#define cadzow_superwrap_oneset            CADZOW_SUPERWRAP_ONESET
#define cadzow_superwrap_twosets           CADZOW_SUPERWRAP_TWOSETS
#define cadzow_superwrap_wrapup            CADZOW_SUPERWRAP_WRAPUP
#define cadzow_superwrap_delete            CADZOW_SUPERWRAP_DELETE
#endif


ProcessCreate     cadzow_superwrap_create;
ProcessInitialize cadzow_superwrap_init;
ProcessUpdate     cadzow_superwrap_update;
ProcessOneset     cadzow_superwrap_oneset;
ProcessTwosets    cadzow_superwrap_twosets;
ProcessWrapup     cadzow_superwrap_wrapup;
ProcessDelete     cadzow_superwrap_delete;


void superwrap_cadzow_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = cadzow_superwrap_create;
  THIS->initialize = cadzow_superwrap_init;
  THIS->update     = cadzow_superwrap_update;
  THIS->oneset     = cadzow_superwrap_oneset;
  THIS->twosets    = cadzow_superwrap_twosets;
  THIS->wrapup     = cadzow_superwrap_wrapup;
  THIS->delete     = cadzow_superwrap_delete;
}


/*------------------------------- CC3D -------------------------------*/
/*------------------------------- CC3D -------------------------------*/
/*------------------------------- CC3D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define cc3d_superwrap_create            cc3d_superwrap_create_
#define cc3d_superwrap_init              cc3d_superwrap_init_
#define cc3d_superwrap_update            cc3d_superwrap_update_
#define cc3d_superwrap_oneset            cc3d_superwrap_oneset_ 
#define cc3d_superwrap_twosets           cc3d_superwrap_twosets_
#define cc3d_superwrap_wrapup            cc3d_superwrap_wrapup_
#define cc3d_superwrap_delete            cc3d_superwrap_delete_
#elif defined NEED_CAPITALS
#define cc3d_superwrap_create            CC3D_SUPERWRAP_CREATE
#define cc3d_superwrap_init              CC3D_SUPERWRAP_INIT
#define cc3d_superwrap_update            CC3D_SUPERWRAP_UPDATE
#define cc3d_superwrap_oneset            CC3D_SUPERWRAP_ONESET 
#define cc3d_superwrap_twosets           CC3D_SUPERWRAP_TWOSETS
#define cc3d_superwrap_wrapup            CC3D_SUPERWRAP_WRAPUP
#define cc3d_superwrap_delete            CC3D_SUPERWRAP_DELETE
#endif


ProcessCreate     cc3d_superwrap_create;
ProcessInitialize cc3d_superwrap_init;
ProcessUpdate     cc3d_superwrap_update;
ProcessOneset     cc3d_superwrap_oneset;
ProcessTwosets    cc3d_superwrap_twosets;
ProcessWrapup     cc3d_superwrap_wrapup;
ProcessDelete     cc3d_superwrap_delete;


void superwrap_cc3d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = cc3d_superwrap_create;
  THIS->initialize = cc3d_superwrap_init;
  THIS->update     = cc3d_superwrap_update;
  THIS->oneset     = cc3d_superwrap_oneset;
  THIS->twosets    = cc3d_superwrap_twosets;
  THIS->wrapup     = cc3d_superwrap_wrapup;
  THIS->delete     = cc3d_superwrap_delete;
}



/*------------------------------- CFDS -------------------------------*/
/*------------------------------- CFDS -------------------------------*/
/*------------------------------- CFDS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define cfds_superwrap_create            cfds_superwrap_create_
#define cfds_superwrap_init              cfds_superwrap_init_
#define cfds_superwrap_update            cfds_superwrap_update_
#define cfds_superwrap_oneset            cfds_superwrap_oneset_ 
#define cfds_superwrap_twosets           cfds_superwrap_twosets_
#define cfds_superwrap_wrapup            cfds_superwrap_wrapup_
#define cfds_superwrap_delete            cfds_superwrap_delete_
#elif defined NEED_CAPITALS
#define cfds_superwrap_create            CFDS_SUPERWRAP_CREATE
#define cfds_superwrap_init              CFDS_SUPERWRAP_INIT
#define cfds_superwrap_update            CFDS_SUPERWRAP_UPDATE
#define cfds_superwrap_oneset            CFDS_SUPERWRAP_ONESET 
#define cfds_superwrap_twosets           CFDS_SUPERWRAP_TWOSETS
#define cfds_superwrap_wrapup            CFDS_SUPERWRAP_WRAPUP
#define cfds_superwrap_delete            CFDS_SUPERWRAP_DELETE
#endif


ProcessCreate     cfds_superwrap_create;
ProcessInitialize cfds_superwrap_init;
ProcessUpdate     cfds_superwrap_update;
ProcessOneset     cfds_superwrap_oneset;
ProcessTwosets    cfds_superwrap_twosets;
ProcessWrapup     cfds_superwrap_wrapup;
ProcessDelete     cfds_superwrap_delete;


void superwrap_cfds_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = cfds_superwrap_create;
  THIS->initialize = cfds_superwrap_init;
  THIS->update     = cfds_superwrap_update;
  THIS->oneset     = cfds_superwrap_oneset;
  THIS->twosets    = cfds_superwrap_twosets;
  THIS->wrapup     = cfds_superwrap_wrapup;
  THIS->delete     = cfds_superwrap_delete;
}



/*------------------------------- CHART -------------------------------*/
/*------------------------------- CHART -------------------------------*/
/*------------------------------- CHART -------------------------------*/


#ifdef NEED_UNDERSCORE
#define chart_superwrap_create            chart_superwrap_create_
#define chart_superwrap_init              chart_superwrap_init_
#define chart_superwrap_update            chart_superwrap_update_
#define chart_superwrap_oneset            chart_superwrap_oneset_ 
#define chart_superwrap_twosets           chart_superwrap_twosets_
#define chart_superwrap_wrapup            chart_superwrap_wrapup_
#define chart_superwrap_delete            chart_superwrap_delete_
#elif defined NEED_CAPITALS
#define chart_superwrap_create            CHART_SUPERWRAP_CREATE
#define chart_superwrap_init              CHART_SUPERWRAP_INIT
#define chart_superwrap_update            CHART_SUPERWRAP_UPDATE
#define chart_superwrap_oneset            CHART_SUPERWRAP_ONESET 
#define chart_superwrap_twosets           CHART_SUPERWRAP_TWOSETS
#define chart_superwrap_wrapup            CHART_SUPERWRAP_WRAPUP
#define chart_superwrap_delete            CHART_SUPERWRAP_DELETE
#endif


ProcessCreate     chart_superwrap_create;
ProcessInitialize chart_superwrap_init;
ProcessUpdate     chart_superwrap_update;
ProcessOneset     chart_superwrap_oneset;
ProcessTwosets    chart_superwrap_twosets;
ProcessWrapup     chart_superwrap_wrapup;
ProcessDelete     chart_superwrap_delete;


void superwrap_chart_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = chart_superwrap_create;
  THIS->initialize = chart_superwrap_init;
  THIS->update     = chart_superwrap_update;
  THIS->oneset     = chart_superwrap_oneset;
  THIS->twosets    = chart_superwrap_twosets;
  THIS->wrapup     = chart_superwrap_wrapup;
  THIS->delete     = chart_superwrap_delete;
}



/*------------------------------- CLEANUP -------------------------------*/
/*------------------------------- CLEANUP -------------------------------*/
/*------------------------------- CLEANUP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define cleanup_superwrap_create            cleanup_superwrap_create_
#define cleanup_superwrap_init              cleanup_superwrap_init_
#define cleanup_superwrap_update            cleanup_superwrap_update_
#define cleanup_superwrap_oneset            cleanup_superwrap_oneset_ 
#define cleanup_superwrap_twosets           cleanup_superwrap_twosets_
#define cleanup_superwrap_wrapup            cleanup_superwrap_wrapup_
#define cleanup_superwrap_delete            cleanup_superwrap_delete_
#elif defined NEED_CAPITALS
#define cleanup_superwrap_create            CLEANUP_SUPERWRAP_CREATE
#define cleanup_superwrap_init              CLEANUP_SUPERWRAP_INIT
#define cleanup_superwrap_update            CLEANUP_SUPERWRAP_UPDATE
#define cleanup_superwrap_oneset            CLEANUP_SUPERWRAP_ONESET 
#define cleanup_superwrap_twosets           CLEANUP_SUPERWRAP_TWOSETS
#define cleanup_superwrap_wrapup            CLEANUP_SUPERWRAP_WRAPUP
#define cleanup_superwrap_delete            CLEANUP_SUPERWRAP_DELETE
#endif


ProcessCreate     cleanup_superwrap_create;
ProcessInitialize cleanup_superwrap_init;
ProcessUpdate     cleanup_superwrap_update;
ProcessOneset     cleanup_superwrap_oneset;
ProcessTwosets    cleanup_superwrap_twosets;
ProcessWrapup     cleanup_superwrap_wrapup;
ProcessDelete     cleanup_superwrap_delete;


void superwrap_cleanup_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = cleanup_superwrap_create;
  THIS->initialize = cleanup_superwrap_init;
  THIS->update     = cleanup_superwrap_update;
  THIS->oneset     = cleanup_superwrap_oneset;
  THIS->twosets    = cleanup_superwrap_twosets;
  THIS->wrapup     = cleanup_superwrap_wrapup;
  THIS->delete     = cleanup_superwrap_delete;
}



/*------------------------------- CLIP -------------------------------*/
/*------------------------------- CLIP -------------------------------*/
/*------------------------------- CLIP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define clip_superwrap_create            clip_superwrap_create_
#define clip_superwrap_init              clip_superwrap_init_
#define clip_superwrap_update            clip_superwrap_update_
#define clip_superwrap_oneset            clip_superwrap_oneset_ 
#define clip_superwrap_twosets           clip_superwrap_twosets_
#define clip_superwrap_wrapup            clip_superwrap_wrapup_
#define clip_superwrap_delete            clip_superwrap_delete_
#elif defined NEED_CAPITALS
#define clip_superwrap_create            CLIP_SUPERWRAP_CREATE
#define clip_superwrap_init              CLIP_SUPERWRAP_INIT
#define clip_superwrap_update            CLIP_SUPERWRAP_UPDATE
#define clip_superwrap_oneset            CLIP_SUPERWRAP_ONESET 
#define clip_superwrap_twosets           CLIP_SUPERWRAP_TWOSETS
#define clip_superwrap_wrapup            CLIP_SUPERWRAP_WRAPUP
#define clip_superwrap_delete            CLIP_SUPERWRAP_DELETE
#endif


ProcessCreate     clip_superwrap_create;
ProcessInitialize clip_superwrap_init;
ProcessUpdate     clip_superwrap_update;
ProcessOneset     clip_superwrap_oneset;
ProcessTwosets    clip_superwrap_twosets;
ProcessWrapup     clip_superwrap_wrapup;
ProcessDelete     clip_superwrap_delete;


void superwrap_clip_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = clip_superwrap_create;
  THIS->initialize = clip_superwrap_init;
  THIS->update     = clip_superwrap_update;
  THIS->oneset     = clip_superwrap_oneset;
  THIS->twosets    = clip_superwrap_twosets;
  THIS->wrapup     = clip_superwrap_wrapup;
  THIS->delete     = clip_superwrap_delete;
}



/*------------------------------- CNEARTS -------------------------------*/
/*------------------------------- CNEARTS -------------------------------*/
/*------------------------------- CNEARTS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define cnearts_superwrap_create            cnearts_superwrap_create_
#define cnearts_superwrap_init              cnearts_superwrap_init_
#define cnearts_superwrap_update            cnearts_superwrap_update_
#define cnearts_superwrap_oneset            cnearts_superwrap_oneset_ 
#define cnearts_superwrap_twosets           cnearts_superwrap_twosets_
#define cnearts_superwrap_wrapup            cnearts_superwrap_wrapup_
#define cnearts_superwrap_delete            cnearts_superwrap_delete_
#elif defined NEED_CAPITALS
#define cnearts_superwrap_create            CNEARTS_SUPERWRAP_CREATE
#define cnearts_superwrap_init              CNEARTS_SUPERWRAP_INIT
#define cnearts_superwrap_update            CNEARTS_SUPERWRAP_UPDATE
#define cnearts_superwrap_oneset            CNEARTS_SUPERWRAP_ONESET 
#define cnearts_superwrap_twosets           CNEARTS_SUPERWRAP_TWOSETS
#define cnearts_superwrap_wrapup            CNEARTS_SUPERWRAP_WRAPUP
#define cnearts_superwrap_delete            CNEARTS_SUPERWRAP_DELETE
#endif


ProcessCreate     cnearts_superwrap_create;
ProcessInitialize cnearts_superwrap_init;
ProcessUpdate     cnearts_superwrap_update;
ProcessOneset     cnearts_superwrap_oneset;
ProcessTwosets    cnearts_superwrap_twosets;
ProcessWrapup     cnearts_superwrap_wrapup;
ProcessDelete     cnearts_superwrap_delete;


void superwrap_cnearts_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = cnearts_superwrap_create;
  THIS->initialize = cnearts_superwrap_init;
  THIS->update     = cnearts_superwrap_update;
  THIS->oneset     = cnearts_superwrap_oneset;
  THIS->twosets    = cnearts_superwrap_twosets;
  THIS->wrapup     = cnearts_superwrap_wrapup;
  THIS->delete     = cnearts_superwrap_delete;
}



/*------------------------------- CODMO -------------------------------*/
/*------------------------------- CODMO -------------------------------*/
/*------------------------------- CODMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define codmo_superwrap_create            codmo_superwrap_create_
#define codmo_superwrap_init              codmo_superwrap_init_
#define codmo_superwrap_update            codmo_superwrap_update_
#define codmo_superwrap_oneset            codmo_superwrap_oneset_ 
#define codmo_superwrap_twosets           codmo_superwrap_twosets_
#define codmo_superwrap_wrapup            codmo_superwrap_wrapup_
#define codmo_superwrap_delete            codmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define codmo_superwrap_create            CODMO_SUPERWRAP_CREATE
#define codmo_superwrap_init              CODMO_SUPERWRAP_INIT
#define codmo_superwrap_update            CODMO_SUPERWRAP_UPDATE
#define codmo_superwrap_oneset            CODMO_SUPERWRAP_ONESET 
#define codmo_superwrap_twosets           CODMO_SUPERWRAP_TWOSETS
#define codmo_superwrap_wrapup            CODMO_SUPERWRAP_WRAPUP
#define codmo_superwrap_delete            CODMO_SUPERWRAP_DELETE
#endif


ProcessCreate     codmo_superwrap_create;
ProcessInitialize codmo_superwrap_init;
ProcessUpdate     codmo_superwrap_update;
ProcessOneset     codmo_superwrap_oneset;
ProcessTwosets    codmo_superwrap_twosets;
ProcessWrapup     codmo_superwrap_wrapup;
ProcessDelete     codmo_superwrap_delete;


void superwrap_codmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = codmo_superwrap_create;
  THIS->initialize = codmo_superwrap_init;
  THIS->update     = codmo_superwrap_update;
  THIS->oneset     = codmo_superwrap_oneset;
  THIS->twosets    = codmo_superwrap_twosets;
  THIS->wrapup     = codmo_superwrap_wrapup;
  THIS->delete     = codmo_superwrap_delete;
}



/*------------------------------- COLOR -------------------------------*/
/*------------------------------- COLOR -------------------------------*/
/*------------------------------- COLOR -------------------------------*/


#ifdef NEED_UNDERSCORE
#define color_superwrap_create            color_superwrap_create_
#define color_superwrap_init              color_superwrap_init_
#define color_superwrap_update            color_superwrap_update_
#define color_superwrap_oneset            color_superwrap_oneset_ 
#define color_superwrap_twosets           color_superwrap_twosets_
#define color_superwrap_wrapup            color_superwrap_wrapup_
#define color_superwrap_delete            color_superwrap_delete_
#elif defined NEED_CAPITALS
#define color_superwrap_create            COLOR_SUPERWRAP_CREATE
#define color_superwrap_init              COLOR_SUPERWRAP_INIT
#define color_superwrap_update            COLOR_SUPERWRAP_UPDATE
#define color_superwrap_oneset            COLOR_SUPERWRAP_ONESET 
#define color_superwrap_twosets           COLOR_SUPERWRAP_TWOSETS
#define color_superwrap_wrapup            COLOR_SUPERWRAP_WRAPUP
#define color_superwrap_delete            COLOR_SUPERWRAP_DELETE
#endif


ProcessCreate     color_superwrap_create;
ProcessInitialize color_superwrap_init;
ProcessUpdate     color_superwrap_update;
ProcessOneset     color_superwrap_oneset;
ProcessTwosets    color_superwrap_twosets;
ProcessWrapup     color_superwrap_wrapup;
ProcessDelete     color_superwrap_delete;


void superwrap_color_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = color_superwrap_create;
  THIS->initialize = color_superwrap_init;
  THIS->update     = color_superwrap_update;
  THIS->oneset     = color_superwrap_oneset;
  THIS->twosets    = color_superwrap_twosets;
  THIS->wrapup     = color_superwrap_wrapup;
  THIS->delete     = color_superwrap_delete;
}



/*------------------------------- COMBINE -------------------------------*/
/*------------------------------- COMBINE -------------------------------*/
/*------------------------------- COMBINE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define combine_superwrap_create            combine_superwrap_create_
#define combine_superwrap_init              combine_superwrap_init_
#define combine_superwrap_update            combine_superwrap_update_
#define combine_superwrap_oneset            combine_superwrap_oneset_ 
#define combine_superwrap_twosets           combine_superwrap_twosets_
#define combine_superwrap_wrapup            combine_superwrap_wrapup_
#define combine_superwrap_delete            combine_superwrap_delete_
#elif defined NEED_CAPITALS
#define combine_superwrap_create            COMBINE_SUPERWRAP_CREATE
#define combine_superwrap_init              COMBINE_SUPERWRAP_INIT
#define combine_superwrap_update            COMBINE_SUPERWRAP_UPDATE
#define combine_superwrap_oneset            COMBINE_SUPERWRAP_ONESET 
#define combine_superwrap_twosets           COMBINE_SUPERWRAP_TWOSETS
#define combine_superwrap_wrapup            COMBINE_SUPERWRAP_WRAPUP
#define combine_superwrap_delete            COMBINE_SUPERWRAP_DELETE
#endif


ProcessCreate     combine_superwrap_create;
ProcessInitialize combine_superwrap_init;
ProcessUpdate     combine_superwrap_update;
ProcessOneset     combine_superwrap_oneset;
ProcessTwosets    combine_superwrap_twosets;
ProcessWrapup     combine_superwrap_wrapup;
ProcessDelete     combine_superwrap_delete;


void superwrap_combine_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = combine_superwrap_create;
  THIS->initialize = combine_superwrap_init;
  THIS->update     = combine_superwrap_update;
  THIS->oneset     = combine_superwrap_oneset;
  THIS->twosets    = combine_superwrap_twosets;
  THIS->wrapup     = combine_superwrap_wrapup;
  THIS->delete     = combine_superwrap_delete;
}



/*------------------------------- COMP -------------------------------*/
/*------------------------------- COMP -------------------------------*/
/*------------------------------- COMP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define comp_superwrap_create            comp_superwrap_create_
#define comp_superwrap_init              comp_superwrap_init_
#define comp_superwrap_update            comp_superwrap_update_
#define comp_superwrap_oneset            comp_superwrap_oneset_ 
#define comp_superwrap_twosets           comp_superwrap_twosets_
#define comp_superwrap_wrapup            comp_superwrap_wrapup_
#define comp_superwrap_delete            comp_superwrap_delete_
#elif defined NEED_CAPITALS
#define comp_superwrap_create            COMP_SUPERWRAP_CREATE
#define comp_superwrap_init              COMP_SUPERWRAP_INIT
#define comp_superwrap_update            COMP_SUPERWRAP_UPDATE
#define comp_superwrap_oneset            COMP_SUPERWRAP_ONESET 
#define comp_superwrap_twosets           COMP_SUPERWRAP_TWOSETS
#define comp_superwrap_wrapup            COMP_SUPERWRAP_WRAPUP
#define comp_superwrap_delete            COMP_SUPERWRAP_DELETE
#endif


ProcessCreate     comp_superwrap_create;
ProcessInitialize comp_superwrap_init;
ProcessUpdate     comp_superwrap_update;
ProcessOneset     comp_superwrap_oneset;
ProcessTwosets    comp_superwrap_twosets;
ProcessWrapup     comp_superwrap_wrapup;
ProcessDelete     comp_superwrap_delete;


void superwrap_comp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = comp_superwrap_create;
  THIS->initialize = comp_superwrap_init;
  THIS->update     = comp_superwrap_update;
  THIS->oneset     = comp_superwrap_oneset;
  THIS->twosets    = comp_superwrap_twosets;
  THIS->wrapup     = comp_superwrap_wrapup;
  THIS->delete     = comp_superwrap_delete;
}



/*------------------------------- CTAN -------------------------------*/
/*------------------------------- CTAN -------------------------------*/
/*------------------------------- CTAN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ctan_superwrap_create            ctan_superwrap_create_
#define ctan_superwrap_init              ctan_superwrap_init_
#define ctan_superwrap_update            ctan_superwrap_update_
#define ctan_superwrap_oneset            ctan_superwrap_oneset_ 
#define ctan_superwrap_twosets           ctan_superwrap_twosets_
#define ctan_superwrap_wrapup            ctan_superwrap_wrapup_
#define ctan_superwrap_delete            ctan_superwrap_delete_
#elif defined NEED_CAPITALS
#define ctan_superwrap_create            CTAN_SUPERWRAP_CREATE
#define ctan_superwrap_init              CTAN_SUPERWRAP_INIT
#define ctan_superwrap_update            CTAN_SUPERWRAP_UPDATE
#define ctan_superwrap_oneset            CTAN_SUPERWRAP_ONESET 
#define ctan_superwrap_twosets           CTAN_SUPERWRAP_TWOSETS
#define ctan_superwrap_wrapup            CTAN_SUPERWRAP_WRAPUP
#define ctan_superwrap_delete            CTAN_SUPERWRAP_DELETE
#endif


ProcessCreate     ctan_superwrap_create;
ProcessInitialize ctan_superwrap_init;
ProcessUpdate     ctan_superwrap_update;
ProcessOneset     ctan_superwrap_oneset;
ProcessTwosets    ctan_superwrap_twosets;
ProcessWrapup     ctan_superwrap_wrapup;
ProcessDelete     ctan_superwrap_delete;


void superwrap_ctan_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ctan_superwrap_create;
  THIS->initialize = ctan_superwrap_init;
  THIS->update     = ctan_superwrap_update;
  THIS->oneset     = ctan_superwrap_oneset;
  THIS->twosets    = ctan_superwrap_twosets;
  THIS->wrapup     = ctan_superwrap_wrapup;
  THIS->delete     = ctan_superwrap_delete;
}



/*------------------------------- DABRA -------------------------------*/
/*------------------------------- DABRA -------------------------------*/
/*------------------------------- DABRA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dabra_superwrap_create            dabra_superwrap_create_
#define dabra_superwrap_init              dabra_superwrap_init_
#define dabra_superwrap_update            dabra_superwrap_update_
#define dabra_superwrap_oneset            dabra_superwrap_oneset_ 
#define dabra_superwrap_twosets           dabra_superwrap_twosets_
#define dabra_superwrap_wrapup            dabra_superwrap_wrapup_
#define dabra_superwrap_delete            dabra_superwrap_delete_
#elif defined NEED_CAPITALS
#define dabra_superwrap_create            DABRA_SUPERWRAP_CREATE
#define dabra_superwrap_init              DABRA_SUPERWRAP_INIT
#define dabra_superwrap_update            DABRA_SUPERWRAP_UPDATE
#define dabra_superwrap_oneset            DABRA_SUPERWRAP_ONESET 
#define dabra_superwrap_twosets           DABRA_SUPERWRAP_TWOSETS
#define dabra_superwrap_wrapup            DABRA_SUPERWRAP_WRAPUP
#define dabra_superwrap_delete            DABRA_SUPERWRAP_DELETE
#endif


ProcessCreate     dabra_superwrap_create;
ProcessInitialize dabra_superwrap_init;
ProcessUpdate     dabra_superwrap_update;
ProcessOneset     dabra_superwrap_oneset;
ProcessTwosets    dabra_superwrap_twosets;
ProcessWrapup     dabra_superwrap_wrapup;
ProcessDelete     dabra_superwrap_delete;


void superwrap_dabra_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dabra_superwrap_create;
  THIS->initialize = dabra_superwrap_init;
  THIS->update     = dabra_superwrap_update;
  THIS->oneset     = dabra_superwrap_oneset;
  THIS->twosets    = dabra_superwrap_twosets;
  THIS->wrapup     = dabra_superwrap_wrapup;
  THIS->delete     = dabra_superwrap_delete;
}



/*------------------------------- DBGAIN -------------------------------*/
/*------------------------------- DBGAIN -------------------------------*/
/*------------------------------- DBGAIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dbgain_superwrap_create            dbgain_superwrap_create_
#define dbgain_superwrap_init              dbgain_superwrap_init_
#define dbgain_superwrap_update            dbgain_superwrap_update_
#define dbgain_superwrap_oneset            dbgain_superwrap_oneset_ 
#define dbgain_superwrap_twosets           dbgain_superwrap_twosets_
#define dbgain_superwrap_wrapup            dbgain_superwrap_wrapup_
#define dbgain_superwrap_delete            dbgain_superwrap_delete_
#elif defined NEED_CAPITALS
#define dbgain_superwrap_create            DBGAIN_SUPERWRAP_CREATE
#define dbgain_superwrap_init              DBGAIN_SUPERWRAP_INIT
#define dbgain_superwrap_update            DBGAIN_SUPERWRAP_UPDATE
#define dbgain_superwrap_oneset            DBGAIN_SUPERWRAP_ONESET 
#define dbgain_superwrap_twosets           DBGAIN_SUPERWRAP_TWOSETS
#define dbgain_superwrap_wrapup            DBGAIN_SUPERWRAP_WRAPUP
#define dbgain_superwrap_delete            DBGAIN_SUPERWRAP_DELETE
#endif


ProcessCreate     dbgain_superwrap_create;
ProcessInitialize dbgain_superwrap_init;
ProcessUpdate     dbgain_superwrap_update;
ProcessOneset     dbgain_superwrap_oneset;
ProcessTwosets    dbgain_superwrap_twosets;
ProcessWrapup     dbgain_superwrap_wrapup;
ProcessDelete     dbgain_superwrap_delete;


void superwrap_dbgain_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dbgain_superwrap_create;
  THIS->initialize = dbgain_superwrap_init;
  THIS->update     = dbgain_superwrap_update;
  THIS->oneset     = dbgain_superwrap_oneset;
  THIS->twosets    = dbgain_superwrap_twosets;
  THIS->wrapup     = dbgain_superwrap_wrapup;
  THIS->delete     = dbgain_superwrap_delete;
}



/*------------------------------- DECON -------------------------------*/
/*------------------------------- DECON -------------------------------*/
/*------------------------------- DECON -------------------------------*/


#ifdef NEED_UNDERSCORE
#define decon_superwrap_create            decon_superwrap_create_
#define decon_superwrap_init              decon_superwrap_init_
#define decon_superwrap_update            decon_superwrap_update_
#define decon_superwrap_oneset            decon_superwrap_oneset_ 
#define decon_superwrap_twosets           decon_superwrap_twosets_
#define decon_superwrap_wrapup            decon_superwrap_wrapup_
#define decon_superwrap_delete            decon_superwrap_delete_
#elif defined NEED_CAPITALS
#define decon_superwrap_create            DECON_SUPERWRAP_CREATE
#define decon_superwrap_init              DECON_SUPERWRAP_INIT
#define decon_superwrap_update            DECON_SUPERWRAP_UPDATE
#define decon_superwrap_oneset            DECON_SUPERWRAP_ONESET 
#define decon_superwrap_twosets           DECON_SUPERWRAP_TWOSETS
#define decon_superwrap_wrapup            DECON_SUPERWRAP_WRAPUP
#define decon_superwrap_delete            DECON_SUPERWRAP_DELETE
#endif


ProcessCreate     decon_superwrap_create;
ProcessInitialize decon_superwrap_init;
ProcessUpdate     decon_superwrap_update;
ProcessOneset     decon_superwrap_oneset;
ProcessTwosets    decon_superwrap_twosets;
ProcessWrapup     decon_superwrap_wrapup;
ProcessDelete     decon_superwrap_delete;


void superwrap_decon_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = decon_superwrap_create;
  THIS->initialize = decon_superwrap_init;
  THIS->update     = decon_superwrap_update;
  THIS->oneset     = decon_superwrap_oneset;
  THIS->twosets    = decon_superwrap_twosets;
  THIS->wrapup     = decon_superwrap_wrapup;
  THIS->delete     = decon_superwrap_delete;
}



/*------------------------------- DIST -------------------------------*/
/*------------------------------- DIST -------------------------------*/
/*------------------------------- DIST -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dist_superwrap_create            dist_superwrap_create_
#define dist_superwrap_init              dist_superwrap_init_
#define dist_superwrap_update            dist_superwrap_update_
#define dist_superwrap_oneset            dist_superwrap_oneset_ 
#define dist_superwrap_twosets           dist_superwrap_twosets_
#define dist_superwrap_wrapup            dist_superwrap_wrapup_
#define dist_superwrap_delete            dist_superwrap_delete_
#elif defined NEED_CAPITALS
#define dist_superwrap_create            DIST_SUPERWRAP_CREATE
#define dist_superwrap_init              DIST_SUPERWRAP_INIT
#define dist_superwrap_update            DIST_SUPERWRAP_UPDATE
#define dist_superwrap_oneset            DIST_SUPERWRAP_ONESET 
#define dist_superwrap_twosets           DIST_SUPERWRAP_TWOSETS
#define dist_superwrap_wrapup            DIST_SUPERWRAP_WRAPUP
#define dist_superwrap_delete            DIST_SUPERWRAP_DELETE
#endif


ProcessCreate     dist_superwrap_create;
ProcessInitialize dist_superwrap_init;
ProcessUpdate     dist_superwrap_update;
ProcessOneset     dist_superwrap_oneset;
ProcessTwosets    dist_superwrap_twosets;
ProcessWrapup     dist_superwrap_wrapup;
ProcessDelete     dist_superwrap_delete;


void superwrap_dist_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dist_superwrap_create;
  THIS->initialize = dist_superwrap_init;
  THIS->update     = dist_superwrap_update;
  THIS->oneset     = dist_superwrap_oneset;
  THIS->twosets    = dist_superwrap_twosets;
  THIS->wrapup     = dist_superwrap_wrapup;
  THIS->delete     = dist_superwrap_delete;
}



/*------------------------------- DMAP3D -------------------------------*/
/*------------------------------- DMAP3D -------------------------------*/
/*------------------------------- DMAP3D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dmap3d_superwrap_create            dmap3d_superwrap_create_
#define dmap3d_superwrap_init              dmap3d_superwrap_init_
#define dmap3d_superwrap_update            dmap3d_superwrap_update_
#define dmap3d_superwrap_oneset            dmap3d_superwrap_oneset_ 
#define dmap3d_superwrap_twosets           dmap3d_superwrap_twosets_
#define dmap3d_superwrap_wrapup            dmap3d_superwrap_wrapup_
#define dmap3d_superwrap_delete            dmap3d_superwrap_delete_
#elif defined NEED_CAPITALS
#define dmap3d_superwrap_create            DMAP3D_SUPERWRAP_CREATE
#define dmap3d_superwrap_init              DMAP3D_SUPERWRAP_INIT
#define dmap3d_superwrap_update            DMAP3D_SUPERWRAP_UPDATE
#define dmap3d_superwrap_oneset            DMAP3D_SUPERWRAP_ONESET 
#define dmap3d_superwrap_twosets           DMAP3D_SUPERWRAP_TWOSETS
#define dmap3d_superwrap_wrapup            DMAP3D_SUPERWRAP_WRAPUP
#define dmap3d_superwrap_delete            DMAP3D_SUPERWRAP_DELETE
#endif


ProcessCreate     dmap3d_superwrap_create;
ProcessInitialize dmap3d_superwrap_init;
ProcessUpdate     dmap3d_superwrap_update;
ProcessOneset     dmap3d_superwrap_oneset;
ProcessTwosets    dmap3d_superwrap_twosets;
ProcessWrapup     dmap3d_superwrap_wrapup;
ProcessDelete     dmap3d_superwrap_delete;


void superwrap_dmap3d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dmap3d_superwrap_create;
  THIS->initialize = dmap3d_superwrap_init;
  THIS->update     = dmap3d_superwrap_update;
  THIS->oneset     = dmap3d_superwrap_oneset;
  THIS->twosets    = dmap3d_superwrap_twosets;
  THIS->wrapup     = dmap3d_superwrap_wrapup;
  THIS->delete     = dmap3d_superwrap_delete;
}



/*------------------------------- DMO3D -------------------------------*/
/*------------------------------- DMO3D -------------------------------*/
/*------------------------------- DMO3D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dmo3d_superwrap_create            dmo3d_superwrap_create_
#define dmo3d_superwrap_init              dmo3d_superwrap_init_
#define dmo3d_superwrap_update            dmo3d_superwrap_update_
#define dmo3d_superwrap_oneset            dmo3d_superwrap_oneset_ 
#define dmo3d_superwrap_twosets           dmo3d_superwrap_twosets_
#define dmo3d_superwrap_wrapup            dmo3d_superwrap_wrapup_
#define dmo3d_superwrap_delete            dmo3d_superwrap_delete_
#elif defined NEED_CAPITALS
#define dmo3d_superwrap_create            DMO3D_SUPERWRAP_CREATE
#define dmo3d_superwrap_init              DMO3D_SUPERWRAP_INIT
#define dmo3d_superwrap_update            DMO3D_SUPERWRAP_UPDATE
#define dmo3d_superwrap_oneset            DMO3D_SUPERWRAP_ONESET 
#define dmo3d_superwrap_twosets           DMO3D_SUPERWRAP_TWOSETS
#define dmo3d_superwrap_wrapup            DMO3D_SUPERWRAP_WRAPUP
#define dmo3d_superwrap_delete            DMO3D_SUPERWRAP_DELETE
#endif


ProcessCreate     dmo3d_superwrap_create;
ProcessInitialize dmo3d_superwrap_init;
ProcessUpdate     dmo3d_superwrap_update;
ProcessOneset     dmo3d_superwrap_oneset;
ProcessTwosets    dmo3d_superwrap_twosets;
ProcessWrapup     dmo3d_superwrap_wrapup;
ProcessDelete     dmo3d_superwrap_delete;


void superwrap_dmo3d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dmo3d_superwrap_create;
  THIS->initialize = dmo3d_superwrap_init;
  THIS->update     = dmo3d_superwrap_update;
  THIS->oneset     = dmo3d_superwrap_oneset;
  THIS->twosets    = dmo3d_superwrap_twosets;
  THIS->wrapup     = dmo3d_superwrap_wrapup;
  THIS->delete     = dmo3d_superwrap_delete;
}



/*------------------------------- DMOPREP -------------------------------*/
/*------------------------------- DMOPREP -------------------------------*/
/*------------------------------- DMOPREP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dmoprep_superwrap_create            dmoprep_superwrap_create_
#define dmoprep_superwrap_init              dmoprep_superwrap_init_
#define dmoprep_superwrap_update            dmoprep_superwrap_update_
#define dmoprep_superwrap_oneset            dmoprep_superwrap_oneset_ 
#define dmoprep_superwrap_twosets           dmoprep_superwrap_twosets_
#define dmoprep_superwrap_wrapup            dmoprep_superwrap_wrapup_
#define dmoprep_superwrap_delete            dmoprep_superwrap_delete_
#elif defined NEED_CAPITALS
#define dmoprep_superwrap_create            DMOPREP_SUPERWRAP_CREATE
#define dmoprep_superwrap_init              DMOPREP_SUPERWRAP_INIT
#define dmoprep_superwrap_update            DMOPREP_SUPERWRAP_UPDATE
#define dmoprep_superwrap_oneset            DMOPREP_SUPERWRAP_ONESET 
#define dmoprep_superwrap_twosets           DMOPREP_SUPERWRAP_TWOSETS
#define dmoprep_superwrap_wrapup            DMOPREP_SUPERWRAP_WRAPUP
#define dmoprep_superwrap_delete            DMOPREP_SUPERWRAP_DELETE
#endif


ProcessCreate     dmoprep_superwrap_create;
ProcessInitialize dmoprep_superwrap_init;
ProcessUpdate     dmoprep_superwrap_update;
ProcessOneset     dmoprep_superwrap_oneset;
ProcessTwosets    dmoprep_superwrap_twosets;
ProcessWrapup     dmoprep_superwrap_wrapup;
ProcessDelete     dmoprep_superwrap_delete;


void superwrap_dmoprep_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dmoprep_superwrap_create;
  THIS->initialize = dmoprep_superwrap_init;
  THIS->update     = dmoprep_superwrap_update;
  THIS->oneset     = dmoprep_superwrap_oneset;
  THIS->twosets    = dmoprep_superwrap_twosets;
  THIS->wrapup     = dmoprep_superwrap_wrapup;
  THIS->delete     = dmoprep_superwrap_delete;
}



/*------------------------------- DRC -------------------------------*/
/*------------------------------- DRC -------------------------------*/
/*------------------------------- DRC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define drc_superwrap_create            drc_superwrap_create_
#define drc_superwrap_init              drc_superwrap_init_
#define drc_superwrap_update            drc_superwrap_update_
#define drc_superwrap_oneset            drc_superwrap_oneset_ 
#define drc_superwrap_twosets           drc_superwrap_twosets_
#define drc_superwrap_wrapup            drc_superwrap_wrapup_
#define drc_superwrap_delete            drc_superwrap_delete_
#elif defined NEED_CAPITALS
#define drc_superwrap_create            DRC_SUPERWRAP_CREATE
#define drc_superwrap_init              DRC_SUPERWRAP_INIT
#define drc_superwrap_update            DRC_SUPERWRAP_UPDATE
#define drc_superwrap_oneset            DRC_SUPERWRAP_ONESET 
#define drc_superwrap_twosets           DRC_SUPERWRAP_TWOSETS
#define drc_superwrap_wrapup            DRC_SUPERWRAP_WRAPUP
#define drc_superwrap_delete            DRC_SUPERWRAP_DELETE
#endif


ProcessCreate     drc_superwrap_create;
ProcessInitialize drc_superwrap_init;
ProcessUpdate     drc_superwrap_update;
ProcessOneset     drc_superwrap_oneset;
ProcessTwosets    drc_superwrap_twosets;
ProcessWrapup     drc_superwrap_wrapup;
ProcessDelete     drc_superwrap_delete;


void superwrap_drc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = drc_superwrap_create;
  THIS->initialize = drc_superwrap_init;
  THIS->update     = drc_superwrap_update;
  THIS->oneset     = drc_superwrap_oneset;
  THIS->twosets    = drc_superwrap_twosets;
  THIS->wrapup     = drc_superwrap_wrapup;
  THIS->delete     = drc_superwrap_delete;
}



/*------------------------------- DSIG -------------------------------*/
/*------------------------------- DSIG -------------------------------*/
/*------------------------------- DSIG -------------------------------*/


#ifdef NEED_UNDERSCORE
#define dsig_superwrap_create            dsig_superwrap_create_
#define dsig_superwrap_init              dsig_superwrap_init_
#define dsig_superwrap_update            dsig_superwrap_update_
#define dsig_superwrap_oneset            dsig_superwrap_oneset_ 
#define dsig_superwrap_twosets           dsig_superwrap_twosets_
#define dsig_superwrap_wrapup            dsig_superwrap_wrapup_
#define dsig_superwrap_delete            dsig_superwrap_delete_
#elif defined NEED_CAPITALS
#define dsig_superwrap_create            DSIG_SUPERWRAP_CREATE
#define dsig_superwrap_init              DSIG_SUPERWRAP_INIT
#define dsig_superwrap_update            DSIG_SUPERWRAP_UPDATE
#define dsig_superwrap_oneset            DSIG_SUPERWRAP_ONESET 
#define dsig_superwrap_twosets           DSIG_SUPERWRAP_TWOSETS
#define dsig_superwrap_wrapup            DSIG_SUPERWRAP_WRAPUP
#define dsig_superwrap_delete            DSIG_SUPERWRAP_DELETE
#endif


ProcessCreate     dsig_superwrap_create;
ProcessInitialize dsig_superwrap_init;
ProcessUpdate     dsig_superwrap_update;
ProcessOneset     dsig_superwrap_oneset;
ProcessTwosets    dsig_superwrap_twosets;
ProcessWrapup     dsig_superwrap_wrapup;
ProcessDelete     dsig_superwrap_delete;


void superwrap_dsig_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = dsig_superwrap_create;
  THIS->initialize = dsig_superwrap_init;
  THIS->update     = dsig_superwrap_update;
  THIS->oneset     = dsig_superwrap_oneset;
  THIS->twosets    = dsig_superwrap_twosets;
  THIS->wrapup     = dsig_superwrap_wrapup;
  THIS->delete     = dsig_superwrap_delete;
}



/*------------------------------- EAGC -------------------------------*/
/*------------------------------- EAGC -------------------------------*/
/*------------------------------- EAGC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define eagc_superwrap_create            eagc_superwrap_create_
#define eagc_superwrap_init              eagc_superwrap_init_
#define eagc_superwrap_update            eagc_superwrap_update_
#define eagc_superwrap_oneset            eagc_superwrap_oneset_ 
#define eagc_superwrap_twosets           eagc_superwrap_twosets_
#define eagc_superwrap_wrapup            eagc_superwrap_wrapup_
#define eagc_superwrap_delete            eagc_superwrap_delete_
#elif defined NEED_CAPITALS
#define eagc_superwrap_create            EAGC_SUPERWRAP_CREATE
#define eagc_superwrap_init              EAGC_SUPERWRAP_INIT
#define eagc_superwrap_update            EAGC_SUPERWRAP_UPDATE
#define eagc_superwrap_oneset            EAGC_SUPERWRAP_ONESET 
#define eagc_superwrap_twosets           EAGC_SUPERWRAP_TWOSETS
#define eagc_superwrap_wrapup            EAGC_SUPERWRAP_WRAPUP
#define eagc_superwrap_delete            EAGC_SUPERWRAP_DELETE
#endif


ProcessCreate     eagc_superwrap_create;
ProcessInitialize eagc_superwrap_init;
ProcessUpdate     eagc_superwrap_update;
ProcessOneset     eagc_superwrap_oneset;
ProcessTwosets    eagc_superwrap_twosets;
ProcessWrapup     eagc_superwrap_wrapup;
ProcessDelete     eagc_superwrap_delete;


void superwrap_eagc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = eagc_superwrap_create;
  THIS->initialize = eagc_superwrap_init;
  THIS->update     = eagc_superwrap_update;
  THIS->oneset     = eagc_superwrap_oneset;
  THIS->twosets    = eagc_superwrap_twosets;
  THIS->wrapup     = eagc_superwrap_wrapup;
  THIS->delete     = eagc_superwrap_delete;
}



/*------------------------------- EDA -------------------------------*/
/*------------------------------- EDA -------------------------------*/
/*------------------------------- EDA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define eda_superwrap_create            eda_superwrap_create_
#define eda_superwrap_init              eda_superwrap_init_
#define eda_superwrap_update            eda_superwrap_update_
#define eda_superwrap_oneset            eda_superwrap_oneset_ 
#define eda_superwrap_twosets           eda_superwrap_twosets_
#define eda_superwrap_wrapup            eda_superwrap_wrapup_
#define eda_superwrap_delete            eda_superwrap_delete_
#elif defined NEED_CAPITALS
#define eda_superwrap_create            EDA_SUPERWRAP_CREATE
#define eda_superwrap_init              EDA_SUPERWRAP_INIT
#define eda_superwrap_update            EDA_SUPERWRAP_UPDATE
#define eda_superwrap_oneset            EDA_SUPERWRAP_ONESET 
#define eda_superwrap_twosets           EDA_SUPERWRAP_TWOSETS
#define eda_superwrap_wrapup            EDA_SUPERWRAP_WRAPUP
#define eda_superwrap_delete            EDA_SUPERWRAP_DELETE
#endif


ProcessCreate     eda_superwrap_create;
ProcessInitialize eda_superwrap_init;
ProcessUpdate     eda_superwrap_update;
ProcessOneset     eda_superwrap_oneset;
ProcessTwosets    eda_superwrap_twosets;
ProcessWrapup     eda_superwrap_wrapup;
ProcessDelete     eda_superwrap_delete;


void superwrap_eda_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = eda_superwrap_create;
  THIS->initialize = eda_superwrap_init;
  THIS->update     = eda_superwrap_update;
  THIS->oneset     = eda_superwrap_oneset;
  THIS->twosets    = eda_superwrap_twosets;
  THIS->wrapup     = eda_superwrap_wrapup;
  THIS->delete     = eda_superwrap_delete;
}



/*------------------------------- EDA3D -------------------------------*/
/*------------------------------- EDA3D -------------------------------*/
/*------------------------------- EDA3D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define eda3d_superwrap_create            eda3d_superwrap_create_
#define eda3d_superwrap_init              eda3d_superwrap_init_
#define eda3d_superwrap_update            eda3d_superwrap_update_
#define eda3d_superwrap_oneset            eda3d_superwrap_oneset_ 
#define eda3d_superwrap_twosets           eda3d_superwrap_twosets_
#define eda3d_superwrap_wrapup            eda3d_superwrap_wrapup_
#define eda3d_superwrap_delete            eda3d_superwrap_delete_
#elif defined NEED_CAPITALS
#define eda3d_superwrap_create            EDA3D_SUPERWRAP_CREATE
#define eda3d_superwrap_init              EDA3D_SUPERWRAP_INIT
#define eda3d_superwrap_update            EDA3D_SUPERWRAP_UPDATE
#define eda3d_superwrap_oneset            EDA3D_SUPERWRAP_ONESET 
#define eda3d_superwrap_twosets           EDA3D_SUPERWRAP_TWOSETS
#define eda3d_superwrap_wrapup            EDA3D_SUPERWRAP_WRAPUP
#define eda3d_superwrap_delete            EDA3D_SUPERWRAP_DELETE
#endif


ProcessCreate     eda3d_superwrap_create;
ProcessInitialize eda3d_superwrap_init;
ProcessUpdate     eda3d_superwrap_update;
ProcessOneset     eda3d_superwrap_oneset;
ProcessTwosets    eda3d_superwrap_twosets;
ProcessWrapup     eda3d_superwrap_wrapup;
ProcessDelete     eda3d_superwrap_delete;


void superwrap_eda3d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = eda3d_superwrap_create;
  THIS->initialize = eda3d_superwrap_init;
  THIS->update     = eda3d_superwrap_update;
  THIS->oneset     = eda3d_superwrap_oneset;
  THIS->twosets    = eda3d_superwrap_twosets;
  THIS->wrapup     = eda3d_superwrap_wrapup;
  THIS->delete     = eda3d_superwrap_delete;
}



/*---------------------------- TRACETERP3D -------------------------------*/
/*---------------------------- TRACETERP3D -------------------------------*/
/*---------------------------- TRACETERP3D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define traceterp3d_superwrap_create            traceterp3d_superwrap_create_
#define traceterp3d_superwrap_init              traceterp3d_superwrap_init_
#define traceterp3d_superwrap_update            traceterp3d_superwrap_update_
#define traceterp3d_superwrap_oneset            traceterp3d_superwrap_oneset_ 
#define traceterp3d_superwrap_twosets           traceterp3d_superwrap_twosets_
#define traceterp3d_superwrap_wrapup            traceterp3d_superwrap_wrapup_
#define traceterp3d_superwrap_delete            traceterp3d_superwrap_delete_
#elif defined NEED_CAPITALS
#define traceterp3d_superwrap_create            TRACETERP3D_SUPERWRAP_CREATE
#define traceterp3d_superwrap_init              TRACETERP3D_SUPERWRAP_INIT
#define traceterp3d_superwrap_update            TRACETERP3D_SUPERWRAP_UPDATE
#define traceterp3d_superwrap_oneset            TRACETERP3D_SUPERWRAP_ONESET 
#define traceterp3d_superwrap_twosets           TRACETERP3D_SUPERWRAP_TWOSETS
#define traceterp3d_superwrap_wrapup            TRACETERP3D_SUPERWRAP_WRAPUP
#define traceterp3d_superwrap_delete            TRACETERP3D_SUPERWRAP_DELETE
#endif


ProcessCreate     traceterp3d_superwrap_create;
ProcessInitialize traceterp3d_superwrap_init;
ProcessUpdate     traceterp3d_superwrap_update;
ProcessOneset     traceterp3d_superwrap_oneset;
ProcessTwosets    traceterp3d_superwrap_twosets;
ProcessWrapup     traceterp3d_superwrap_wrapup;
ProcessDelete     traceterp3d_superwrap_delete;


void superwrap_traceterp3d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = traceterp3d_superwrap_create;
  THIS->initialize = traceterp3d_superwrap_init;
  THIS->update     = traceterp3d_superwrap_update;
  THIS->oneset     = traceterp3d_superwrap_oneset;
  THIS->twosets    = traceterp3d_superwrap_twosets;
  THIS->wrapup     = traceterp3d_superwrap_wrapup;
  THIS->delete     = traceterp3d_superwrap_delete;
}


/*------------------------------- ELEV -------------------------------*/
/*------------------------------- ELEV -------------------------------*/
/*------------------------------- ELEV -------------------------------*/


#ifdef NEED_UNDERSCORE
#define elev_superwrap_create            elev_superwrap_create_
#define elev_superwrap_init              elev_superwrap_init_
#define elev_superwrap_update            elev_superwrap_update_
#define elev_superwrap_oneset            elev_superwrap_oneset_ 
#define elev_superwrap_twosets           elev_superwrap_twosets_
#define elev_superwrap_wrapup            elev_superwrap_wrapup_
#define elev_superwrap_delete            elev_superwrap_delete_
#elif defined NEED_CAPITALS
#define elev_superwrap_create            ELEV_SUPERWRAP_CREATE
#define elev_superwrap_init              ELEV_SUPERWRAP_INIT
#define elev_superwrap_update            ELEV_SUPERWRAP_UPDATE
#define elev_superwrap_oneset            ELEV_SUPERWRAP_ONESET 
#define elev_superwrap_twosets           ELEV_SUPERWRAP_TWOSETS
#define elev_superwrap_wrapup            ELEV_SUPERWRAP_WRAPUP
#define elev_superwrap_delete            ELEV_SUPERWRAP_DELETE
#endif


ProcessCreate     elev_superwrap_create;
ProcessInitialize elev_superwrap_init;
ProcessUpdate     elev_superwrap_update;
ProcessOneset     elev_superwrap_oneset;
ProcessTwosets    elev_superwrap_twosets;
ProcessWrapup     elev_superwrap_wrapup;
ProcessDelete     elev_superwrap_delete;


void superwrap_elev_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = elev_superwrap_create;
  THIS->initialize = elev_superwrap_init;
  THIS->update     = elev_superwrap_update;
  THIS->oneset     = elev_superwrap_oneset;
  THIS->twosets    = elev_superwrap_twosets;
  THIS->wrapup     = elev_superwrap_wrapup;
  THIS->delete     = elev_superwrap_delete;
}



/*------------------------------- EXO -------------------------------*/
/*------------------------------- EXO -------------------------------*/
/*------------------------------- EXO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define exo_superwrap_create            exo_superwrap_create_
#define exo_superwrap_init              exo_superwrap_init_
#define exo_superwrap_update            exo_superwrap_update_
#define exo_superwrap_oneset            exo_superwrap_oneset_ 
#define exo_superwrap_twosets           exo_superwrap_twosets_
#define exo_superwrap_wrapup            exo_superwrap_wrapup_
#define exo_superwrap_delete            exo_superwrap_delete_
#elif defined NEED_CAPITALS
#define exo_superwrap_create            EXO_SUPERWRAP_CREATE
#define exo_superwrap_init              EXO_SUPERWRAP_INIT
#define exo_superwrap_update            EXO_SUPERWRAP_UPDATE
#define exo_superwrap_oneset            EXO_SUPERWRAP_ONESET 
#define exo_superwrap_twosets           EXO_SUPERWRAP_TWOSETS
#define exo_superwrap_wrapup            EXO_SUPERWRAP_WRAPUP
#define exo_superwrap_delete            EXO_SUPERWRAP_DELETE
#endif


ProcessCreate     exo_superwrap_create;
ProcessInitialize exo_superwrap_init;
ProcessUpdate     exo_superwrap_update;
ProcessOneset     exo_superwrap_oneset;
ProcessTwosets    exo_superwrap_twosets;
ProcessWrapup     exo_superwrap_wrapup;
ProcessDelete     exo_superwrap_delete;


void superwrap_exo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = exo_superwrap_create;
  THIS->initialize = exo_superwrap_init;
  THIS->update     = exo_superwrap_update;
  THIS->oneset     = exo_superwrap_oneset;
  THIS->twosets    = exo_superwrap_twosets;
  THIS->wrapup     = exo_superwrap_wrapup;
  THIS->delete     = exo_superwrap_delete;
}



/*------------------------------- EZCHECK -------------------------------*/
/*------------------------------- EZCHECK -------------------------------*/
/*------------------------------- EZCHECK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ezcheck_superwrap_create            ezcheck_superwrap_create_
#define ezcheck_superwrap_init              ezcheck_superwrap_init_
#define ezcheck_superwrap_update            ezcheck_superwrap_update_
#define ezcheck_superwrap_oneset            ezcheck_superwrap_oneset_ 
#define ezcheck_superwrap_twosets           ezcheck_superwrap_twosets_
#define ezcheck_superwrap_wrapup            ezcheck_superwrap_wrapup_
#define ezcheck_superwrap_delete            ezcheck_superwrap_delete_
#elif defined NEED_CAPITALS
#define ezcheck_superwrap_create            EZCHECK_SUPERWRAP_CREATE
#define ezcheck_superwrap_init              EZCHECK_SUPERWRAP_INIT
#define ezcheck_superwrap_update            EZCHECK_SUPERWRAP_UPDATE
#define ezcheck_superwrap_oneset            EZCHECK_SUPERWRAP_ONESET 
#define ezcheck_superwrap_twosets           EZCHECK_SUPERWRAP_TWOSETS
#define ezcheck_superwrap_wrapup            EZCHECK_SUPERWRAP_WRAPUP
#define ezcheck_superwrap_delete            EZCHECK_SUPERWRAP_DELETE
#endif


ProcessCreate     ezcheck_superwrap_create;
ProcessInitialize ezcheck_superwrap_init;
ProcessUpdate     ezcheck_superwrap_update;
ProcessOneset     ezcheck_superwrap_oneset;
ProcessTwosets    ezcheck_superwrap_twosets;
ProcessWrapup     ezcheck_superwrap_wrapup;
ProcessDelete     ezcheck_superwrap_delete;


void superwrap_ezcheck_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ezcheck_superwrap_create;
  THIS->initialize = ezcheck_superwrap_init;
  THIS->update     = ezcheck_superwrap_update;
  THIS->oneset     = ezcheck_superwrap_oneset;
  THIS->twosets    = ezcheck_superwrap_twosets;
  THIS->wrapup     = ezcheck_superwrap_wrapup;
  THIS->delete     = ezcheck_superwrap_delete;
}



/*------------------------------- FBAL -------------------------------*/
/*------------------------------- FBAL -------------------------------*/
/*------------------------------- FBAL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fbal_superwrap_create            fbal_superwrap_create_
#define fbal_superwrap_init              fbal_superwrap_init_
#define fbal_superwrap_update            fbal_superwrap_update_
#define fbal_superwrap_oneset            fbal_superwrap_oneset_ 
#define fbal_superwrap_twosets           fbal_superwrap_twosets_
#define fbal_superwrap_wrapup            fbal_superwrap_wrapup_
#define fbal_superwrap_delete            fbal_superwrap_delete_
#elif defined NEED_CAPITALS
#define fbal_superwrap_create            FBAL_SUPERWRAP_CREATE
#define fbal_superwrap_init              FBAL_SUPERWRAP_INIT
#define fbal_superwrap_update            FBAL_SUPERWRAP_UPDATE
#define fbal_superwrap_oneset            FBAL_SUPERWRAP_ONESET 
#define fbal_superwrap_twosets           FBAL_SUPERWRAP_TWOSETS
#define fbal_superwrap_wrapup            FBAL_SUPERWRAP_WRAPUP
#define fbal_superwrap_delete            FBAL_SUPERWRAP_DELETE
#endif


ProcessCreate     fbal_superwrap_create;
ProcessInitialize fbal_superwrap_init;
ProcessUpdate     fbal_superwrap_update;
ProcessOneset     fbal_superwrap_oneset;
ProcessTwosets    fbal_superwrap_twosets;
ProcessWrapup     fbal_superwrap_wrapup;
ProcessDelete     fbal_superwrap_delete;


void superwrap_fbal_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fbal_superwrap_create;
  THIS->initialize = fbal_superwrap_init;
  THIS->update     = fbal_superwrap_update;
  THIS->oneset     = fbal_superwrap_oneset;
  THIS->twosets    = fbal_superwrap_twosets;
  THIS->wrapup     = fbal_superwrap_wrapup;
  THIS->delete     = fbal_superwrap_delete;
}



/*------------------------------- FFAVA -------------------------------*/
/*------------------------------- FFAVA -------------------------------*/
/*------------------------------- FFAVA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ffava_superwrap_create            ffava_superwrap_create_
#define ffava_superwrap_init              ffava_superwrap_init_
#define ffava_superwrap_update            ffava_superwrap_update_
#define ffava_superwrap_oneset            ffava_superwrap_oneset_ 
#define ffava_superwrap_twosets           ffava_superwrap_twosets_
#define ffava_superwrap_wrapup            ffava_superwrap_wrapup_
#define ffava_superwrap_delete            ffava_superwrap_delete_
#elif defined NEED_CAPITALS
#define ffava_superwrap_create            FFAVA_SUPERWRAP_CREATE
#define ffava_superwrap_init              FFAVA_SUPERWRAP_INIT
#define ffava_superwrap_update            FFAVA_SUPERWRAP_UPDATE
#define ffava_superwrap_oneset            FFAVA_SUPERWRAP_ONESET 
#define ffava_superwrap_twosets           FFAVA_SUPERWRAP_TWOSETS
#define ffava_superwrap_wrapup            FFAVA_SUPERWRAP_WRAPUP
#define ffava_superwrap_delete            FFAVA_SUPERWRAP_DELETE
#endif


ProcessCreate     ffava_superwrap_create;
ProcessInitialize ffava_superwrap_init;
ProcessUpdate     ffava_superwrap_update;
ProcessOneset     ffava_superwrap_oneset;
ProcessTwosets    ffava_superwrap_twosets;
ProcessWrapup     ffava_superwrap_wrapup;
ProcessDelete     ffava_superwrap_delete;


void superwrap_ffava_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ffava_superwrap_create;
  THIS->initialize = ffava_superwrap_init;
  THIS->update     = ffava_superwrap_update;
  THIS->oneset     = ffava_superwrap_oneset;
  THIS->twosets    = ffava_superwrap_twosets;
  THIS->wrapup     = ffava_superwrap_wrapup;
  THIS->delete     = ffava_superwrap_delete;
}



/*------------------------------- FGD -------------------------------*/
/*------------------------------- FGD -------------------------------*/
/*------------------------------- FGD -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fgd_superwrap_create            fgd_superwrap_create_
#define fgd_superwrap_init              fgd_superwrap_init_
#define fgd_superwrap_update            fgd_superwrap_update_
#define fgd_superwrap_oneset            fgd_superwrap_oneset_ 
#define fgd_superwrap_twosets           fgd_superwrap_twosets_
#define fgd_superwrap_wrapup            fgd_superwrap_wrapup_
#define fgd_superwrap_delete            fgd_superwrap_delete_
#elif defined NEED_CAPITALS
#define fgd_superwrap_create            FGD_SUPERWRAP_CREATE
#define fgd_superwrap_init              FGD_SUPERWRAP_INIT
#define fgd_superwrap_update            FGD_SUPERWRAP_UPDATE
#define fgd_superwrap_oneset            FGD_SUPERWRAP_ONESET 
#define fgd_superwrap_twosets           FGD_SUPERWRAP_TWOSETS
#define fgd_superwrap_wrapup            FGD_SUPERWRAP_WRAPUP
#define fgd_superwrap_delete            FGD_SUPERWRAP_DELETE
#endif


ProcessCreate     fgd_superwrap_create;
ProcessInitialize fgd_superwrap_init;
ProcessUpdate     fgd_superwrap_update;
ProcessOneset     fgd_superwrap_oneset;
ProcessTwosets    fgd_superwrap_twosets;
ProcessWrapup     fgd_superwrap_wrapup;
ProcessDelete     fgd_superwrap_delete;


void superwrap_fgd_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fgd_superwrap_create;
  THIS->initialize = fgd_superwrap_init;
  THIS->update     = fgd_superwrap_update;
  THIS->oneset     = fgd_superwrap_oneset;
  THIS->twosets    = fgd_superwrap_twosets;
  THIS->wrapup     = fgd_superwrap_wrapup;
  THIS->delete     = fgd_superwrap_delete;
}



/*------------------------------- FGDREV -------------------------------*/
/*------------------------------- FGDREV -------------------------------*/
/*------------------------------- FGDREV -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fgdrev_superwrap_create            fgdrev_superwrap_create_
#define fgdrev_superwrap_init              fgdrev_superwrap_init_
#define fgdrev_superwrap_update            fgdrev_superwrap_update_
#define fgdrev_superwrap_oneset            fgdrev_superwrap_oneset_ 
#define fgdrev_superwrap_twosets           fgdrev_superwrap_twosets_
#define fgdrev_superwrap_wrapup            fgdrev_superwrap_wrapup_
#define fgdrev_superwrap_delete            fgdrev_superwrap_delete_
#elif defined NEED_CAPITALS
#define fgdrev_superwrap_create            FGDREV_SUPERWRAP_CREATE
#define fgdrev_superwrap_init              FGDREV_SUPERWRAP_INIT
#define fgdrev_superwrap_update            FGDREV_SUPERWRAP_UPDATE
#define fgdrev_superwrap_oneset            FGDREV_SUPERWRAP_ONESET 
#define fgdrev_superwrap_twosets           FGDREV_SUPERWRAP_TWOSETS
#define fgdrev_superwrap_wrapup            FGDREV_SUPERWRAP_WRAPUP
#define fgdrev_superwrap_delete            FGDREV_SUPERWRAP_DELETE
#endif


ProcessCreate     fgdrev_superwrap_create;
ProcessInitialize fgdrev_superwrap_init;
ProcessUpdate     fgdrev_superwrap_update;
ProcessOneset     fgdrev_superwrap_oneset;
ProcessTwosets    fgdrev_superwrap_twosets;
ProcessWrapup     fgdrev_superwrap_wrapup;
ProcessDelete     fgdrev_superwrap_delete;


void superwrap_fgdrev_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fgdrev_superwrap_create;
  THIS->initialize = fgdrev_superwrap_init;
  THIS->update     = fgdrev_superwrap_update;
  THIS->oneset     = fgdrev_superwrap_oneset;
  THIS->twosets    = fgdrev_superwrap_twosets;
  THIS->wrapup     = fgdrev_superwrap_wrapup;
  THIS->delete     = fgdrev_superwrap_delete;
}



/*------------------------------- FILL -------------------------------*/
/*------------------------------- FILL -------------------------------*/
/*------------------------------- FILL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fill_superwrap_create            fill_superwrap_create_
#define fill_superwrap_init              fill_superwrap_init_
#define fill_superwrap_update            fill_superwrap_update_
#define fill_superwrap_oneset            fill_superwrap_oneset_ 
#define fill_superwrap_twosets           fill_superwrap_twosets_
#define fill_superwrap_wrapup            fill_superwrap_wrapup_
#define fill_superwrap_delete            fill_superwrap_delete_
#elif defined NEED_CAPITALS
#define fill_superwrap_create            FILL_SUPERWRAP_CREATE
#define fill_superwrap_init              FILL_SUPERWRAP_INIT
#define fill_superwrap_update            FILL_SUPERWRAP_UPDATE
#define fill_superwrap_oneset            FILL_SUPERWRAP_ONESET 
#define fill_superwrap_twosets           FILL_SUPERWRAP_TWOSETS
#define fill_superwrap_wrapup            FILL_SUPERWRAP_WRAPUP
#define fill_superwrap_delete            FILL_SUPERWRAP_DELETE
#endif


ProcessCreate     fill_superwrap_create;
ProcessInitialize fill_superwrap_init;
ProcessUpdate     fill_superwrap_update;
ProcessOneset     fill_superwrap_oneset;
ProcessTwosets    fill_superwrap_twosets;
ProcessWrapup     fill_superwrap_wrapup;
ProcessDelete     fill_superwrap_delete;


void superwrap_fill_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fill_superwrap_create;
  THIS->initialize = fill_superwrap_init;
  THIS->update     = fill_superwrap_update;
  THIS->oneset     = fill_superwrap_oneset;
  THIS->twosets    = fill_superwrap_twosets;
  THIS->wrapup     = fill_superwrap_wrapup;
  THIS->delete     = fill_superwrap_delete;
}



/*------------------------------- FILTIIR -------------------------------*/
/*------------------------------- FILTIIR -------------------------------*/
/*------------------------------- FILTIIR -------------------------------*/


#ifdef NEED_UNDERSCORE
#define filtiir_superwrap_create            filtiir_superwrap_create_
#define filtiir_superwrap_init              filtiir_superwrap_init_
#define filtiir_superwrap_update            filtiir_superwrap_update_
#define filtiir_superwrap_oneset            filtiir_superwrap_oneset_ 
#define filtiir_superwrap_twosets           filtiir_superwrap_twosets_
#define filtiir_superwrap_wrapup            filtiir_superwrap_wrapup_
#define filtiir_superwrap_delete            filtiir_superwrap_delete_
#elif defined NEED_CAPITALS
#define filtiir_superwrap_create            FILTIIR_SUPERWRAP_CREATE
#define filtiir_superwrap_init              FILTIIR_SUPERWRAP_INIT
#define filtiir_superwrap_update            FILTIIR_SUPERWRAP_UPDATE
#define filtiir_superwrap_oneset            FILTIIR_SUPERWRAP_ONESET 
#define filtiir_superwrap_twosets           FILTIIR_SUPERWRAP_TWOSETS
#define filtiir_superwrap_wrapup            FILTIIR_SUPERWRAP_WRAPUP
#define filtiir_superwrap_delete            FILTIIR_SUPERWRAP_DELETE
#endif


ProcessCreate     filtiir_superwrap_create;
ProcessInitialize filtiir_superwrap_init;
ProcessUpdate     filtiir_superwrap_update;
ProcessOneset     filtiir_superwrap_oneset;
ProcessTwosets    filtiir_superwrap_twosets;
ProcessWrapup     filtiir_superwrap_wrapup;
ProcessDelete     filtiir_superwrap_delete;


void superwrap_filtiir_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = filtiir_superwrap_create;
  THIS->initialize = filtiir_superwrap_init;
  THIS->update     = filtiir_superwrap_update;
  THIS->oneset     = filtiir_superwrap_oneset;
  THIS->twosets    = filtiir_superwrap_twosets;
  THIS->wrapup     = filtiir_superwrap_wrapup;
  THIS->delete     = filtiir_superwrap_delete;
}


/*------------------------------- FILTP -------------------------------*/
/*------------------------------- FILTP -------------------------------*/
/*------------------------------- FILTP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define filtp_superwrap_create            filtp_superwrap_create_
#define filtp_superwrap_init              filtp_superwrap_init_
#define filtp_superwrap_update            filtp_superwrap_update_
#define filtp_superwrap_oneset            filtp_superwrap_oneset_ 
#define filtp_superwrap_twosets           filtp_superwrap_twosets_
#define filtp_superwrap_wrapup            filtp_superwrap_wrapup_
#define filtp_superwrap_delete            filtp_superwrap_delete_
#elif defined NEED_CAPITALS
#define filtp_superwrap_create            FILTP_SUPERWRAP_CREATE
#define filtp_superwrap_init              FILTP_SUPERWRAP_INIT
#define filtp_superwrap_update            FILTP_SUPERWRAP_UPDATE
#define filtp_superwrap_oneset            FILTP_SUPERWRAP_ONESET 
#define filtp_superwrap_twosets           FILTP_SUPERWRAP_TWOSETS
#define filtp_superwrap_wrapup            FILTP_SUPERWRAP_WRAPUP
#define filtp_superwrap_delete            FILTP_SUPERWRAP_DELETE
#endif


ProcessCreate     filtp_superwrap_create;
ProcessInitialize filtp_superwrap_init;
ProcessUpdate     filtp_superwrap_update;
ProcessOneset     filtp_superwrap_oneset;
ProcessTwosets    filtp_superwrap_twosets;
ProcessWrapup     filtp_superwrap_wrapup;
ProcessDelete     filtp_superwrap_delete;


void superwrap_filtp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = filtp_superwrap_create;
  THIS->initialize = filtp_superwrap_init;
  THIS->update     = filtp_superwrap_update;
  THIS->oneset     = filtp_superwrap_oneset;
  THIS->twosets    = filtp_superwrap_twosets;
  THIS->wrapup     = filtp_superwrap_wrapup;
  THIS->delete     = filtp_superwrap_delete;
}



/*------------------------------- FISH -------------------------------*/
/*------------------------------- FISH -------------------------------*/
/*------------------------------- FISH -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fish_superwrap_create            fish_superwrap_create_
#define fish_superwrap_init              fish_superwrap_init_
#define fish_superwrap_update            fish_superwrap_update_
#define fish_superwrap_oneset            fish_superwrap_oneset_ 
#define fish_superwrap_twosets           fish_superwrap_twosets_
#define fish_superwrap_wrapup            fish_superwrap_wrapup_
#define fish_superwrap_delete            fish_superwrap_delete_
#elif defined NEED_CAPITALS
#define fish_superwrap_create            FISH_SUPERWRAP_CREATE
#define fish_superwrap_init              FISH_SUPERWRAP_INIT
#define fish_superwrap_update            FISH_SUPERWRAP_UPDATE
#define fish_superwrap_oneset            FISH_SUPERWRAP_ONESET 
#define fish_superwrap_twosets           FISH_SUPERWRAP_TWOSETS
#define fish_superwrap_wrapup            FISH_SUPERWRAP_WRAPUP
#define fish_superwrap_delete            FISH_SUPERWRAP_DELETE
#endif


ProcessCreate     fish_superwrap_create;
ProcessInitialize fish_superwrap_init;
ProcessUpdate     fish_superwrap_update;
ProcessOneset     fish_superwrap_oneset;
ProcessTwosets    fish_superwrap_twosets;
ProcessWrapup     fish_superwrap_wrapup;
ProcessDelete     fish_superwrap_delete;


void superwrap_fish_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fish_superwrap_create;
  THIS->initialize = fish_superwrap_init;
  THIS->update     = fish_superwrap_update;
  THIS->oneset     = fish_superwrap_oneset;
  THIS->twosets    = fish_superwrap_twosets;
  THIS->wrapup     = fish_superwrap_wrapup;
  THIS->delete     = fish_superwrap_delete;
}



/*------------------------------- FKAP -------------------------------*/
/*------------------------------- FKAP -------------------------------*/
/*------------------------------- FKAP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fkap_superwrap_create            fkap_superwrap_create_
#define fkap_superwrap_init              fkap_superwrap_init_
#define fkap_superwrap_update            fkap_superwrap_update_
#define fkap_superwrap_oneset            fkap_superwrap_oneset_ 
#define fkap_superwrap_twosets           fkap_superwrap_twosets_
#define fkap_superwrap_wrapup            fkap_superwrap_wrapup_
#define fkap_superwrap_delete            fkap_superwrap_delete_
#elif defined NEED_CAPITALS
#define fkap_superwrap_create            FKAP_SUPERWRAP_CREATE
#define fkap_superwrap_init              FKAP_SUPERWRAP_INIT
#define fkap_superwrap_update            FKAP_SUPERWRAP_UPDATE
#define fkap_superwrap_oneset            FKAP_SUPERWRAP_ONESET 
#define fkap_superwrap_twosets           FKAP_SUPERWRAP_TWOSETS
#define fkap_superwrap_wrapup            FKAP_SUPERWRAP_WRAPUP
#define fkap_superwrap_delete            FKAP_SUPERWRAP_DELETE
#endif


ProcessCreate     fkap_superwrap_create;
ProcessInitialize fkap_superwrap_init;
ProcessUpdate     fkap_superwrap_update;
ProcessOneset     fkap_superwrap_oneset;
ProcessTwosets    fkap_superwrap_twosets;
ProcessWrapup     fkap_superwrap_wrapup;
ProcessDelete     fkap_superwrap_delete;


void superwrap_fkap_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fkap_superwrap_create;
  THIS->initialize = fkap_superwrap_init;
  THIS->update     = fkap_superwrap_update;
  THIS->oneset     = fkap_superwrap_oneset;
  THIS->twosets    = fkap_superwrap_twosets;
  THIS->wrapup     = fkap_superwrap_wrapup;
  THIS->delete     = fkap_superwrap_delete;
}



/*------------------------------- FKFILT -------------------------------*/
/*------------------------------- FKFILT -------------------------------*/
/*------------------------------- FKFILT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fkfilt_superwrap_create            fkfilt_superwrap_create_
#define fkfilt_superwrap_init              fkfilt_superwrap_init_
#define fkfilt_superwrap_update            fkfilt_superwrap_update_
#define fkfilt_superwrap_oneset            fkfilt_superwrap_oneset_ 
#define fkfilt_superwrap_twosets           fkfilt_superwrap_twosets_
#define fkfilt_superwrap_wrapup            fkfilt_superwrap_wrapup_
#define fkfilt_superwrap_delete            fkfilt_superwrap_delete_
#elif defined NEED_CAPITALS
#define fkfilt_superwrap_create            FKFILT_SUPERWRAP_CREATE
#define fkfilt_superwrap_init              FKFILT_SUPERWRAP_INIT
#define fkfilt_superwrap_update            FKFILT_SUPERWRAP_UPDATE
#define fkfilt_superwrap_oneset            FKFILT_SUPERWRAP_ONESET 
#define fkfilt_superwrap_twosets           FKFILT_SUPERWRAP_TWOSETS
#define fkfilt_superwrap_wrapup            FKFILT_SUPERWRAP_WRAPUP
#define fkfilt_superwrap_delete            FKFILT_SUPERWRAP_DELETE
#endif


ProcessCreate     fkfilt_superwrap_create;
ProcessInitialize fkfilt_superwrap_init;
ProcessUpdate     fkfilt_superwrap_update;
ProcessOneset     fkfilt_superwrap_oneset;
ProcessTwosets    fkfilt_superwrap_twosets;
ProcessWrapup     fkfilt_superwrap_wrapup;
ProcessDelete     fkfilt_superwrap_delete;


void superwrap_fkfilt_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fkfilt_superwrap_create;
  THIS->initialize = fkfilt_superwrap_init;
  THIS->update     = fkfilt_superwrap_update;
  THIS->oneset     = fkfilt_superwrap_oneset;
  THIS->twosets    = fkfilt_superwrap_twosets;
  THIS->wrapup     = fkfilt_superwrap_wrapup;
  THIS->delete     = fkfilt_superwrap_delete;
}



/*------------------------------- FKTMIG -------------------------------*/
/*------------------------------- FKTMIG -------------------------------*/
/*------------------------------- FKTMIG -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fktmig_superwrap_create            fktmig_superwrap_create_
#define fktmig_superwrap_init              fktmig_superwrap_init_
#define fktmig_superwrap_update            fktmig_superwrap_update_
#define fktmig_superwrap_oneset            fktmig_superwrap_oneset_ 
#define fktmig_superwrap_twosets           fktmig_superwrap_twosets_
#define fktmig_superwrap_wrapup            fktmig_superwrap_wrapup_
#define fktmig_superwrap_delete            fktmig_superwrap_delete_
#elif defined NEED_CAPITALS
#define fktmig_superwrap_create            FKTMIG_SUPERWRAP_CREATE
#define fktmig_superwrap_init              FKTMIG_SUPERWRAP_INIT
#define fktmig_superwrap_update            FKTMIG_SUPERWRAP_UPDATE
#define fktmig_superwrap_oneset            FKTMIG_SUPERWRAP_ONESET 
#define fktmig_superwrap_twosets           FKTMIG_SUPERWRAP_TWOSETS
#define fktmig_superwrap_wrapup            FKTMIG_SUPERWRAP_WRAPUP
#define fktmig_superwrap_delete            FKTMIG_SUPERWRAP_DELETE
#endif


ProcessCreate     fktmig_superwrap_create;
ProcessInitialize fktmig_superwrap_init;
ProcessUpdate     fktmig_superwrap_update;
ProcessOneset     fktmig_superwrap_oneset;
ProcessTwosets    fktmig_superwrap_twosets;
ProcessWrapup     fktmig_superwrap_wrapup;
ProcessDelete     fktmig_superwrap_delete;


void superwrap_fktmig_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fktmig_superwrap_create;
  THIS->initialize = fktmig_superwrap_init;
  THIS->update     = fktmig_superwrap_update;
  THIS->oneset     = fktmig_superwrap_oneset;
  THIS->twosets    = fktmig_superwrap_twosets;
  THIS->wrapup     = fktmig_superwrap_wrapup;
  THIS->delete     = fktmig_superwrap_delete;
}



/*------------------------------- FKTR -------------------------------*/
/*------------------------------- FKTR -------------------------------*/
/*------------------------------- FKTR -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fktr_superwrap_create            fktr_superwrap_create_
#define fktr_superwrap_init              fktr_superwrap_init_
#define fktr_superwrap_update            fktr_superwrap_update_
#define fktr_superwrap_oneset            fktr_superwrap_oneset_ 
#define fktr_superwrap_twosets           fktr_superwrap_twosets_
#define fktr_superwrap_wrapup            fktr_superwrap_wrapup_
#define fktr_superwrap_delete            fktr_superwrap_delete_
#elif defined NEED_CAPITALS
#define fktr_superwrap_create            FKTR_SUPERWRAP_CREATE
#define fktr_superwrap_init              FKTR_SUPERWRAP_INIT
#define fktr_superwrap_update            FKTR_SUPERWRAP_UPDATE
#define fktr_superwrap_oneset            FKTR_SUPERWRAP_ONESET 
#define fktr_superwrap_twosets           FKTR_SUPERWRAP_TWOSETS
#define fktr_superwrap_wrapup            FKTR_SUPERWRAP_WRAPUP
#define fktr_superwrap_delete            FKTR_SUPERWRAP_DELETE
#endif


ProcessCreate     fktr_superwrap_create;
ProcessInitialize fktr_superwrap_init;
ProcessUpdate     fktr_superwrap_update;
ProcessOneset     fktr_superwrap_oneset;
ProcessTwosets    fktr_superwrap_twosets;
ProcessWrapup     fktr_superwrap_wrapup;
ProcessDelete     fktr_superwrap_delete;


void superwrap_fktr_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fktr_superwrap_create;
  THIS->initialize = fktr_superwrap_init;
  THIS->update     = fktr_superwrap_update;
  THIS->oneset     = fktr_superwrap_oneset;
  THIS->twosets    = fktr_superwrap_twosets;
  THIS->wrapup     = fktr_superwrap_wrapup;
  THIS->delete     = fktr_superwrap_delete;
}



/*------------------------------- FLEXBIN -------------------------------*/
/*------------------------------- FLEXBIN -------------------------------*/
/*------------------------------- FLEXBIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define flexbin_superwrap_create            flexbin_superwrap_create_
#define flexbin_superwrap_init              flexbin_superwrap_init_
#define flexbin_superwrap_update            flexbin_superwrap_update_
#define flexbin_superwrap_oneset            flexbin_superwrap_oneset_ 
#define flexbin_superwrap_twosets           flexbin_superwrap_twosets_
#define flexbin_superwrap_wrapup            flexbin_superwrap_wrapup_
#define flexbin_superwrap_delete            flexbin_superwrap_delete_
#elif defined NEED_CAPITALS
#define flexbin_superwrap_create            FLEXBIN_SUPERWRAP_CREATE
#define flexbin_superwrap_init              FLEXBIN_SUPERWRAP_INIT
#define flexbin_superwrap_update            FLEXBIN_SUPERWRAP_UPDATE
#define flexbin_superwrap_oneset            FLEXBIN_SUPERWRAP_ONESET 
#define flexbin_superwrap_twosets           FLEXBIN_SUPERWRAP_TWOSETS
#define flexbin_superwrap_wrapup            FLEXBIN_SUPERWRAP_WRAPUP
#define flexbin_superwrap_delete            FLEXBIN_SUPERWRAP_DELETE
#endif


ProcessCreate     flexbin_superwrap_create;
ProcessInitialize flexbin_superwrap_init;
ProcessUpdate     flexbin_superwrap_update;
ProcessOneset     flexbin_superwrap_oneset;
ProcessTwosets    flexbin_superwrap_twosets;
ProcessWrapup     flexbin_superwrap_wrapup;
ProcessDelete     flexbin_superwrap_delete;


void superwrap_flexbin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = flexbin_superwrap_create;
  THIS->initialize = flexbin_superwrap_init;
  THIS->update     = flexbin_superwrap_update;
  THIS->oneset     = flexbin_superwrap_oneset;
  THIS->twosets    = flexbin_superwrap_twosets;
  THIS->wrapup     = flexbin_superwrap_wrapup;
  THIS->delete     = flexbin_superwrap_delete;
}



/*------------------------------- FXDECON -------------------------------*/
/*------------------------------- FXDECON -------------------------------*/
/*------------------------------- FXDECON -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fxdecon_superwrap_create            fxdecon_superwrap_create_
#define fxdecon_superwrap_init              fxdecon_superwrap_init_
#define fxdecon_superwrap_update            fxdecon_superwrap_update_
#define fxdecon_superwrap_oneset            fxdecon_superwrap_oneset_ 
#define fxdecon_superwrap_twosets           fxdecon_superwrap_twosets_
#define fxdecon_superwrap_wrapup            fxdecon_superwrap_wrapup_
#define fxdecon_superwrap_delete            fxdecon_superwrap_delete_
#elif defined NEED_CAPITALS
#define fxdecon_superwrap_create            FXDECON_SUPERWRAP_CREATE
#define fxdecon_superwrap_init              FXDECON_SUPERWRAP_INIT
#define fxdecon_superwrap_update            FXDECON_SUPERWRAP_UPDATE
#define fxdecon_superwrap_oneset            FXDECON_SUPERWRAP_ONESET 
#define fxdecon_superwrap_twosets           FXDECON_SUPERWRAP_TWOSETS
#define fxdecon_superwrap_wrapup            FXDECON_SUPERWRAP_WRAPUP
#define fxdecon_superwrap_delete            FXDECON_SUPERWRAP_DELETE
#endif


ProcessCreate     fxdecon_superwrap_create;
ProcessInitialize fxdecon_superwrap_init;
ProcessUpdate     fxdecon_superwrap_update;
ProcessOneset     fxdecon_superwrap_oneset;
ProcessTwosets    fxdecon_superwrap_twosets;
ProcessWrapup     fxdecon_superwrap_wrapup;
ProcessDelete     fxdecon_superwrap_delete;


void superwrap_fxdecon_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fxdecon_superwrap_create;
  THIS->initialize = fxdecon_superwrap_init;
  THIS->update     = fxdecon_superwrap_update;
  THIS->oneset     = fxdecon_superwrap_oneset;
  THIS->twosets    = fxdecon_superwrap_twosets;
  THIS->wrapup     = fxdecon_superwrap_wrapup;
  THIS->delete     = fxdecon_superwrap_delete;
}

/*------------------------------- FXDNOISE -------------------------------*/
/*------------------------------- FXDNOISE -------------------------------*/
/*------------------------------- FXDNOISE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fxdnoise_superwrap_create            fxdnoise_superwrap_create_
#define fxdnoise_superwrap_init              fxdnoise_superwrap_init_
#define fxdnoise_superwrap_update            fxdnoise_superwrap_update_
#define fxdnoise_superwrap_oneset            fxdnoise_superwrap_oneset_ 
#define fxdnoise_superwrap_twosets           fxdnoise_superwrap_twosets_
#define fxdnoise_superwrap_wrapup            fxdnoise_superwrap_wrapup_
#define fxdnoise_superwrap_delete            fxdnoise_superwrap_delete_
#elif defined NEED_CAPITALS
#define fxdnoise_superwrap_create            FXDNOISE_SUPERWRAP_CREATE
#define fxdnoise_superwrap_init              FXDNOISE_SUPERWRAP_INIT
#define fxdnoise_superwrap_update            FXDNOISE_SUPERWRAP_UPDATE
#define fxdnoise_superwrap_oneset            FXDNOISE_SUPERWRAP_ONESET 
#define fxdnoise_superwrap_twosets           FXDNOISE_SUPERWRAP_TWOSETS
#define fxdnoise_superwrap_wrapup            FXDNOISE_SUPERWRAP_WRAPUP
#define fxdnoise_superwrap_delete            FXDNOISE_SUPERWRAP_DELETE
#endif


ProcessCreate     fxdnoise_superwrap_create;
ProcessInitialize fxdnoise_superwrap_init;
ProcessUpdate     fxdnoise_superwrap_update;
ProcessOneset     fxdnoise_superwrap_oneset;
ProcessTwosets    fxdnoise_superwrap_twosets;
ProcessWrapup     fxdnoise_superwrap_wrapup;
ProcessDelete     fxdnoise_superwrap_delete;


void superwrap_fxdnoise_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fxdnoise_superwrap_create;
  THIS->initialize = fxdnoise_superwrap_init;
  THIS->update     = fxdnoise_superwrap_update;
  THIS->oneset     = fxdnoise_superwrap_oneset;
  THIS->twosets    = fxdnoise_superwrap_twosets;
  THIS->wrapup     = fxdnoise_superwrap_wrapup;
  THIS->delete     = fxdnoise_superwrap_delete;
}


/*------------------------------- FKINTERP -------------------------------*/
/*------------------------------- FKINTERP -------------------------------*/
/*------------------------------- FKINTERP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fkinterp_superwrap_create            fkinterp_superwrap_create_
#define fkinterp_superwrap_init              fkinterp_superwrap_init_
#define fkinterp_superwrap_update            fkinterp_superwrap_update_
#define fkinterp_superwrap_oneset            fkinterp_superwrap_oneset_ 
#define fkinterp_superwrap_twosets           fkinterp_superwrap_twosets_
#define fkinterp_superwrap_wrapup            fkinterp_superwrap_wrapup_
#define fkinterp_superwrap_delete            fkinterp_superwrap_delete_
#elif defined NEED_CAPITALS
#define fkinterp_superwrap_create            FKINTERP_SUPERWRAP_CREATE
#define fkinterp_superwrap_init              FKINTERP_SUPERWRAP_INIT
#define fkinterp_superwrap_update            FKINTERP_SUPERWRAP_UPDATE
#define fkinterp_superwrap_oneset            FKINTERP_SUPERWRAP_ONESET 
#define fkinterp_superwrap_twosets           FKINTERP_SUPERWRAP_TWOSETS
#define fkinterp_superwrap_wrapup            FKINTERP_SUPERWRAP_WRAPUP
#define fkinterp_superwrap_delete            FKINTERP_SUPERWRAP_DELETE
#endif


ProcessCreate     fkinterp_superwrap_create;
ProcessInitialize fkinterp_superwrap_init;
ProcessUpdate     fkinterp_superwrap_update;
ProcessOneset     fkinterp_superwrap_oneset;
ProcessTwosets    fkinterp_superwrap_twosets;
ProcessWrapup     fkinterp_superwrap_wrapup;
ProcessDelete     fkinterp_superwrap_delete;


void superwrap_fkinterp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fkinterp_superwrap_create;
  THIS->initialize = fkinterp_superwrap_init;
  THIS->update     = fkinterp_superwrap_update;
  THIS->oneset     = fkinterp_superwrap_oneset;
  THIS->twosets    = fkinterp_superwrap_twosets;
  THIS->wrapup     = fkinterp_superwrap_wrapup;
  THIS->delete     = fkinterp_superwrap_delete;
}




/*------------------------------- FXINTERP -------------------------------*/
/*------------------------------- FXINTERP -------------------------------*/
/*------------------------------- FXINTERP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define fxinterp_superwrap_create            fxinterp_superwrap_create_
#define fxinterp_superwrap_init              fxinterp_superwrap_init_
#define fxinterp_superwrap_update            fxinterp_superwrap_update_
#define fxinterp_superwrap_oneset            fxinterp_superwrap_oneset_ 
#define fxinterp_superwrap_twosets           fxinterp_superwrap_twosets_
#define fxinterp_superwrap_wrapup            fxinterp_superwrap_wrapup_
#define fxinterp_superwrap_delete            fxinterp_superwrap_delete_
#elif defined NEED_CAPITALS
#define fxinterp_superwrap_create            FXINTERP_SUPERWRAP_CREATE
#define fxinterp_superwrap_init              FXINTERP_SUPERWRAP_INIT
#define fxinterp_superwrap_update            FXINTERP_SUPERWRAP_UPDATE
#define fxinterp_superwrap_oneset            FXINTERP_SUPERWRAP_ONESET 
#define fxinterp_superwrap_twosets           FXINTERP_SUPERWRAP_TWOSETS
#define fxinterp_superwrap_wrapup            FXINTERP_SUPERWRAP_WRAPUP
#define fxinterp_superwrap_delete            FXINTERP_SUPERWRAP_DELETE
#endif


ProcessCreate     fxinterp_superwrap_create;
ProcessInitialize fxinterp_superwrap_init;
ProcessUpdate     fxinterp_superwrap_update;
ProcessOneset     fxinterp_superwrap_oneset;
ProcessTwosets    fxinterp_superwrap_twosets;
ProcessWrapup     fxinterp_superwrap_wrapup;
ProcessDelete     fxinterp_superwrap_delete;


void superwrap_fxinterp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = fxinterp_superwrap_create;
  THIS->initialize = fxinterp_superwrap_init;
  THIS->update     = fxinterp_superwrap_update;
  THIS->oneset     = fxinterp_superwrap_oneset;
  THIS->twosets    = fxinterp_superwrap_twosets;
  THIS->wrapup     = fxinterp_superwrap_wrapup;
  THIS->delete     = fxinterp_superwrap_delete;
}



/*------------------------------- GATHER -------------------------------*/
/*------------------------------- GATHER -------------------------------*/
/*------------------------------- GATHER -------------------------------*/


#ifdef NEED_UNDERSCORE
#define gather_superwrap_create            gather_superwrap_create_
#define gather_superwrap_init              gather_superwrap_init_
#define gather_superwrap_update            gather_superwrap_update_
#define gather_superwrap_oneset            gather_superwrap_oneset_ 
#define gather_superwrap_twosets           gather_superwrap_twosets_
#define gather_superwrap_wrapup            gather_superwrap_wrapup_
#define gather_superwrap_delete            gather_superwrap_delete_
#elif defined NEED_CAPITALS
#define gather_superwrap_create            GATHER_SUPERWRAP_CREATE
#define gather_superwrap_init              GATHER_SUPERWRAP_INIT
#define gather_superwrap_update            GATHER_SUPERWRAP_UPDATE
#define gather_superwrap_oneset            GATHER_SUPERWRAP_ONESET 
#define gather_superwrap_twosets           GATHER_SUPERWRAP_TWOSETS
#define gather_superwrap_wrapup            GATHER_SUPERWRAP_WRAPUP
#define gather_superwrap_delete            GATHER_SUPERWRAP_DELETE
#endif


ProcessCreate     gather_superwrap_create;
ProcessInitialize gather_superwrap_init;
ProcessUpdate     gather_superwrap_update;
ProcessOneset     gather_superwrap_oneset;
ProcessTwosets    gather_superwrap_twosets;
ProcessWrapup     gather_superwrap_wrapup;
ProcessDelete     gather_superwrap_delete;


void superwrap_gather_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = gather_superwrap_create;
  THIS->initialize = gather_superwrap_init;
  THIS->update     = gather_superwrap_update;
  THIS->oneset     = gather_superwrap_oneset;
  THIS->twosets    = gather_superwrap_twosets;
  THIS->wrapup     = gather_superwrap_wrapup;
  THIS->delete     = gather_superwrap_delete;
}



/*------------------------------- GDIV -------------------------------*/
/*------------------------------- GDIV -------------------------------*/
/*------------------------------- GDIV -------------------------------*/


#ifdef NEED_UNDERSCORE
#define gdiv_superwrap_create            gdiv_superwrap_create_
#define gdiv_superwrap_init              gdiv_superwrap_init_
#define gdiv_superwrap_update            gdiv_superwrap_update_
#define gdiv_superwrap_oneset            gdiv_superwrap_oneset_ 
#define gdiv_superwrap_twosets           gdiv_superwrap_twosets_
#define gdiv_superwrap_wrapup            gdiv_superwrap_wrapup_
#define gdiv_superwrap_delete            gdiv_superwrap_delete_
#elif defined NEED_CAPITALS
#define gdiv_superwrap_create            GDIV_SUPERWRAP_CREATE
#define gdiv_superwrap_init              GDIV_SUPERWRAP_INIT
#define gdiv_superwrap_update            GDIV_SUPERWRAP_UPDATE
#define gdiv_superwrap_oneset            GDIV_SUPERWRAP_ONESET 
#define gdiv_superwrap_twosets           GDIV_SUPERWRAP_TWOSETS
#define gdiv_superwrap_wrapup            GDIV_SUPERWRAP_WRAPUP
#define gdiv_superwrap_delete            GDIV_SUPERWRAP_DELETE
#endif


ProcessCreate     gdiv_superwrap_create;
ProcessInitialize gdiv_superwrap_init;
ProcessUpdate     gdiv_superwrap_update;
ProcessOneset     gdiv_superwrap_oneset;
ProcessTwosets    gdiv_superwrap_twosets;
ProcessWrapup     gdiv_superwrap_wrapup;
ProcessDelete     gdiv_superwrap_delete;


void superwrap_gdiv_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = gdiv_superwrap_create;
  THIS->initialize = gdiv_superwrap_init;
  THIS->update     = gdiv_superwrap_update;
  THIS->oneset     = gdiv_superwrap_oneset;
  THIS->twosets    = gdiv_superwrap_twosets;
  THIS->wrapup     = gdiv_superwrap_wrapup;
  THIS->delete     = gdiv_superwrap_delete;
}



/*------------------------------- GENFILT -------------------------------*/
/*------------------------------- GENFILT -------------------------------*/
/*------------------------------- GENFILT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define genfilt_superwrap_create            genfilt_superwrap_create_
#define genfilt_superwrap_init              genfilt_superwrap_init_
#define genfilt_superwrap_update            genfilt_superwrap_update_
#define genfilt_superwrap_oneset            genfilt_superwrap_oneset_ 
#define genfilt_superwrap_twosets           genfilt_superwrap_twosets_
#define genfilt_superwrap_wrapup            genfilt_superwrap_wrapup_
#define genfilt_superwrap_delete            genfilt_superwrap_delete_
#elif defined NEED_CAPITALS
#define genfilt_superwrap_create            GENFILT_SUPERWRAP_CREATE
#define genfilt_superwrap_init              GENFILT_SUPERWRAP_INIT
#define genfilt_superwrap_update            GENFILT_SUPERWRAP_UPDATE
#define genfilt_superwrap_oneset            GENFILT_SUPERWRAP_ONESET 
#define genfilt_superwrap_twosets           GENFILT_SUPERWRAP_TWOSETS
#define genfilt_superwrap_wrapup            GENFILT_SUPERWRAP_WRAPUP
#define genfilt_superwrap_delete            GENFILT_SUPERWRAP_DELETE
#endif


ProcessCreate     genfilt_superwrap_create;
ProcessInitialize genfilt_superwrap_init;
ProcessUpdate     genfilt_superwrap_update;
ProcessOneset     genfilt_superwrap_oneset;
ProcessTwosets    genfilt_superwrap_twosets;
ProcessWrapup     genfilt_superwrap_wrapup;
ProcessDelete     genfilt_superwrap_delete;


void superwrap_genfilt_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = genfilt_superwrap_create;
  THIS->initialize = genfilt_superwrap_init;
  THIS->update     = genfilt_superwrap_update;
  THIS->oneset     = genfilt_superwrap_oneset;
  THIS->twosets    = genfilt_superwrap_twosets;
  THIS->wrapup     = genfilt_superwrap_wrapup;
  THIS->delete     = genfilt_superwrap_delete;
}



/*------------------------------- GRAB -------------------------------*/
/*------------------------------- GRAB -------------------------------*/
/*------------------------------- GRAB -------------------------------*/


#ifdef NEED_UNDERSCORE
#define grab_superwrap_create            grab_superwrap_create_
#define grab_superwrap_init              grab_superwrap_init_
#define grab_superwrap_update            grab_superwrap_update_
#define grab_superwrap_oneset            grab_superwrap_oneset_ 
#define grab_superwrap_twosets           grab_superwrap_twosets_
#define grab_superwrap_wrapup            grab_superwrap_wrapup_
#define grab_superwrap_delete            grab_superwrap_delete_
#elif defined NEED_CAPITALS
#define grab_superwrap_create            GRAB_SUPERWRAP_CREATE
#define grab_superwrap_init              GRAB_SUPERWRAP_INIT
#define grab_superwrap_update            GRAB_SUPERWRAP_UPDATE
#define grab_superwrap_oneset            GRAB_SUPERWRAP_ONESET 
#define grab_superwrap_twosets           GRAB_SUPERWRAP_TWOSETS
#define grab_superwrap_wrapup            GRAB_SUPERWRAP_WRAPUP
#define grab_superwrap_delete            GRAB_SUPERWRAP_DELETE
#endif


ProcessCreate     grab_superwrap_create;
ProcessInitialize grab_superwrap_init;
ProcessUpdate     grab_superwrap_update;
ProcessOneset     grab_superwrap_oneset;
ProcessTwosets    grab_superwrap_twosets;
ProcessWrapup     grab_superwrap_wrapup;
ProcessDelete     grab_superwrap_delete;


void superwrap_grab_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = grab_superwrap_create;
  THIS->initialize = grab_superwrap_init;
  THIS->update     = grab_superwrap_update;
  THIS->oneset     = grab_superwrap_oneset;
  THIS->twosets    = grab_superwrap_twosets;
  THIS->wrapup     = grab_superwrap_wrapup;
  THIS->delete     = grab_superwrap_delete;
}



/*------------------------------- GSTACK -------------------------------*/
/*------------------------------- GSTACK -------------------------------*/
/*------------------------------- GSTACK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define gstack_superwrap_create            gstack_superwrap_create_
#define gstack_superwrap_init              gstack_superwrap_init_
#define gstack_superwrap_update            gstack_superwrap_update_
#define gstack_superwrap_oneset            gstack_superwrap_oneset_ 
#define gstack_superwrap_twosets           gstack_superwrap_twosets_
#define gstack_superwrap_wrapup            gstack_superwrap_wrapup_
#define gstack_superwrap_delete            gstack_superwrap_delete_
#elif defined NEED_CAPITALS
#define gstack_superwrap_create            GSTACK_SUPERWRAP_CREATE
#define gstack_superwrap_init              GSTACK_SUPERWRAP_INIT
#define gstack_superwrap_update            GSTACK_SUPERWRAP_UPDATE
#define gstack_superwrap_oneset            GSTACK_SUPERWRAP_ONESET 
#define gstack_superwrap_twosets           GSTACK_SUPERWRAP_TWOSETS
#define gstack_superwrap_wrapup            GSTACK_SUPERWRAP_WRAPUP
#define gstack_superwrap_delete            GSTACK_SUPERWRAP_DELETE
#endif


ProcessCreate     gstack_superwrap_create;
ProcessInitialize gstack_superwrap_init;
ProcessUpdate     gstack_superwrap_update;
ProcessOneset     gstack_superwrap_oneset;
ProcessTwosets    gstack_superwrap_twosets;
ProcessWrapup     gstack_superwrap_wrapup;
ProcessDelete     gstack_superwrap_delete;


void superwrap_gstack_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = gstack_superwrap_create;
  THIS->initialize = gstack_superwrap_init;
  THIS->update     = gstack_superwrap_update;
  THIS->oneset     = gstack_superwrap_oneset;
  THIS->twosets    = gstack_superwrap_twosets;
  THIS->wrapup     = gstack_superwrap_wrapup;
  THIS->delete     = gstack_superwrap_delete;
}



/*------------------------------- GSTK -------------------------------*/
/*------------------------------- GSTK -------------------------------*/
/*------------------------------- GSTK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define gstk_superwrap_create            gstk_superwrap_create_
#define gstk_superwrap_init              gstk_superwrap_init_
#define gstk_superwrap_update            gstk_superwrap_update_
#define gstk_superwrap_oneset            gstk_superwrap_oneset_ 
#define gstk_superwrap_twosets           gstk_superwrap_twosets_
#define gstk_superwrap_wrapup            gstk_superwrap_wrapup_
#define gstk_superwrap_delete            gstk_superwrap_delete_
#elif defined NEED_CAPITALS
#define gstk_superwrap_create            GSTK_SUPERWRAP_CREATE
#define gstk_superwrap_init              GSTK_SUPERWRAP_INIT
#define gstk_superwrap_update            GSTK_SUPERWRAP_UPDATE
#define gstk_superwrap_oneset            GSTK_SUPERWRAP_ONESET 
#define gstk_superwrap_twosets           GSTK_SUPERWRAP_TWOSETS
#define gstk_superwrap_wrapup            GSTK_SUPERWRAP_WRAPUP
#define gstk_superwrap_delete            GSTK_SUPERWRAP_DELETE
#endif


ProcessCreate     gstk_superwrap_create;
ProcessInitialize gstk_superwrap_init;
ProcessUpdate     gstk_superwrap_update;
ProcessOneset     gstk_superwrap_oneset;
ProcessTwosets    gstk_superwrap_twosets;
ProcessWrapup     gstk_superwrap_wrapup;
ProcessDelete     gstk_superwrap_delete;


void superwrap_gstk_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = gstk_superwrap_create;
  THIS->initialize = gstk_superwrap_init;
  THIS->update     = gstk_superwrap_update;
  THIS->oneset     = gstk_superwrap_oneset;
  THIS->twosets    = gstk_superwrap_twosets;
  THIS->wrapup     = gstk_superwrap_wrapup;
  THIS->delete     = gstk_superwrap_delete;
}



/*------------------------------- GVS -------------------------------*/
/*------------------------------- GVS -------------------------------*/
/*------------------------------- GVS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define gvs_superwrap_create            gvs_superwrap_create_
#define gvs_superwrap_init              gvs_superwrap_init_
#define gvs_superwrap_update            gvs_superwrap_update_
#define gvs_superwrap_oneset            gvs_superwrap_oneset_ 
#define gvs_superwrap_twosets           gvs_superwrap_twosets_
#define gvs_superwrap_wrapup            gvs_superwrap_wrapup_
#define gvs_superwrap_delete            gvs_superwrap_delete_
#elif defined NEED_CAPITALS
#define gvs_superwrap_create            GVS_SUPERWRAP_CREATE
#define gvs_superwrap_init              GVS_SUPERWRAP_INIT
#define gvs_superwrap_update            GVS_SUPERWRAP_UPDATE
#define gvs_superwrap_oneset            GVS_SUPERWRAP_ONESET 
#define gvs_superwrap_twosets           GVS_SUPERWRAP_TWOSETS
#define gvs_superwrap_wrapup            GVS_SUPERWRAP_WRAPUP
#define gvs_superwrap_delete            GVS_SUPERWRAP_DELETE
#endif


ProcessCreate     gvs_superwrap_create;
ProcessInitialize gvs_superwrap_init;
ProcessUpdate     gvs_superwrap_update;
ProcessOneset     gvs_superwrap_oneset;
ProcessTwosets    gvs_superwrap_twosets;
ProcessWrapup     gvs_superwrap_wrapup;
ProcessDelete     gvs_superwrap_delete;


void superwrap_gvs_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = gvs_superwrap_create;
  THIS->initialize = gvs_superwrap_init;
  THIS->update     = gvs_superwrap_update;
  THIS->oneset     = gvs_superwrap_oneset;
  THIS->twosets    = gvs_superwrap_twosets;
  THIS->wrapup     = gvs_superwrap_wrapup;
  THIS->delete     = gvs_superwrap_delete;
}



/*------------------------------- HEADCHECK -------------------------------*/
/*------------------------------- HEADCHECK -------------------------------*/
/*------------------------------- HEADCHECK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define headcheck_superwrap_create            headcheck_superwrap_create_
#define headcheck_superwrap_init              headcheck_superwrap_init_
#define headcheck_superwrap_update            headcheck_superwrap_update_
#define headcheck_superwrap_oneset            headcheck_superwrap_oneset_ 
#define headcheck_superwrap_twosets           headcheck_superwrap_twosets_
#define headcheck_superwrap_wrapup            headcheck_superwrap_wrapup_
#define headcheck_superwrap_delete            headcheck_superwrap_delete_
#elif defined NEED_CAPITALS
#define headcheck_superwrap_create            HEADCHECK_SUPERWRAP_CREATE
#define headcheck_superwrap_init              HEADCHECK_SUPERWRAP_INIT
#define headcheck_superwrap_update            HEADCHECK_SUPERWRAP_UPDATE
#define headcheck_superwrap_oneset            HEADCHECK_SUPERWRAP_ONESET 
#define headcheck_superwrap_twosets           HEADCHECK_SUPERWRAP_TWOSETS
#define headcheck_superwrap_wrapup            HEADCHECK_SUPERWRAP_WRAPUP
#define headcheck_superwrap_delete            HEADCHECK_SUPERWRAP_DELETE
#endif


ProcessCreate     headcheck_superwrap_create;
ProcessInitialize headcheck_superwrap_init;
ProcessUpdate     headcheck_superwrap_update;
ProcessOneset     headcheck_superwrap_oneset;
ProcessTwosets    headcheck_superwrap_twosets;
ProcessWrapup     headcheck_superwrap_wrapup;
ProcessDelete     headcheck_superwrap_delete;


void superwrap_headcheck_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = headcheck_superwrap_create;
  THIS->initialize = headcheck_superwrap_init;
  THIS->update     = headcheck_superwrap_update;
  THIS->oneset     = headcheck_superwrap_oneset;
  THIS->twosets    = headcheck_superwrap_twosets;
  THIS->wrapup     = headcheck_superwrap_wrapup;
  THIS->delete     = headcheck_superwrap_delete;
}



/*------------------------------- HEADFIT -------------------------------*/
/*------------------------------- HEADFIT -------------------------------*/
/*------------------------------- HEADFIT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define headfit_superwrap_create            headfit_superwrap_create_
#define headfit_superwrap_init              headfit_superwrap_init_
#define headfit_superwrap_update            headfit_superwrap_update_
#define headfit_superwrap_oneset            headfit_superwrap_oneset_ 
#define headfit_superwrap_twosets           headfit_superwrap_twosets_
#define headfit_superwrap_wrapup            headfit_superwrap_wrapup_
#define headfit_superwrap_delete            headfit_superwrap_delete_
#elif defined NEED_CAPITALS
#define headfit_superwrap_create            HEADFIT_SUPERWRAP_CREATE
#define headfit_superwrap_init              HEADFIT_SUPERWRAP_INIT
#define headfit_superwrap_update            HEADFIT_SUPERWRAP_UPDATE
#define headfit_superwrap_oneset            HEADFIT_SUPERWRAP_ONESET 
#define headfit_superwrap_twosets           HEADFIT_SUPERWRAP_TWOSETS
#define headfit_superwrap_wrapup            HEADFIT_SUPERWRAP_WRAPUP
#define headfit_superwrap_delete            HEADFIT_SUPERWRAP_DELETE
#endif


ProcessCreate     headfit_superwrap_create;
ProcessInitialize headfit_superwrap_init;
ProcessUpdate     headfit_superwrap_update;
ProcessOneset     headfit_superwrap_oneset;
ProcessTwosets    headfit_superwrap_twosets;
ProcessWrapup     headfit_superwrap_wrapup;
ProcessDelete     headfit_superwrap_delete;


void superwrap_headfit_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = headfit_superwrap_create;
  THIS->initialize = headfit_superwrap_init;
  THIS->update     = headfit_superwrap_update;
  THIS->oneset     = headfit_superwrap_oneset;
  THIS->twosets    = headfit_superwrap_twosets;
  THIS->wrapup     = headfit_superwrap_wrapup;
  THIS->delete     = headfit_superwrap_delete;
}


/*------------------------------- HEADMAP -------------------------------*/
/*------------------------------- HEADMAP -------------------------------*/
/*------------------------------- HEADMAP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define headmap_superwrap_create            headmap_superwrap_create_
#define headmap_superwrap_init              headmap_superwrap_init_
#define headmap_superwrap_update            headmap_superwrap_update_
#define headmap_superwrap_oneset            headmap_superwrap_oneset_ 
#define headmap_superwrap_twosets           headmap_superwrap_twosets_
#define headmap_superwrap_wrapup            headmap_superwrap_wrapup_
#define headmap_superwrap_delete            headmap_superwrap_delete_
#elif defined NEED_CAPITALS
#define headmap_superwrap_create            HEADMAP_SUPERWRAP_CREATE
#define headmap_superwrap_init              HEADMAP_SUPERWRAP_INIT
#define headmap_superwrap_update            HEADMAP_SUPERWRAP_UPDATE
#define headmap_superwrap_oneset            HEADMAP_SUPERWRAP_ONESET 
#define headmap_superwrap_twosets           HEADMAP_SUPERWRAP_TWOSETS
#define headmap_superwrap_wrapup            HEADMAP_SUPERWRAP_WRAPUP
#define headmap_superwrap_delete            HEADMAP_SUPERWRAP_DELETE
#endif


ProcessCreate     headmap_superwrap_create;
ProcessInitialize headmap_superwrap_init;
ProcessUpdate     headmap_superwrap_update;
ProcessOneset     headmap_superwrap_oneset;
ProcessTwosets    headmap_superwrap_twosets;
ProcessWrapup     headmap_superwrap_wrapup;
ProcessDelete     headmap_superwrap_delete;


void superwrap_headmap_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = headmap_superwrap_create;
  THIS->initialize = headmap_superwrap_init;
  THIS->update     = headmap_superwrap_update;
  THIS->oneset     = headmap_superwrap_oneset;
  THIS->twosets    = headmap_superwrap_twosets;
  THIS->wrapup     = headmap_superwrap_wrapup;
  THIS->delete     = headmap_superwrap_delete;
}



/*------------------------------- HEADSUM -------------------------------*/
/*------------------------------- HEADSUM -------------------------------*/
/*------------------------------- HEADSUM -------------------------------*/


#ifdef NEED_UNDERSCORE
#define headsum_superwrap_create            headsum_superwrap_create_
#define headsum_superwrap_init              headsum_superwrap_init_
#define headsum_superwrap_update            headsum_superwrap_update_
#define headsum_superwrap_oneset            headsum_superwrap_oneset_ 
#define headsum_superwrap_twosets           headsum_superwrap_twosets_
#define headsum_superwrap_wrapup            headsum_superwrap_wrapup_
#define headsum_superwrap_delete            headsum_superwrap_delete_
#elif defined NEED_CAPITALS
#define headsum_superwrap_create            HEADSUM_SUPERWRAP_CREATE
#define headsum_superwrap_init              HEADSUM_SUPERWRAP_INIT
#define headsum_superwrap_update            HEADSUM_SUPERWRAP_UPDATE
#define headsum_superwrap_oneset            HEADSUM_SUPERWRAP_ONESET 
#define headsum_superwrap_twosets           HEADSUM_SUPERWRAP_TWOSETS
#define headsum_superwrap_wrapup            HEADSUM_SUPERWRAP_WRAPUP
#define headsum_superwrap_delete            HEADSUM_SUPERWRAP_DELETE
#endif


ProcessCreate     headsum_superwrap_create;
ProcessInitialize headsum_superwrap_init;
ProcessUpdate     headsum_superwrap_update;
ProcessOneset     headsum_superwrap_oneset;
ProcessTwosets    headsum_superwrap_twosets;
ProcessWrapup     headsum_superwrap_wrapup;
ProcessDelete     headsum_superwrap_delete;


void superwrap_headsum_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = headsum_superwrap_create;
  THIS->initialize = headsum_superwrap_init;
  THIS->update     = headsum_superwrap_update;
  THIS->oneset     = headsum_superwrap_oneset;
  THIS->twosets    = headsum_superwrap_twosets;
  THIS->wrapup     = headsum_superwrap_wrapup;
  THIS->delete     = headsum_superwrap_delete;
}



/*------------------------------- HEADSWAP -------------------------------*/
/*------------------------------- HEADSWAP -------------------------------*/
/*------------------------------- HEADSWAP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define headswap_superwrap_create            headswap_superwrap_create_
#define headswap_superwrap_init              headswap_superwrap_init_
#define headswap_superwrap_update            headswap_superwrap_update_
#define headswap_superwrap_oneset            headswap_superwrap_oneset_ 
#define headswap_superwrap_twosets           headswap_superwrap_twosets_
#define headswap_superwrap_wrapup            headswap_superwrap_wrapup_
#define headswap_superwrap_delete            headswap_superwrap_delete_
#elif defined NEED_CAPITALS
#define headswap_superwrap_create            HEADSWAP_SUPERWRAP_CREATE
#define headswap_superwrap_init              HEADSWAP_SUPERWRAP_INIT
#define headswap_superwrap_update            HEADSWAP_SUPERWRAP_UPDATE
#define headswap_superwrap_oneset            HEADSWAP_SUPERWRAP_ONESET 
#define headswap_superwrap_twosets           HEADSWAP_SUPERWRAP_TWOSETS
#define headswap_superwrap_wrapup            HEADSWAP_SUPERWRAP_WRAPUP
#define headswap_superwrap_delete            HEADSWAP_SUPERWRAP_DELETE
#endif


ProcessCreate     headswap_superwrap_create;
ProcessInitialize headswap_superwrap_init;
ProcessUpdate     headswap_superwrap_update;
ProcessOneset     headswap_superwrap_oneset;
ProcessTwosets    headswap_superwrap_twosets;
ProcessWrapup     headswap_superwrap_wrapup;
ProcessDelete     headswap_superwrap_delete;


void superwrap_headswap_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = headswap_superwrap_create;
  THIS->initialize = headswap_superwrap_init;
  THIS->update     = headswap_superwrap_update;
  THIS->oneset     = headswap_superwrap_oneset;
  THIS->twosets    = headswap_superwrap_twosets;
  THIS->wrapup     = headswap_superwrap_wrapup;
  THIS->delete     = headswap_superwrap_delete;
}



/*------------------------------- HRZSTK -------------------------------*/
/*------------------------------- HRZSTK -------------------------------*/
/*------------------------------- HRZSTK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define hrzstk_superwrap_create            hrzstk_superwrap_create_
#define hrzstk_superwrap_init              hrzstk_superwrap_init_
#define hrzstk_superwrap_update            hrzstk_superwrap_update_
#define hrzstk_superwrap_oneset            hrzstk_superwrap_oneset_ 
#define hrzstk_superwrap_twosets           hrzstk_superwrap_twosets_
#define hrzstk_superwrap_wrapup            hrzstk_superwrap_wrapup_
#define hrzstk_superwrap_delete            hrzstk_superwrap_delete_
#elif defined NEED_CAPITALS
#define hrzstk_superwrap_create            HRZSTK_SUPERWRAP_CREATE
#define hrzstk_superwrap_init              HRZSTK_SUPERWRAP_INIT
#define hrzstk_superwrap_update            HRZSTK_SUPERWRAP_UPDATE
#define hrzstk_superwrap_oneset            HRZSTK_SUPERWRAP_ONESET 
#define hrzstk_superwrap_twosets           HRZSTK_SUPERWRAP_TWOSETS
#define hrzstk_superwrap_wrapup            HRZSTK_SUPERWRAP_WRAPUP
#define hrzstk_superwrap_delete            HRZSTK_SUPERWRAP_DELETE
#endif


ProcessCreate     hrzstk_superwrap_create;
ProcessInitialize hrzstk_superwrap_init;
ProcessUpdate     hrzstk_superwrap_update;
ProcessOneset     hrzstk_superwrap_oneset;
ProcessTwosets    hrzstk_superwrap_twosets;
ProcessWrapup     hrzstk_superwrap_wrapup;
ProcessDelete     hrzstk_superwrap_delete;


void superwrap_hrzstk_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = hrzstk_superwrap_create;
  THIS->initialize = hrzstk_superwrap_init;
  THIS->update     = hrzstk_superwrap_update;
  THIS->oneset     = hrzstk_superwrap_oneset;
  THIS->twosets    = hrzstk_superwrap_twosets;
  THIS->wrapup     = hrzstk_superwrap_wrapup;
  THIS->delete     = hrzstk_superwrap_delete;
}



/*------------------------------- HSYN -------------------------------*/
/*------------------------------- HSYN -------------------------------*/
/*------------------------------- HSYN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define hsyn_superwrap_create            hsyn_superwrap_create_
#define hsyn_superwrap_init              hsyn_superwrap_init_
#define hsyn_superwrap_update            hsyn_superwrap_update_
#define hsyn_superwrap_oneset            hsyn_superwrap_oneset_ 
#define hsyn_superwrap_twosets           hsyn_superwrap_twosets_
#define hsyn_superwrap_wrapup            hsyn_superwrap_wrapup_
#define hsyn_superwrap_delete            hsyn_superwrap_delete_
#elif defined NEED_CAPITALS
#define hsyn_superwrap_create            HSYN_SUPERWRAP_CREATE
#define hsyn_superwrap_init              HSYN_SUPERWRAP_INIT
#define hsyn_superwrap_update            HSYN_SUPERWRAP_UPDATE
#define hsyn_superwrap_oneset            HSYN_SUPERWRAP_ONESET 
#define hsyn_superwrap_twosets           HSYN_SUPERWRAP_TWOSETS
#define hsyn_superwrap_wrapup            HSYN_SUPERWRAP_WRAPUP
#define hsyn_superwrap_delete            HSYN_SUPERWRAP_DELETE
#endif


ProcessCreate     hsyn_superwrap_create;
ProcessInitialize hsyn_superwrap_init;
ProcessUpdate     hsyn_superwrap_update;
ProcessOneset     hsyn_superwrap_oneset;
ProcessTwosets    hsyn_superwrap_twosets;
ProcessWrapup     hsyn_superwrap_wrapup;
ProcessDelete     hsyn_superwrap_delete;


void superwrap_hsyn_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = hsyn_superwrap_create;
  THIS->initialize = hsyn_superwrap_init;
  THIS->update     = hsyn_superwrap_update;
  THIS->oneset     = hsyn_superwrap_oneset;
  THIS->twosets    = hsyn_superwrap_twosets;
  THIS->wrapup     = hsyn_superwrap_wrapup;
  THIS->delete     = hsyn_superwrap_delete;
}



/*------------------------------- HSYNMOD -------------------------------*/
/*------------------------------- HSYNMOD -------------------------------*/
/*------------------------------- HSYNMOD -------------------------------*/


#ifdef NEED_UNDERSCORE
#define hsynmod_superwrap_create            hsynmod_superwrap_create_
#define hsynmod_superwrap_init              hsynmod_superwrap_init_
#define hsynmod_superwrap_update            hsynmod_superwrap_update_
#define hsynmod_superwrap_oneset            hsynmod_superwrap_oneset_ 
#define hsynmod_superwrap_twosets           hsynmod_superwrap_twosets_
#define hsynmod_superwrap_wrapup            hsynmod_superwrap_wrapup_
#define hsynmod_superwrap_delete            hsynmod_superwrap_delete_
#elif defined NEED_CAPITALS
#define hsynmod_superwrap_create            HSYNMOD_SUPERWRAP_CREATE
#define hsynmod_superwrap_init              HSYNMOD_SUPERWRAP_INIT
#define hsynmod_superwrap_update            HSYNMOD_SUPERWRAP_UPDATE
#define hsynmod_superwrap_oneset            HSYNMOD_SUPERWRAP_ONESET 
#define hsynmod_superwrap_twosets           HSYNMOD_SUPERWRAP_TWOSETS
#define hsynmod_superwrap_wrapup            HSYNMOD_SUPERWRAP_WRAPUP
#define hsynmod_superwrap_delete            HSYNMOD_SUPERWRAP_DELETE
#endif


ProcessCreate     hsynmod_superwrap_create;
ProcessInitialize hsynmod_superwrap_init;
ProcessUpdate     hsynmod_superwrap_update;
ProcessOneset     hsynmod_superwrap_oneset;
ProcessTwosets    hsynmod_superwrap_twosets;
ProcessWrapup     hsynmod_superwrap_wrapup;
ProcessDelete     hsynmod_superwrap_delete;


void superwrap_hsynmod_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = hsynmod_superwrap_create;
  THIS->initialize = hsynmod_superwrap_init;
  THIS->update     = hsynmod_superwrap_update;
  THIS->oneset     = hsynmod_superwrap_oneset;
  THIS->twosets    = hsynmod_superwrap_twosets;
  THIS->wrapup     = hsynmod_superwrap_wrapup;
  THIS->delete     = hsynmod_superwrap_delete;
}



/*------------------------------- HVEL -------------------------------*/
/*------------------------------- HVEL -------------------------------*/
/*------------------------------- HVEL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define hvel_superwrap_create            hvel_superwrap_create_
#define hvel_superwrap_init              hvel_superwrap_init_
#define hvel_superwrap_update            hvel_superwrap_update_
#define hvel_superwrap_oneset            hvel_superwrap_oneset_ 
#define hvel_superwrap_twosets           hvel_superwrap_twosets_
#define hvel_superwrap_wrapup            hvel_superwrap_wrapup_
#define hvel_superwrap_delete            hvel_superwrap_delete_
#elif defined NEED_CAPITALS
#define hvel_superwrap_create            HVEL_SUPERWRAP_CREATE
#define hvel_superwrap_init              HVEL_SUPERWRAP_INIT
#define hvel_superwrap_update            HVEL_SUPERWRAP_UPDATE
#define hvel_superwrap_oneset            HVEL_SUPERWRAP_ONESET 
#define hvel_superwrap_twosets           HVEL_SUPERWRAP_TWOSETS
#define hvel_superwrap_wrapup            HVEL_SUPERWRAP_WRAPUP
#define hvel_superwrap_delete            HVEL_SUPERWRAP_DELETE
#endif


ProcessCreate     hvel_superwrap_create;
ProcessInitialize hvel_superwrap_init;
ProcessUpdate     hvel_superwrap_update;
ProcessOneset     hvel_superwrap_oneset;
ProcessTwosets    hvel_superwrap_twosets;
ProcessWrapup     hvel_superwrap_wrapup;
ProcessDelete     hvel_superwrap_delete;


void superwrap_hvel_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = hvel_superwrap_create;
  THIS->initialize = hvel_superwrap_init;
  THIS->update     = hvel_superwrap_update;
  THIS->oneset     = hvel_superwrap_oneset;
  THIS->twosets    = hvel_superwrap_twosets;
  THIS->wrapup     = hvel_superwrap_wrapup;
  THIS->delete     = hvel_superwrap_delete;
}



/*------------------------------- IBSMA -------------------------------*/
/*------------------------------- IBSMA -------------------------------*/
/*------------------------------- IBSMA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ibsma_superwrap_create            ibsma_superwrap_create_
#define ibsma_superwrap_init              ibsma_superwrap_init_
#define ibsma_superwrap_update            ibsma_superwrap_update_
#define ibsma_superwrap_oneset            ibsma_superwrap_oneset_ 
#define ibsma_superwrap_twosets           ibsma_superwrap_twosets_
#define ibsma_superwrap_wrapup            ibsma_superwrap_wrapup_
#define ibsma_superwrap_delete            ibsma_superwrap_delete_
#elif defined NEED_CAPITALS
#define ibsma_superwrap_create            IBSMA_SUPERWRAP_CREATE
#define ibsma_superwrap_init              IBSMA_SUPERWRAP_INIT
#define ibsma_superwrap_update            IBSMA_SUPERWRAP_UPDATE
#define ibsma_superwrap_oneset            IBSMA_SUPERWRAP_ONESET 
#define ibsma_superwrap_twosets           IBSMA_SUPERWRAP_TWOSETS
#define ibsma_superwrap_wrapup            IBSMA_SUPERWRAP_WRAPUP
#define ibsma_superwrap_delete            IBSMA_SUPERWRAP_DELETE
#endif


ProcessCreate     ibsma_superwrap_create;
ProcessInitialize ibsma_superwrap_init;
ProcessUpdate     ibsma_superwrap_update;
ProcessOneset     ibsma_superwrap_oneset;
ProcessTwosets    ibsma_superwrap_twosets;
ProcessWrapup     ibsma_superwrap_wrapup;
ProcessDelete     ibsma_superwrap_delete;


void superwrap_ibsma_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ibsma_superwrap_create;
  THIS->initialize = ibsma_superwrap_init;
  THIS->update     = ibsma_superwrap_update;
  THIS->oneset     = ibsma_superwrap_oneset;
  THIS->twosets    = ibsma_superwrap_twosets;
  THIS->wrapup     = ibsma_superwrap_wrapup;
  THIS->delete     = ibsma_superwrap_delete;
}



/*------------------------------- IMS -------------------------------*/
/*------------------------------- IMS -------------------------------*/
/*------------------------------- IMS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ims_superwrap_create            ims_superwrap_create_
#define ims_superwrap_init              ims_superwrap_init_
#define ims_superwrap_update            ims_superwrap_update_
#define ims_superwrap_oneset            ims_superwrap_oneset_ 
#define ims_superwrap_twosets           ims_superwrap_twosets_
#define ims_superwrap_wrapup            ims_superwrap_wrapup_
#define ims_superwrap_delete            ims_superwrap_delete_
#elif defined NEED_CAPITALS
#define ims_superwrap_create            IMS_SUPERWRAP_CREATE
#define ims_superwrap_init              IMS_SUPERWRAP_INIT
#define ims_superwrap_update            IMS_SUPERWRAP_UPDATE
#define ims_superwrap_oneset            IMS_SUPERWRAP_ONESET 
#define ims_superwrap_twosets           IMS_SUPERWRAP_TWOSETS
#define ims_superwrap_wrapup            IMS_SUPERWRAP_WRAPUP
#define ims_superwrap_delete            IMS_SUPERWRAP_DELETE
#endif


ProcessCreate     ims_superwrap_create;
ProcessInitialize ims_superwrap_init;
ProcessUpdate     ims_superwrap_update;
ProcessOneset     ims_superwrap_oneset;
ProcessTwosets    ims_superwrap_twosets;
ProcessWrapup     ims_superwrap_wrapup;
ProcessDelete     ims_superwrap_delete;


void superwrap_ims_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ims_superwrap_create;
  THIS->initialize = ims_superwrap_init;
  THIS->update     = ims_superwrap_update;
  THIS->oneset     = ims_superwrap_oneset;
  THIS->twosets    = ims_superwrap_twosets;
  THIS->wrapup     = ims_superwrap_wrapup;
  THIS->delete     = ims_superwrap_delete;
}



/*------------------------------- IQ -------------------------------*/
/*------------------------------- IQ -------------------------------*/
/*------------------------------- IQ -------------------------------*/


#ifdef NEED_UNDERSCORE
#define iq_superwrap_create            iq_superwrap_create_
#define iq_superwrap_init              iq_superwrap_init_
#define iq_superwrap_update            iq_superwrap_update_
#define iq_superwrap_oneset            iq_superwrap_oneset_ 
#define iq_superwrap_twosets           iq_superwrap_twosets_
#define iq_superwrap_wrapup            iq_superwrap_wrapup_
#define iq_superwrap_delete            iq_superwrap_delete_
#elif defined NEED_CAPITALS
#define iq_superwrap_create            IQ_SUPERWRAP_CREATE
#define iq_superwrap_init              IQ_SUPERWRAP_INIT
#define iq_superwrap_update            IQ_SUPERWRAP_UPDATE
#define iq_superwrap_oneset            IQ_SUPERWRAP_ONESET 
#define iq_superwrap_twosets           IQ_SUPERWRAP_TWOSETS
#define iq_superwrap_wrapup            IQ_SUPERWRAP_WRAPUP
#define iq_superwrap_delete            IQ_SUPERWRAP_DELETE
#endif


ProcessCreate     iq_superwrap_create;
ProcessInitialize iq_superwrap_init;
ProcessUpdate     iq_superwrap_update;
ProcessOneset     iq_superwrap_oneset;
ProcessTwosets    iq_superwrap_twosets;
ProcessWrapup     iq_superwrap_wrapup;
ProcessDelete     iq_superwrap_delete;


void superwrap_iq_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = iq_superwrap_create;
  THIS->initialize = iq_superwrap_init;
  THIS->update     = iq_superwrap_update;
  THIS->oneset     = iq_superwrap_oneset;
  THIS->twosets    = iq_superwrap_twosets;
  THIS->wrapup     = iq_superwrap_wrapup;
  THIS->delete     = iq_superwrap_delete;
}



/*------------------------------- integrate -------------------------------*/
/*------------------------------- integrate -------------------------------*/
/*------------------------------- integrate -------------------------------*/


#ifdef NEED_UNDERSCORE
#define integrate_superwrap_create            integrate_superwrap_create_
#define integrate_superwrap_init              integrate_superwrap_init_
#define integrate_superwrap_update            integrate_superwrap_update_
#define integrate_superwrap_oneset            integrate_superwrap_oneset_ 
#define integrate_superwrap_wrapup            integrate_superwrap_wrapup_
#define integrate_superwrap_delete            integrate_superwrap_delete_
#elif defined NEED_CAPITALS
#define integrate_superwrap_create            INTEGRATE_SUPERWRAP_CREATE
#define integrate_superwrap_init              INTEGRATE_SUPERWRAP_INIT
#define integrate_superwrap_update            INTEGRATE_SUPERWRAP_UPDATE
#define integrate_superwrap_oneset            INTEGRATE_SUPERWRAP_ONESET 
#define integrate_superwrap_wrapup            INTEGRATE_SUPERWRAP_WRAPUP
#define integrate_superwrap_delete            INTEGRATE_SUPERWRAP_DELETE
#endif


ProcessCreate     integrate_superwrap_create;
ProcessInitialize integrate_superwrap_init;
ProcessUpdate     integrate_superwrap_update;
ProcessOneset     integrate_superwrap_oneset;
ProcessWrapup     integrate_superwrap_wrapup;
ProcessDelete     integrate_superwrap_delete;


void superwrap_integrate_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = integrate_superwrap_create;
  THIS->initialize = integrate_superwrap_init;
  THIS->update     = integrate_superwrap_update;
  THIS->oneset     = integrate_superwrap_oneset;
  THIS->wrapup     = integrate_superwrap_wrapup;
  THIS->delete     = integrate_superwrap_delete;
}



/*------------------------------- wsep -------------------------------*/
/*------------------------------- wsep -------------------------------*/
/*------------------------------- wsep -------------------------------*/


#ifdef NEED_UNDERSCORE
#define wsep_superwrap_create            wsep_superwrap_create_
#define wsep_superwrap_init              wsep_superwrap_init_
#define wsep_superwrap_update            wsep_superwrap_update_
#define wsep_superwrap_oneset            wsep_superwrap_oneset_ 
#define wsep_superwrap_wrapup            wsep_superwrap_wrapup_
#define wsep_superwrap_delete            wsep_superwrap_delete_
#elif defined NEED_CAPITALS
#define wsep_superwrap_create            WSEP_SUPERWRAP_CREATE
#define wsep_superwrap_init              WSEP_SUPERWRAP_INIT
#define wsep_superwrap_update            WSEP_SUPERWRAP_UPDATE
#define wsep_superwrap_oneset            WSEP_SUPERWRAP_ONESET 
#define wsep_superwrap_wrapup            WSEP_SUPERWRAP_WRAPUP
#define wsep_superwrap_delete            WSEP_SUPERWRAP_DELETE
#endif


ProcessCreate     wsep_superwrap_create;
ProcessInitialize wsep_superwrap_init;
ProcessUpdate     wsep_superwrap_update;
ProcessOneset     wsep_superwrap_oneset;
ProcessWrapup     wsep_superwrap_wrapup;
ProcessDelete     wsep_superwrap_delete;


void superwrap_wsep_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = wsep_superwrap_create;
  THIS->initialize = wsep_superwrap_init;
  THIS->update     = wsep_superwrap_update;
  THIS->oneset     = wsep_superwrap_oneset;
  THIS->wrapup     = wsep_superwrap_wrapup;
  THIS->delete     = wsep_superwrap_delete;
}



/*------------------------------- JOB_DATA -------------------------------*/
/*------------------------------- JOB_DATA -------------------------------*/
/*------------------------------- JOB_DATA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define job_data_superwrap_create            job_data_superwrap_create_
#define job_data_superwrap_init              job_data_superwrap_init_
#define job_data_superwrap_update            job_data_superwrap_update_
#define job_data_superwrap_oneset            job_data_superwrap_oneset_ 
#define job_data_superwrap_twosets           job_data_superwrap_twosets_
#define job_data_superwrap_wrapup            job_data_superwrap_wrapup_
#define job_data_superwrap_delete            job_data_superwrap_delete_
#elif defined NEED_CAPITALS
#define job_data_superwrap_create            JOB_DATA_SUPERWRAP_CREATE
#define job_data_superwrap_init              JOB_DATA_SUPERWRAP_INIT
#define job_data_superwrap_update            JOB_DATA_SUPERWRAP_UPDATE
#define job_data_superwrap_oneset            JOB_DATA_SUPERWRAP_ONESET 
#define job_data_superwrap_twosets           JOB_DATA_SUPERWRAP_TWOSETS
#define job_data_superwrap_wrapup            JOB_DATA_SUPERWRAP_WRAPUP
#define job_data_superwrap_delete            JOB_DATA_SUPERWRAP_DELETE
#endif


ProcessCreate     job_data_superwrap_create;
ProcessInitialize job_data_superwrap_init;
ProcessUpdate     job_data_superwrap_update;
ProcessOneset     job_data_superwrap_oneset;
ProcessTwosets    job_data_superwrap_twosets;
ProcessWrapup     job_data_superwrap_wrapup;
ProcessDelete     job_data_superwrap_delete;


void superwrap_job_data_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = job_data_superwrap_create;
  THIS->initialize = job_data_superwrap_init;
  THIS->update     = job_data_superwrap_update;
  THIS->oneset     = job_data_superwrap_oneset;
  THIS->twosets    = job_data_superwrap_twosets;
  THIS->wrapup     = job_data_superwrap_wrapup;
  THIS->delete     = job_data_superwrap_delete;
}



/*------------------------------- KA -------------------------------*/
/*------------------------------- KA -------------------------------*/
/*------------------------------- KA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ka_superwrap_create            ka_superwrap_create_
#define ka_superwrap_init              ka_superwrap_init_
#define ka_superwrap_update            ka_superwrap_update_
#define ka_superwrap_oneset            ka_superwrap_oneset_ 
#define ka_superwrap_twosets           ka_superwrap_twosets_
#define ka_superwrap_wrapup            ka_superwrap_wrapup_
#define ka_superwrap_delete            ka_superwrap_delete_
#elif defined NEED_CAPITALS
#define ka_superwrap_create            KA_SUPERWRAP_CREATE
#define ka_superwrap_init              KA_SUPERWRAP_INIT
#define ka_superwrap_update            KA_SUPERWRAP_UPDATE
#define ka_superwrap_oneset            KA_SUPERWRAP_ONESET 
#define ka_superwrap_twosets           KA_SUPERWRAP_TWOSETS
#define ka_superwrap_wrapup            KA_SUPERWRAP_WRAPUP
#define ka_superwrap_delete            KA_SUPERWRAP_DELETE
#endif


ProcessCreate     ka_superwrap_create;
ProcessInitialize ka_superwrap_init;
ProcessUpdate     ka_superwrap_update;
ProcessOneset     ka_superwrap_oneset;
ProcessTwosets    ka_superwrap_twosets;
ProcessWrapup     ka_superwrap_wrapup;
ProcessDelete     ka_superwrap_delete;


void superwrap_ka_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ka_superwrap_create;
  THIS->initialize = ka_superwrap_init;
  THIS->update     = ka_superwrap_update;
  THIS->oneset     = ka_superwrap_oneset;
  THIS->twosets    = ka_superwrap_twosets;
  THIS->wrapup     = ka_superwrap_wrapup;
  THIS->delete     = ka_superwrap_delete;
}



/*------------------------------- KASTATS -------------------------------*/
/*------------------------------- KASTATS -------------------------------*/
/*------------------------------- KASTATS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define kastats_superwrap_create            kastats_superwrap_create_
#define kastats_superwrap_init              kastats_superwrap_init_
#define kastats_superwrap_update            kastats_superwrap_update_
#define kastats_superwrap_oneset            kastats_superwrap_oneset_ 
#define kastats_superwrap_twosets           kastats_superwrap_twosets_
#define kastats_superwrap_wrapup            kastats_superwrap_wrapup_
#define kastats_superwrap_delete            kastats_superwrap_delete_
#elif defined NEED_CAPITALS
#define kastats_superwrap_create            KASTATS_SUPERWRAP_CREATE
#define kastats_superwrap_init              KASTATS_SUPERWRAP_INIT
#define kastats_superwrap_update            KASTATS_SUPERWRAP_UPDATE
#define kastats_superwrap_oneset            KASTATS_SUPERWRAP_ONESET 
#define kastats_superwrap_twosets           KASTATS_SUPERWRAP_TWOSETS
#define kastats_superwrap_wrapup            KASTATS_SUPERWRAP_WRAPUP
#define kastats_superwrap_delete            KASTATS_SUPERWRAP_DELETE
#endif


ProcessCreate     kastats_superwrap_create;
ProcessInitialize kastats_superwrap_init;
ProcessUpdate     kastats_superwrap_update;
ProcessOneset     kastats_superwrap_oneset;
ProcessTwosets    kastats_superwrap_twosets;
ProcessWrapup     kastats_superwrap_wrapup;
ProcessDelete     kastats_superwrap_delete;


void superwrap_kastats_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = kastats_superwrap_create;
  THIS->initialize = kastats_superwrap_init;
  THIS->update     = kastats_superwrap_update;
  THIS->oneset     = kastats_superwrap_oneset;
  THIS->twosets    = kastats_superwrap_twosets;
  THIS->wrapup     = kastats_superwrap_wrapup;
  THIS->delete     = kastats_superwrap_delete;
}



/*------------------------------- KDMO -------------------------------*/
/*------------------------------- KDMO -------------------------------*/
/*------------------------------- KDMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define kdmo_superwrap_create            kdmo_superwrap_create_
#define kdmo_superwrap_init              kdmo_superwrap_init_
#define kdmo_superwrap_update            kdmo_superwrap_update_
#define kdmo_superwrap_oneset            kdmo_superwrap_oneset_ 
#define kdmo_superwrap_twosets           kdmo_superwrap_twosets_
#define kdmo_superwrap_wrapup            kdmo_superwrap_wrapup_
#define kdmo_superwrap_delete            kdmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define kdmo_superwrap_create            KDMO_SUPERWRAP_CREATE
#define kdmo_superwrap_init              KDMO_SUPERWRAP_INIT
#define kdmo_superwrap_update            KDMO_SUPERWRAP_UPDATE
#define kdmo_superwrap_oneset            KDMO_SUPERWRAP_ONESET 
#define kdmo_superwrap_twosets           KDMO_SUPERWRAP_TWOSETS
#define kdmo_superwrap_wrapup            KDMO_SUPERWRAP_WRAPUP
#define kdmo_superwrap_delete            KDMO_SUPERWRAP_DELETE
#endif


ProcessCreate     kdmo_superwrap_create;
ProcessInitialize kdmo_superwrap_init;
ProcessUpdate     kdmo_superwrap_update;
ProcessOneset     kdmo_superwrap_oneset;
ProcessTwosets    kdmo_superwrap_twosets;
ProcessWrapup     kdmo_superwrap_wrapup;
ProcessDelete     kdmo_superwrap_delete;


void superwrap_kdmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = kdmo_superwrap_create;
  THIS->initialize = kdmo_superwrap_init;
  THIS->update     = kdmo_superwrap_update;
  THIS->oneset     = kdmo_superwrap_oneset;
  THIS->twosets    = kdmo_superwrap_twosets;
  THIS->wrapup     = kdmo_superwrap_wrapup;
  THIS->delete     = kdmo_superwrap_delete;
}

/*------------------------------- KPSTM2D -------------------------------*/
/*------------------------------- KPSTM2D -------------------------------*/
/*------------------------------- KPSTM2D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define kpstm2d_superwrap_create            kpstm2d_superwrap_create_
#define kpstm2d_superwrap_init              kpstm2d_superwrap_init_
#define kpstm2d_superwrap_update            kpstm2d_superwrap_update_
#define kpstm2d_superwrap_oneset            kpstm2d_superwrap_oneset_
#define kpstm2d_superwrap_twosets           kpstm2d_superwrap_twosets_
#define kpstm2d_superwrap_wrapup            kpstm2d_superwrap_wrapup_
#define kpstm2d_superwrap_delete            kpstm2d_superwrap_delete_
#elif defined NEED_CAPITALS
#define kpstm2d_superwrap_create            KPSTM2D_SUPERWRAP_CREATE
#define kpstm2d_superwrap_init              KPSTM2D_SUPERWRAP_INIT
#define kpstm2d_superwrap_update            KPSTM2D_SUPERWRAP_UPDATE
#define kpstm2d_superwrap_oneset            KPSTM2D_SUPERWRAP_ONESET
#define kpstm2d_superwrap_twosets           KPSTM2D_SUPERWRAP_TWOSETS
#define kpstm2d_superwrap_wrapup            KPSTM2D_SUPERWRAP_WRAPUP
#define kpstm2d_superwrap_delete            KPSTM2D_SUPERWRAP_DELETE
#endif


ProcessCreate     kpstm2d_superwrap_create;
ProcessInitialize kpstm2d_superwrap_init;
ProcessUpdate     kpstm2d_superwrap_update;
ProcessOneset     kpstm2d_superwrap_oneset;
ProcessTwosets    kpstm2d_superwrap_twosets;
ProcessWrapup     kpstm2d_superwrap_wrapup;
ProcessDelete     kpstm2d_superwrap_delete;


void superwrap_kpstm2d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = kpstm2d_superwrap_create;
  THIS->initialize = kpstm2d_superwrap_init;
  THIS->update     = kpstm2d_superwrap_update;
  THIS->oneset     = kpstm2d_superwrap_oneset;
  THIS->twosets    = kpstm2d_superwrap_twosets;
  THIS->wrapup     = kpstm2d_superwrap_wrapup;
  THIS->delete     = kpstm2d_superwrap_delete;
}


/*------------------------------- MADC -------------------------------*/
/*------------------------------- MADC -------------------------------*/
/*------------------------------- MADC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define madc_superwrap_create            madc_superwrap_create_
#define madc_superwrap_init              madc_superwrap_init_
#define madc_superwrap_update            madc_superwrap_update_
#define madc_superwrap_oneset            madc_superwrap_oneset_ 
#define madc_superwrap_twosets           madc_superwrap_twosets_
#define madc_superwrap_wrapup            madc_superwrap_wrapup_
#define madc_superwrap_delete            madc_superwrap_delete_
#elif defined NEED_CAPITALS
#define madc_superwrap_create            MADC_SUPERWRAP_CREATE
#define madc_superwrap_init              MADC_SUPERWRAP_INIT
#define madc_superwrap_update            MADC_SUPERWRAP_UPDATE
#define madc_superwrap_oneset            MADC_SUPERWRAP_ONESET 
#define madc_superwrap_twosets           MADC_SUPERWRAP_TWOSETS
#define madc_superwrap_wrapup            MADC_SUPERWRAP_WRAPUP
#define madc_superwrap_delete            MADC_SUPERWRAP_DELETE
#endif


ProcessCreate     madc_superwrap_create;
ProcessInitialize madc_superwrap_init;
ProcessUpdate     madc_superwrap_update;
ProcessOneset     madc_superwrap_oneset;
ProcessTwosets    madc_superwrap_twosets;
ProcessWrapup     madc_superwrap_wrapup;
ProcessDelete     madc_superwrap_delete;


void superwrap_madc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = madc_superwrap_create;
  THIS->initialize = madc_superwrap_init;
  THIS->update     = madc_superwrap_update;
  THIS->oneset     = madc_superwrap_oneset;
  THIS->twosets    = madc_superwrap_twosets;
  THIS->wrapup     = madc_superwrap_wrapup;
  THIS->delete     = madc_superwrap_delete;
}



/*------------------------------- MASKER -------------------------------*/
/*------------------------------- MASKER -------------------------------*/
/*------------------------------- MASKER -------------------------------*/


#ifdef NEED_UNDERSCORE
#define masker_superwrap_create            masker_superwrap_create_
#define masker_superwrap_init              masker_superwrap_init_
#define masker_superwrap_update            masker_superwrap_update_
#define masker_superwrap_oneset            masker_superwrap_oneset_ 
#define masker_superwrap_twosets           masker_superwrap_twosets_
#define masker_superwrap_wrapup            masker_superwrap_wrapup_
#define masker_superwrap_delete            masker_superwrap_delete_
#elif defined NEED_CAPITALS
#define masker_superwrap_create            MASKER_SUPERWRAP_CREATE
#define masker_superwrap_init              MASKER_SUPERWRAP_INIT
#define masker_superwrap_update            MASKER_SUPERWRAP_UPDATE
#define masker_superwrap_oneset            MASKER_SUPERWRAP_ONESET 
#define masker_superwrap_twosets           MASKER_SUPERWRAP_TWOSETS
#define masker_superwrap_wrapup            MASKER_SUPERWRAP_WRAPUP
#define masker_superwrap_delete            MASKER_SUPERWRAP_DELETE
#endif


ProcessCreate     masker_superwrap_create;
ProcessInitialize masker_superwrap_init;
ProcessUpdate     masker_superwrap_update;
ProcessOneset     masker_superwrap_oneset;
ProcessTwosets    masker_superwrap_twosets;
ProcessWrapup     masker_superwrap_wrapup;
ProcessDelete     masker_superwrap_delete;


void superwrap_masker_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = masker_superwrap_create;
  THIS->initialize = masker_superwrap_init;
  THIS->update     = masker_superwrap_update;
  THIS->oneset     = masker_superwrap_oneset;
  THIS->twosets    = masker_superwrap_twosets;
  THIS->wrapup     = masker_superwrap_wrapup;
  THIS->delete     = masker_superwrap_delete;
}



/*------------------------------- MDIP -------------------------------*/
/*------------------------------- MDIP -------------------------------*/
/*------------------------------- MDIP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mdip_superwrap_create            mdip_superwrap_create_
#define mdip_superwrap_init              mdip_superwrap_init_
#define mdip_superwrap_update            mdip_superwrap_update_
#define mdip_superwrap_oneset            mdip_superwrap_oneset_ 
#define mdip_superwrap_twosets           mdip_superwrap_twosets_
#define mdip_superwrap_wrapup            mdip_superwrap_wrapup_
#define mdip_superwrap_delete            mdip_superwrap_delete_
#elif defined NEED_CAPITALS
#define mdip_superwrap_create            MDIP_SUPERWRAP_CREATE
#define mdip_superwrap_init              MDIP_SUPERWRAP_INIT
#define mdip_superwrap_update            MDIP_SUPERWRAP_UPDATE
#define mdip_superwrap_oneset            MDIP_SUPERWRAP_ONESET 
#define mdip_superwrap_twosets           MDIP_SUPERWRAP_TWOSETS
#define mdip_superwrap_wrapup            MDIP_SUPERWRAP_WRAPUP
#define mdip_superwrap_delete            MDIP_SUPERWRAP_DELETE
#endif


ProcessCreate     mdip_superwrap_create;
ProcessInitialize mdip_superwrap_init;
ProcessUpdate     mdip_superwrap_update;
ProcessOneset     mdip_superwrap_oneset;
ProcessTwosets    mdip_superwrap_twosets;
ProcessWrapup     mdip_superwrap_wrapup;
ProcessDelete     mdip_superwrap_delete;


void superwrap_mdip_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mdip_superwrap_create;
  THIS->initialize = mdip_superwrap_init;
  THIS->update     = mdip_superwrap_update;
  THIS->oneset     = mdip_superwrap_oneset;
  THIS->twosets    = mdip_superwrap_twosets;
  THIS->wrapup     = mdip_superwrap_wrapup;
  THIS->delete     = mdip_superwrap_delete;
}



/*------------------------------- MDS -------------------------------*/
/*------------------------------- MDS -------------------------------*/
/*------------------------------- MDS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mds_superwrap_create            mds_superwrap_create_
#define mds_superwrap_init              mds_superwrap_init_
#define mds_superwrap_update            mds_superwrap_update_
#define mds_superwrap_oneset            mds_superwrap_oneset_ 
#define mds_superwrap_twosets           mds_superwrap_twosets_
#define mds_superwrap_wrapup            mds_superwrap_wrapup_
#define mds_superwrap_delete            mds_superwrap_delete_
#elif defined NEED_CAPITALS
#define mds_superwrap_create            MDS_SUPERWRAP_CREATE
#define mds_superwrap_init              MDS_SUPERWRAP_INIT
#define mds_superwrap_update            MDS_SUPERWRAP_UPDATE
#define mds_superwrap_oneset            MDS_SUPERWRAP_ONESET 
#define mds_superwrap_twosets           MDS_SUPERWRAP_TWOSETS
#define mds_superwrap_wrapup            MDS_SUPERWRAP_WRAPUP
#define mds_superwrap_delete            MDS_SUPERWRAP_DELETE
#endif


ProcessCreate     mds_superwrap_create;
ProcessInitialize mds_superwrap_init;
ProcessUpdate     mds_superwrap_update;
ProcessOneset     mds_superwrap_oneset;
ProcessTwosets    mds_superwrap_twosets;
ProcessWrapup     mds_superwrap_wrapup;
ProcessDelete     mds_superwrap_delete;


void superwrap_mds_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mds_superwrap_create;
  THIS->initialize = mds_superwrap_init;
  THIS->update     = mds_superwrap_update;
  THIS->oneset     = mds_superwrap_oneset;
  THIS->twosets    = mds_superwrap_twosets;
  THIS->wrapup     = mds_superwrap_wrapup;
  THIS->delete     = mds_superwrap_delete;
}



/*------------------------------- MFRS -------------------------------*/
/*------------------------------- MFRS -------------------------------*/
/*------------------------------- MFRS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mfrs_superwrap_create            mfrs_superwrap_create_
#define mfrs_superwrap_init              mfrs_superwrap_init_
#define mfrs_superwrap_update            mfrs_superwrap_update_
#define mfrs_superwrap_oneset            mfrs_superwrap_oneset_ 
#define mfrs_superwrap_twosets           mfrs_superwrap_twosets_
#define mfrs_superwrap_wrapup            mfrs_superwrap_wrapup_
#define mfrs_superwrap_delete            mfrs_superwrap_delete_
#elif defined NEED_CAPITALS
#define mfrs_superwrap_create            MFRS_SUPERWRAP_CREATE
#define mfrs_superwrap_init              MFRS_SUPERWRAP_INIT
#define mfrs_superwrap_update            MFRS_SUPERWRAP_UPDATE
#define mfrs_superwrap_oneset            MFRS_SUPERWRAP_ONESET 
#define mfrs_superwrap_twosets           MFRS_SUPERWRAP_TWOSETS
#define mfrs_superwrap_wrapup            MFRS_SUPERWRAP_WRAPUP
#define mfrs_superwrap_delete            MFRS_SUPERWRAP_DELETE
#endif


ProcessCreate     mfrs_superwrap_create;
ProcessInitialize mfrs_superwrap_init;
ProcessUpdate     mfrs_superwrap_update;
ProcessOneset     mfrs_superwrap_oneset;
ProcessTwosets    mfrs_superwrap_twosets;
ProcessWrapup     mfrs_superwrap_wrapup;
ProcessDelete     mfrs_superwrap_delete;


void superwrap_mfrs_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mfrs_superwrap_create;
  THIS->initialize = mfrs_superwrap_init;
  THIS->update     = mfrs_superwrap_update;
  THIS->oneset     = mfrs_superwrap_oneset;
  THIS->twosets    = mfrs_superwrap_twosets;
  THIS->wrapup     = mfrs_superwrap_wrapup;
  THIS->delete     = mfrs_superwrap_delete;
}



/*------------------------------- MGD -------------------------------*/
/*------------------------------- MGD -------------------------------*/
/*------------------------------- MGD -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mgd_superwrap_create            mgd_superwrap_create_
#define mgd_superwrap_init              mgd_superwrap_init_
#define mgd_superwrap_update            mgd_superwrap_update_
#define mgd_superwrap_oneset            mgd_superwrap_oneset_ 
#define mgd_superwrap_twosets           mgd_superwrap_twosets_
#define mgd_superwrap_wrapup            mgd_superwrap_wrapup_
#define mgd_superwrap_delete            mgd_superwrap_delete_
#elif defined NEED_CAPITALS
#define mgd_superwrap_create            MGD_SUPERWRAP_CREATE
#define mgd_superwrap_init              MGD_SUPERWRAP_INIT
#define mgd_superwrap_update            MGD_SUPERWRAP_UPDATE
#define mgd_superwrap_oneset            MGD_SUPERWRAP_ONESET 
#define mgd_superwrap_twosets           MGD_SUPERWRAP_TWOSETS
#define mgd_superwrap_wrapup            MGD_SUPERWRAP_WRAPUP
#define mgd_superwrap_delete            MGD_SUPERWRAP_DELETE
#endif


ProcessCreate     mgd_superwrap_create;
ProcessInitialize mgd_superwrap_init;
ProcessUpdate     mgd_superwrap_update;
ProcessOneset     mgd_superwrap_oneset;
ProcessTwosets    mgd_superwrap_twosets;
ProcessWrapup     mgd_superwrap_wrapup;
ProcessDelete     mgd_superwrap_delete;


void superwrap_mgd_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mgd_superwrap_create;
  THIS->initialize = mgd_superwrap_init;
  THIS->update     = mgd_superwrap_update;
  THIS->oneset     = mgd_superwrap_oneset;
  THIS->twosets    = mgd_superwrap_twosets;
  THIS->wrapup     = mgd_superwrap_wrapup;
  THIS->delete     = mgd_superwrap_delete;
}



/*------------------------------- MIX -------------------------------*/
/*------------------------------- MIX -------------------------------*/
/*------------------------------- MIX -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mix_superwrap_create            mix_superwrap_create_
#define mix_superwrap_init              mix_superwrap_init_
#define mix_superwrap_update            mix_superwrap_update_
#define mix_superwrap_oneset            mix_superwrap_oneset_ 
#define mix_superwrap_twosets           mix_superwrap_twosets_
#define mix_superwrap_wrapup            mix_superwrap_wrapup_
#define mix_superwrap_delete            mix_superwrap_delete_
#elif defined NEED_CAPITALS
#define mix_superwrap_create            MIX_SUPERWRAP_CREATE
#define mix_superwrap_init              MIX_SUPERWRAP_INIT
#define mix_superwrap_update            MIX_SUPERWRAP_UPDATE
#define mix_superwrap_oneset            MIX_SUPERWRAP_ONESET 
#define mix_superwrap_twosets           MIX_SUPERWRAP_TWOSETS
#define mix_superwrap_wrapup            MIX_SUPERWRAP_WRAPUP
#define mix_superwrap_delete            MIX_SUPERWRAP_DELETE
#endif


ProcessCreate     mix_superwrap_create;
ProcessInitialize mix_superwrap_init;
ProcessUpdate     mix_superwrap_update;
ProcessOneset     mix_superwrap_oneset;
ProcessTwosets    mix_superwrap_twosets;
ProcessWrapup     mix_superwrap_wrapup;
ProcessDelete     mix_superwrap_delete;


void superwrap_mix_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mix_superwrap_create;
  THIS->initialize = mix_superwrap_init;
  THIS->update     = mix_superwrap_update;
  THIS->oneset     = mix_superwrap_oneset;
  THIS->twosets    = mix_superwrap_twosets;
  THIS->wrapup     = mix_superwrap_wrapup;
  THIS->delete     = mix_superwrap_delete;
}



/*------------------------------- MODMO -------------------------------*/
/*------------------------------- MODMO -------------------------------*/
/*------------------------------- MODMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define modmo_superwrap_create            modmo_superwrap_create_
#define modmo_superwrap_init              modmo_superwrap_init_
#define modmo_superwrap_update            modmo_superwrap_update_
#define modmo_superwrap_oneset            modmo_superwrap_oneset_ 
#define modmo_superwrap_twosets           modmo_superwrap_twosets_
#define modmo_superwrap_wrapup            modmo_superwrap_wrapup_
#define modmo_superwrap_delete            modmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define modmo_superwrap_create            MODMO_SUPERWRAP_CREATE
#define modmo_superwrap_init              MODMO_SUPERWRAP_INIT
#define modmo_superwrap_update            MODMO_SUPERWRAP_UPDATE
#define modmo_superwrap_oneset            MODMO_SUPERWRAP_ONESET 
#define modmo_superwrap_twosets           MODMO_SUPERWRAP_TWOSETS
#define modmo_superwrap_wrapup            MODMO_SUPERWRAP_WRAPUP
#define modmo_superwrap_delete            MODMO_SUPERWRAP_DELETE
#endif


ProcessCreate     modmo_superwrap_create;
ProcessInitialize modmo_superwrap_init;
ProcessUpdate     modmo_superwrap_update;
ProcessOneset     modmo_superwrap_oneset;
ProcessTwosets    modmo_superwrap_twosets;
ProcessWrapup     modmo_superwrap_wrapup;
ProcessDelete     modmo_superwrap_delete;


void superwrap_modmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = modmo_superwrap_create;
  THIS->initialize = modmo_superwrap_init;
  THIS->update     = modmo_superwrap_update;
  THIS->oneset     = modmo_superwrap_oneset;
  THIS->twosets    = modmo_superwrap_twosets;
  THIS->wrapup     = modmo_superwrap_wrapup;
  THIS->delete     = modmo_superwrap_delete;
}



/*------------------------------- MODMO2D -------------------------------*/
/*------------------------------- MODMO2D -------------------------------*/
/*------------------------------- MODMO2D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define modmo2d_superwrap_create            modmo2d_superwrap_create_
#define modmo2d_superwrap_init              modmo2d_superwrap_init_
#define modmo2d_superwrap_update            modmo2d_superwrap_update_
#define modmo2d_superwrap_oneset            modmo2d_superwrap_oneset_ 
#define modmo2d_superwrap_twosets           modmo2d_superwrap_twosets_
#define modmo2d_superwrap_wrapup            modmo2d_superwrap_wrapup_
#define modmo2d_superwrap_delete            modmo2d_superwrap_delete_
#elif defined NEED_CAPITALS
#define modmo2d_superwrap_create            MODMO2D_SUPERWRAP_CREATE
#define modmo2d_superwrap_init              MODMO2D_SUPERWRAP_INIT
#define modmo2d_superwrap_update            MODMO2D_SUPERWRAP_UPDATE
#define modmo2d_superwrap_oneset            MODMO2D_SUPERWRAP_ONESET 
#define modmo2d_superwrap_twosets           MODMO2D_SUPERWRAP_TWOSETS
#define modmo2d_superwrap_wrapup            MODMO2D_SUPERWRAP_WRAPUP
#define modmo2d_superwrap_delete            MODMO2D_SUPERWRAP_DELETE
#endif


ProcessCreate     modmo2d_superwrap_create;
ProcessInitialize modmo2d_superwrap_init;
ProcessUpdate     modmo2d_superwrap_update;
ProcessOneset     modmo2d_superwrap_oneset;
ProcessTwosets    modmo2d_superwrap_twosets;
ProcessWrapup     modmo2d_superwrap_wrapup;
ProcessDelete     modmo2d_superwrap_delete;


void superwrap_modmo2d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = modmo2d_superwrap_create;
  THIS->initialize = modmo2d_superwrap_init;
  THIS->update     = modmo2d_superwrap_update;
  THIS->oneset     = modmo2d_superwrap_oneset;
  THIS->twosets    = modmo2d_superwrap_twosets;
  THIS->wrapup     = modmo2d_superwrap_wrapup;
  THIS->delete     = modmo2d_superwrap_delete;
}



/*------------------------------- MTFUN -------------------------------*/
/*------------------------------- MTFUN -------------------------------*/
/*------------------------------- MTFUN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mtfun_superwrap_create            mtfun_superwrap_create_
#define mtfun_superwrap_init              mtfun_superwrap_init_
#define mtfun_superwrap_update            mtfun_superwrap_update_
#define mtfun_superwrap_oneset            mtfun_superwrap_oneset_ 
#define mtfun_superwrap_twosets           mtfun_superwrap_twosets_
#define mtfun_superwrap_wrapup            mtfun_superwrap_wrapup_
#define mtfun_superwrap_delete            mtfun_superwrap_delete_
#elif defined NEED_CAPITALS
#define mtfun_superwrap_create            MTFUN_SUPERWRAP_CREATE
#define mtfun_superwrap_init              MTFUN_SUPERWRAP_INIT
#define mtfun_superwrap_update            MTFUN_SUPERWRAP_UPDATE
#define mtfun_superwrap_oneset            MTFUN_SUPERWRAP_ONESET 
#define mtfun_superwrap_twosets           MTFUN_SUPERWRAP_TWOSETS
#define mtfun_superwrap_wrapup            MTFUN_SUPERWRAP_WRAPUP
#define mtfun_superwrap_delete            MTFUN_SUPERWRAP_DELETE
#endif


ProcessCreate     mtfun_superwrap_create;
ProcessInitialize mtfun_superwrap_init;
ProcessUpdate     mtfun_superwrap_update;
ProcessOneset     mtfun_superwrap_oneset;
ProcessTwosets    mtfun_superwrap_twosets;
ProcessWrapup     mtfun_superwrap_wrapup;
ProcessDelete     mtfun_superwrap_delete;


void superwrap_mtfun_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mtfun_superwrap_create;
  THIS->initialize = mtfun_superwrap_init;
  THIS->update     = mtfun_superwrap_update;
  THIS->oneset     = mtfun_superwrap_oneset;
  THIS->twosets    = mtfun_superwrap_twosets;
  THIS->wrapup     = mtfun_superwrap_wrapup;
  THIS->delete     = mtfun_superwrap_delete;
}



/*------------------------------- MUTE -------------------------------*/
/*------------------------------- MUTE -------------------------------*/
/*------------------------------- MUTE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mute_superwrap_create            mute_superwrap_create_
#define mute_superwrap_init              mute_superwrap_init_
#define mute_superwrap_update            mute_superwrap_update_
#define mute_superwrap_oneset            mute_superwrap_oneset_ 
#define mute_superwrap_twosets           mute_superwrap_twosets_
#define mute_superwrap_wrapup            mute_superwrap_wrapup_
#define mute_superwrap_delete            mute_superwrap_delete_
#elif defined NEED_CAPITALS
#define mute_superwrap_create            MUTE_SUPERWRAP_CREATE
#define mute_superwrap_init              MUTE_SUPERWRAP_INIT
#define mute_superwrap_update            MUTE_SUPERWRAP_UPDATE
#define mute_superwrap_oneset            MUTE_SUPERWRAP_ONESET 
#define mute_superwrap_twosets           MUTE_SUPERWRAP_TWOSETS
#define mute_superwrap_wrapup            MUTE_SUPERWRAP_WRAPUP
#define mute_superwrap_delete            MUTE_SUPERWRAP_DELETE
#endif


ProcessCreate     mute_superwrap_create;
ProcessInitialize mute_superwrap_init;
ProcessUpdate     mute_superwrap_update;
ProcessOneset     mute_superwrap_oneset;
ProcessTwosets    mute_superwrap_twosets;
ProcessWrapup     mute_superwrap_wrapup;
ProcessDelete     mute_superwrap_delete;


void superwrap_mute_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mute_superwrap_create;
  THIS->initialize = mute_superwrap_init;
  THIS->update     = mute_superwrap_update;
  THIS->oneset     = mute_superwrap_oneset;
  THIS->twosets    = mute_superwrap_twosets;
  THIS->wrapup     = mute_superwrap_wrapup;
  THIS->delete     = mute_superwrap_delete;
}



/*------------------------------- MVXP -------------------------------*/
/*------------------------------- MVXP -------------------------------*/
/*------------------------------- MVXP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mvxp_superwrap_create            mvxp_superwrap_create_
#define mvxp_superwrap_init              mvxp_superwrap_init_
#define mvxp_superwrap_update            mvxp_superwrap_update_
#define mvxp_superwrap_oneset            mvxp_superwrap_oneset_ 
#define mvxp_superwrap_twosets           mvxp_superwrap_twosets_
#define mvxp_superwrap_wrapup            mvxp_superwrap_wrapup_
#define mvxp_superwrap_delete            mvxp_superwrap_delete_
#elif defined NEED_CAPITALS
#define mvxp_superwrap_create            MVXP_SUPERWRAP_CREATE
#define mvxp_superwrap_init              MVXP_SUPERWRAP_INIT
#define mvxp_superwrap_update            MVXP_SUPERWRAP_UPDATE
#define mvxp_superwrap_oneset            MVXP_SUPERWRAP_ONESET 
#define mvxp_superwrap_twosets           MVXP_SUPERWRAP_TWOSETS
#define mvxp_superwrap_wrapup            MVXP_SUPERWRAP_WRAPUP
#define mvxp_superwrap_delete            MVXP_SUPERWRAP_DELETE
#endif


ProcessCreate     mvxp_superwrap_create;
ProcessInitialize mvxp_superwrap_init;
ProcessUpdate     mvxp_superwrap_update;
ProcessOneset     mvxp_superwrap_oneset;
ProcessTwosets    mvxp_superwrap_twosets;
ProcessWrapup     mvxp_superwrap_wrapup;
ProcessDelete     mvxp_superwrap_delete;


void superwrap_mvxp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mvxp_superwrap_create;
  THIS->initialize = mvxp_superwrap_init;
  THIS->update     = mvxp_superwrap_update;
  THIS->oneset     = mvxp_superwrap_oneset;
  THIS->twosets    = mvxp_superwrap_twosets;
  THIS->wrapup     = mvxp_superwrap_wrapup;
  THIS->delete     = mvxp_superwrap_delete;
}



/*------------------------------- MZPC -------------------------------*/
/*------------------------------- MZPC -------------------------------*/
/*------------------------------- MZPC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define mzpc_superwrap_create            mzpc_superwrap_create_
#define mzpc_superwrap_init              mzpc_superwrap_init_
#define mzpc_superwrap_update            mzpc_superwrap_update_
#define mzpc_superwrap_oneset            mzpc_superwrap_oneset_ 
#define mzpc_superwrap_twosets           mzpc_superwrap_twosets_
#define mzpc_superwrap_wrapup            mzpc_superwrap_wrapup_
#define mzpc_superwrap_delete            mzpc_superwrap_delete_
#elif defined NEED_CAPITALS
#define mzpc_superwrap_create            MZPC_SUPERWRAP_CREATE
#define mzpc_superwrap_init              MZPC_SUPERWRAP_INIT
#define mzpc_superwrap_update            MZPC_SUPERWRAP_UPDATE
#define mzpc_superwrap_oneset            MZPC_SUPERWRAP_ONESET 
#define mzpc_superwrap_twosets           MZPC_SUPERWRAP_TWOSETS
#define mzpc_superwrap_wrapup            MZPC_SUPERWRAP_WRAPUP
#define mzpc_superwrap_delete            MZPC_SUPERWRAP_DELETE
#endif


ProcessCreate     mzpc_superwrap_create;
ProcessInitialize mzpc_superwrap_init;
ProcessUpdate     mzpc_superwrap_update;
ProcessOneset     mzpc_superwrap_oneset;
ProcessTwosets    mzpc_superwrap_twosets;
ProcessWrapup     mzpc_superwrap_wrapup;
ProcessDelete     mzpc_superwrap_delete;


void superwrap_mzpc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = mzpc_superwrap_create;
  THIS->initialize = mzpc_superwrap_init;
  THIS->update     = mzpc_superwrap_update;
  THIS->oneset     = mzpc_superwrap_oneset;
  THIS->twosets    = mzpc_superwrap_twosets;
  THIS->wrapup     = mzpc_superwrap_wrapup;
  THIS->delete     = mzpc_superwrap_delete;
}



/*------------------------------- NMO -------------------------------*/
/*------------------------------- NMO -------------------------------*/
/*------------------------------- NMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define nmo_superwrap_create            nmo_superwrap_create_
#define nmo_superwrap_init              nmo_superwrap_init_
#define nmo_superwrap_update            nmo_superwrap_update_
#define nmo_superwrap_oneset            nmo_superwrap_oneset_ 
#define nmo_superwrap_twosets           nmo_superwrap_twosets_
#define nmo_superwrap_wrapup            nmo_superwrap_wrapup_
#define nmo_superwrap_delete            nmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define nmo_superwrap_create            NMO_SUPERWRAP_CREATE
#define nmo_superwrap_init              NMO_SUPERWRAP_INIT
#define nmo_superwrap_update            NMO_SUPERWRAP_UPDATE
#define nmo_superwrap_oneset            NMO_SUPERWRAP_ONESET 
#define nmo_superwrap_twosets           NMO_SUPERWRAP_TWOSETS
#define nmo_superwrap_wrapup            NMO_SUPERWRAP_WRAPUP
#define nmo_superwrap_delete            NMO_SUPERWRAP_DELETE
#endif


ProcessCreate     nmo_superwrap_create;
ProcessInitialize nmo_superwrap_init;
ProcessUpdate     nmo_superwrap_update;
ProcessOneset     nmo_superwrap_oneset;
ProcessTwosets    nmo_superwrap_twosets;
ProcessWrapup     nmo_superwrap_wrapup;
ProcessDelete     nmo_superwrap_delete;


void superwrap_nmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = nmo_superwrap_create;
  THIS->initialize = nmo_superwrap_init;
  THIS->update     = nmo_superwrap_update;
  THIS->oneset     = nmo_superwrap_oneset;
  THIS->twosets    = nmo_superwrap_twosets;
  THIS->wrapup     = nmo_superwrap_wrapup;
  THIS->delete     = nmo_superwrap_delete;
}



/*------------------------------- NORM -------------------------------*/
/*------------------------------- NORM -------------------------------*/
/*------------------------------- NORM -------------------------------*/


#ifdef NEED_UNDERSCORE
#define norm_superwrap_create            norm_superwrap_create_
#define norm_superwrap_init              norm_superwrap_init_
#define norm_superwrap_update            norm_superwrap_update_
#define norm_superwrap_oneset            norm_superwrap_oneset_ 
#define norm_superwrap_twosets           norm_superwrap_twosets_
#define norm_superwrap_wrapup            norm_superwrap_wrapup_
#define norm_superwrap_delete            norm_superwrap_delete_
#elif defined NEED_CAPITALS
#define norm_superwrap_create            NORM_SUPERWRAP_CREATE
#define norm_superwrap_init              NORM_SUPERWRAP_INIT
#define norm_superwrap_update            NORM_SUPERWRAP_UPDATE
#define norm_superwrap_oneset            NORM_SUPERWRAP_ONESET 
#define norm_superwrap_twosets           NORM_SUPERWRAP_TWOSETS
#define norm_superwrap_wrapup            NORM_SUPERWRAP_WRAPUP
#define norm_superwrap_delete            NORM_SUPERWRAP_DELETE
#endif


ProcessCreate     norm_superwrap_create;
ProcessInitialize norm_superwrap_init;
ProcessUpdate     norm_superwrap_update;
ProcessOneset     norm_superwrap_oneset;
ProcessTwosets    norm_superwrap_twosets;
ProcessWrapup     norm_superwrap_wrapup;
ProcessDelete     norm_superwrap_delete;


void superwrap_norm_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = norm_superwrap_create;
  THIS->initialize = norm_superwrap_init;
  THIS->update     = norm_superwrap_update;
  THIS->oneset     = norm_superwrap_oneset;
  THIS->twosets    = norm_superwrap_twosets;
  THIS->wrapup     = norm_superwrap_wrapup;
  THIS->delete     = norm_superwrap_delete;
}



/*------------------------------- OFF2ANG -------------------------------*/
/*------------------------------- OFF2ANG -------------------------------*/
/*------------------------------- OFF2ANG -------------------------------*/


#ifdef NEED_UNDERSCORE
#define off2ang_superwrap_create            off2ang_superwrap_create_
#define off2ang_superwrap_init              off2ang_superwrap_init_
#define off2ang_superwrap_update            off2ang_superwrap_update_
#define off2ang_superwrap_oneset            off2ang_superwrap_oneset_ 
#define off2ang_superwrap_twosets           off2ang_superwrap_twosets_
#define off2ang_superwrap_wrapup            off2ang_superwrap_wrapup_
#define off2ang_superwrap_delete            off2ang_superwrap_delete_
#elif defined NEED_CAPITALS
#define off2ang_superwrap_create            OFF2ANG_SUPERWRAP_CREATE
#define off2ang_superwrap_init              OFF2ANG_SUPERWRAP_INIT
#define off2ang_superwrap_update            OFF2ANG_SUPERWRAP_UPDATE
#define off2ang_superwrap_oneset            OFF2ANG_SUPERWRAP_ONESET 
#define off2ang_superwrap_twosets           OFF2ANG_SUPERWRAP_TWOSETS
#define off2ang_superwrap_wrapup            OFF2ANG_SUPERWRAP_WRAPUP
#define off2ang_superwrap_delete            OFF2ANG_SUPERWRAP_DELETE
#endif


ProcessCreate     off2ang_superwrap_create;
ProcessInitialize off2ang_superwrap_init;
ProcessUpdate     off2ang_superwrap_update;
ProcessOneset     off2ang_superwrap_oneset;
ProcessTwosets    off2ang_superwrap_twosets;
ProcessWrapup     off2ang_superwrap_wrapup;
ProcessDelete     off2ang_superwrap_delete;


void superwrap_off2ang_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = off2ang_superwrap_create;
  THIS->initialize = off2ang_superwrap_init;
  THIS->update     = off2ang_superwrap_update;
  THIS->oneset     = off2ang_superwrap_oneset;
  THIS->twosets    = off2ang_superwrap_twosets;
  THIS->wrapup     = off2ang_superwrap_wrapup;
  THIS->delete     = off2ang_superwrap_delete;
}



/*------------------------------- PAIRMERGE -------------------------------*/
/*------------------------------- PAIRMERGE -------------------------------*/
/*------------------------------- PAIRMERGE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define pairmerge_superwrap_create            pairmerge_superwrap_create_
#define pairmerge_superwrap_init              pairmerge_superwrap_init_
#define pairmerge_superwrap_update            pairmerge_superwrap_update_
#define pairmerge_superwrap_oneset            pairmerge_superwrap_oneset_ 
#define pairmerge_superwrap_twosets           pairmerge_superwrap_twosets_
#define pairmerge_superwrap_wrapup            pairmerge_superwrap_wrapup_
#define pairmerge_superwrap_delete            pairmerge_superwrap_delete_
#elif defined NEED_CAPITALS
#define pairmerge_superwrap_create            PAIRMERGE_SUPERWRAP_CREATE
#define pairmerge_superwrap_init              PAIRMERGE_SUPERWRAP_INIT
#define pairmerge_superwrap_update            PAIRMERGE_SUPERWRAP_UPDATE
#define pairmerge_superwrap_oneset            PAIRMERGE_SUPERWRAP_ONESET 
#define pairmerge_superwrap_twosets           PAIRMERGE_SUPERWRAP_TWOSETS
#define pairmerge_superwrap_wrapup            PAIRMERGE_SUPERWRAP_WRAPUP
#define pairmerge_superwrap_delete            PAIRMERGE_SUPERWRAP_DELETE
#endif


ProcessCreate     pairmerge_superwrap_create;
ProcessInitialize pairmerge_superwrap_init;
ProcessUpdate     pairmerge_superwrap_update;
ProcessOneset     pairmerge_superwrap_oneset;
ProcessTwosets    pairmerge_superwrap_twosets;
ProcessWrapup     pairmerge_superwrap_wrapup;
ProcessDelete     pairmerge_superwrap_delete;


void superwrap_pairmerge_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = pairmerge_superwrap_create;
  THIS->initialize = pairmerge_superwrap_init;
  THIS->update     = pairmerge_superwrap_update;
  THIS->oneset     = pairmerge_superwrap_oneset;
  THIS->twosets    = pairmerge_superwrap_twosets;
  THIS->wrapup     = pairmerge_superwrap_wrapup;
  THIS->delete     = pairmerge_superwrap_delete;
}



/*------------------------------- PFILT3C -------------------------------*/
/*------------------------------- PFILT3C -------------------------------*/
/*------------------------------- PFILT3C -------------------------------*/


#ifdef NEED_UNDERSCORE
#define pfilt3c_superwrap_create            pfilt3c_superwrap_create_
#define pfilt3c_superwrap_init              pfilt3c_superwrap_init_
#define pfilt3c_superwrap_update            pfilt3c_superwrap_update_
#define pfilt3c_superwrap_oneset            pfilt3c_superwrap_oneset_ 
#define pfilt3c_superwrap_twosets           pfilt3c_superwrap_twosets_
#define pfilt3c_superwrap_wrapup            pfilt3c_superwrap_wrapup_
#define pfilt3c_superwrap_delete            pfilt3c_superwrap_delete_
#elif defined NEED_CAPITALS
#define pfilt3c_superwrap_create            PFILT3C_SUPERWRAP_CREATE
#define pfilt3c_superwrap_init              PFILT3C_SUPERWRAP_INIT
#define pfilt3c_superwrap_update            PFILT3C_SUPERWRAP_UPDATE
#define pfilt3c_superwrap_oneset            PFILT3C_SUPERWRAP_ONESET 
#define pfilt3c_superwrap_twosets           PFILT3C_SUPERWRAP_TWOSETS
#define pfilt3c_superwrap_wrapup            PFILT3C_SUPERWRAP_WRAPUP
#define pfilt3c_superwrap_delete            PFILT3C_SUPERWRAP_DELETE
#endif


ProcessCreate     pfilt3c_superwrap_create;
ProcessInitialize pfilt3c_superwrap_init;
ProcessUpdate     pfilt3c_superwrap_update;
ProcessOneset     pfilt3c_superwrap_oneset;
ProcessTwosets    pfilt3c_superwrap_twosets;
ProcessWrapup     pfilt3c_superwrap_wrapup;
ProcessDelete     pfilt3c_superwrap_delete;


void superwrap_pfilt3c_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = pfilt3c_superwrap_create;
  THIS->initialize = pfilt3c_superwrap_init;
  THIS->update     = pfilt3c_superwrap_update;
  THIS->oneset     = pfilt3c_superwrap_oneset;
  THIS->twosets    = pfilt3c_superwrap_twosets;
  THIS->wrapup     = pfilt3c_superwrap_wrapup;
  THIS->delete     = pfilt3c_superwrap_delete;
}



/*------------------------------- PGPS -------------------------------*/
/*------------------------------- PGPS -------------------------------*/
/*------------------------------- PGPS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define pgps_superwrap_create            pgps_superwrap_create_
#define pgps_superwrap_init              pgps_superwrap_init_
#define pgps_superwrap_update            pgps_superwrap_update_
#define pgps_superwrap_oneset            pgps_superwrap_oneset_ 
#define pgps_superwrap_twosets           pgps_superwrap_twosets_
#define pgps_superwrap_wrapup            pgps_superwrap_wrapup_
#define pgps_superwrap_delete            pgps_superwrap_delete_
#elif defined NEED_CAPITALS
#define pgps_superwrap_create            PGPS_SUPERWRAP_CREATE
#define pgps_superwrap_init              PGPS_SUPERWRAP_INIT
#define pgps_superwrap_update            PGPS_SUPERWRAP_UPDATE
#define pgps_superwrap_oneset            PGPS_SUPERWRAP_ONESET 
#define pgps_superwrap_twosets           PGPS_SUPERWRAP_TWOSETS
#define pgps_superwrap_wrapup            PGPS_SUPERWRAP_WRAPUP
#define pgps_superwrap_delete            PGPS_SUPERWRAP_DELETE
#endif


ProcessCreate     pgps_superwrap_create;
ProcessInitialize pgps_superwrap_init;
ProcessUpdate     pgps_superwrap_update;
ProcessOneset     pgps_superwrap_oneset;
ProcessTwosets    pgps_superwrap_twosets;
ProcessWrapup     pgps_superwrap_wrapup;
ProcessDelete     pgps_superwrap_delete;


void superwrap_pgps_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = pgps_superwrap_create;
  THIS->initialize = pgps_superwrap_init;
  THIS->update     = pgps_superwrap_update;
  THIS->oneset     = pgps_superwrap_oneset;
  THIS->twosets    = pgps_superwrap_twosets;
  THIS->wrapup     = pgps_superwrap_wrapup;
  THIS->delete     = pgps_superwrap_delete;
}



/*------------------------------- PH2OFF -------------------------------*/
/*------------------------------- PH2OFF -------------------------------*/
/*------------------------------- PH2OFF -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ph2off_superwrap_create            ph2off_superwrap_create_
#define ph2off_superwrap_init              ph2off_superwrap_init_
#define ph2off_superwrap_update            ph2off_superwrap_update_
#define ph2off_superwrap_oneset            ph2off_superwrap_oneset_ 
#define ph2off_superwrap_twosets           ph2off_superwrap_twosets_
#define ph2off_superwrap_wrapup            ph2off_superwrap_wrapup_
#define ph2off_superwrap_delete            ph2off_superwrap_delete_
#elif defined NEED_CAPITALS
#define ph2off_superwrap_create            PH2OFF_SUPERWRAP_CREATE
#define ph2off_superwrap_init              PH2OFF_SUPERWRAP_INIT
#define ph2off_superwrap_update            PH2OFF_SUPERWRAP_UPDATE
#define ph2off_superwrap_oneset            PH2OFF_SUPERWRAP_ONESET 
#define ph2off_superwrap_twosets           PH2OFF_SUPERWRAP_TWOSETS
#define ph2off_superwrap_wrapup            PH2OFF_SUPERWRAP_WRAPUP
#define ph2off_superwrap_delete            PH2OFF_SUPERWRAP_DELETE
#endif


ProcessCreate     ph2off_superwrap_create;
ProcessInitialize ph2off_superwrap_init;
ProcessUpdate     ph2off_superwrap_update;
ProcessOneset     ph2off_superwrap_oneset;
ProcessTwosets    ph2off_superwrap_twosets;
ProcessWrapup     ph2off_superwrap_wrapup;
ProcessDelete     ph2off_superwrap_delete;


void superwrap_ph2off_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ph2off_superwrap_create;
  THIS->initialize = ph2off_superwrap_init;
  THIS->update     = ph2off_superwrap_update;
  THIS->oneset     = ph2off_superwrap_oneset;
  THIS->twosets    = ph2off_superwrap_twosets;
  THIS->wrapup     = ph2off_superwrap_wrapup;
  THIS->delete     = ph2off_superwrap_delete;
}



/*------------------------------- PICKSET -------------------------------*/
/*------------------------------- PICKSET -------------------------------*/
/*------------------------------- PICKSET -------------------------------*/


#ifdef NEED_UNDERSCORE
#define pickset_superwrap_create            pickset_superwrap_create_
#define pickset_superwrap_init              pickset_superwrap_init_
#define pickset_superwrap_update            pickset_superwrap_update_
#define pickset_superwrap_oneset            pickset_superwrap_oneset_ 
#define pickset_superwrap_twosets           pickset_superwrap_twosets_
#define pickset_superwrap_wrapup            pickset_superwrap_wrapup_
#define pickset_superwrap_delete            pickset_superwrap_delete_
#elif defined NEED_CAPITALS
#define pickset_superwrap_create            PICKSET_SUPERWRAP_CREATE
#define pickset_superwrap_init              PICKSET_SUPERWRAP_INIT
#define pickset_superwrap_update            PICKSET_SUPERWRAP_UPDATE
#define pickset_superwrap_oneset            PICKSET_SUPERWRAP_ONESET 
#define pickset_superwrap_twosets           PICKSET_SUPERWRAP_TWOSETS
#define pickset_superwrap_wrapup            PICKSET_SUPERWRAP_WRAPUP
#define pickset_superwrap_delete            PICKSET_SUPERWRAP_DELETE
#endif


ProcessCreate     pickset_superwrap_create;
ProcessInitialize pickset_superwrap_init;
ProcessUpdate     pickset_superwrap_update;
ProcessOneset     pickset_superwrap_oneset;
ProcessTwosets    pickset_superwrap_twosets;
ProcessWrapup     pickset_superwrap_wrapup;
ProcessDelete     pickset_superwrap_delete;


void superwrap_pickset_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = pickset_superwrap_create;
  THIS->initialize = pickset_superwrap_init;
  THIS->update     = pickset_superwrap_update;
  THIS->oneset     = pickset_superwrap_oneset;
  THIS->twosets    = pickset_superwrap_twosets;
  THIS->wrapup     = pickset_superwrap_wrapup;
  THIS->delete     = pickset_superwrap_delete;
}



/*------------------------------- PROJECT_DATA -------------------------------*/
/*------------------------------- PROJECT_DATA -------------------------------*/
/*------------------------------- PROJECT_DATA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define project_data_superwrap_create            project_data_superwrap_create_
#define project_data_superwrap_init              project_data_superwrap_init_
#define project_data_superwrap_update            project_data_superwrap_update_
#define project_data_superwrap_oneset            project_data_superwrap_oneset_ 
#define project_data_superwrap_twosets           project_data_superwrap_twosets_
#define project_data_superwrap_wrapup            project_data_superwrap_wrapup_
#define project_data_superwrap_delete            project_data_superwrap_delete_
#elif defined NEED_CAPITALS
#define project_data_superwrap_create            PROJECT_DATA_SUPERWRAP_CREATE
#define project_data_superwrap_init              PROJECT_DATA_SUPERWRAP_INIT
#define project_data_superwrap_update            PROJECT_DATA_SUPERWRAP_UPDATE
#define project_data_superwrap_oneset            PROJECT_DATA_SUPERWRAP_ONESET 
#define project_data_superwrap_twosets           PROJECT_DATA_SUPERWRAP_TWOSETS
#define project_data_superwrap_wrapup            PROJECT_DATA_SUPERWRAP_WRAPUP
#define project_data_superwrap_delete            PROJECT_DATA_SUPERWRAP_DELETE
#endif


ProcessCreate     project_data_superwrap_create;
ProcessInitialize project_data_superwrap_init;
ProcessUpdate     project_data_superwrap_update;
ProcessOneset     project_data_superwrap_oneset;
ProcessTwosets    project_data_superwrap_twosets;
ProcessWrapup     project_data_superwrap_wrapup;
ProcessDelete     project_data_superwrap_delete;


void superwrap_project_data_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = project_data_superwrap_create;
  THIS->initialize = project_data_superwrap_init;
  THIS->update     = project_data_superwrap_update;
  THIS->oneset     = project_data_superwrap_oneset;
  THIS->twosets    = project_data_superwrap_twosets;
  THIS->wrapup     = project_data_superwrap_wrapup;
  THIS->delete     = project_data_superwrap_delete;
}



/*------------------------------- PSTMIG -------------------------------*/
/*------------------------------- PSTMIG -------------------------------*/
/*------------------------------- PSTMIG -------------------------------*/


#ifdef NEED_UNDERSCORE
#define pstmig_superwrap_create            pstmig_superwrap_create_
#define pstmig_superwrap_init              pstmig_superwrap_init_
#define pstmig_superwrap_update            pstmig_superwrap_update_
#define pstmig_superwrap_oneset            pstmig_superwrap_oneset_ 
#define pstmig_superwrap_twosets           pstmig_superwrap_twosets_
#define pstmig_superwrap_wrapup            pstmig_superwrap_wrapup_
#define pstmig_superwrap_delete            pstmig_superwrap_delete_
#elif defined NEED_CAPITALS
#define pstmig_superwrap_create            PSTMIG_SUPERWRAP_CREATE
#define pstmig_superwrap_init              PSTMIG_SUPERWRAP_INIT
#define pstmig_superwrap_update            PSTMIG_SUPERWRAP_UPDATE
#define pstmig_superwrap_oneset            PSTMIG_SUPERWRAP_ONESET 
#define pstmig_superwrap_twosets           PSTMIG_SUPERWRAP_TWOSETS
#define pstmig_superwrap_wrapup            PSTMIG_SUPERWRAP_WRAPUP
#define pstmig_superwrap_delete            PSTMIG_SUPERWRAP_DELETE
#endif


ProcessCreate     pstmig_superwrap_create;
ProcessInitialize pstmig_superwrap_init;
ProcessUpdate     pstmig_superwrap_update;
ProcessOneset     pstmig_superwrap_oneset;
ProcessTwosets    pstmig_superwrap_twosets;
ProcessWrapup     pstmig_superwrap_wrapup;
ProcessDelete     pstmig_superwrap_delete;


void superwrap_pstmig_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = pstmig_superwrap_create;
  THIS->initialize = pstmig_superwrap_init;
  THIS->update     = pstmig_superwrap_update;
  THIS->oneset     = pstmig_superwrap_oneset;
  THIS->twosets    = pstmig_superwrap_twosets;
  THIS->wrapup     = pstmig_superwrap_wrapup;
  THIS->delete     = pstmig_superwrap_delete;
}



/*------------------------------- QEST -------------------------------*/
/*------------------------------- QEST -------------------------------*/
/*------------------------------- QEST -------------------------------*/


#ifdef NEED_UNDERSCORE
#define qest_superwrap_create            qest_superwrap_create_
#define qest_superwrap_init              qest_superwrap_init_
#define qest_superwrap_update            qest_superwrap_update_
#define qest_superwrap_oneset            qest_superwrap_oneset_ 
#define qest_superwrap_twosets           qest_superwrap_twosets_
#define qest_superwrap_wrapup            qest_superwrap_wrapup_
#define qest_superwrap_delete            qest_superwrap_delete_
#elif defined NEED_CAPITALS
#define qest_superwrap_create            QEST_SUPERWRAP_CREATE
#define qest_superwrap_init              QEST_SUPERWRAP_INIT
#define qest_superwrap_update            QEST_SUPERWRAP_UPDATE
#define qest_superwrap_oneset            QEST_SUPERWRAP_ONESET 
#define qest_superwrap_twosets           QEST_SUPERWRAP_TWOSETS
#define qest_superwrap_wrapup            QEST_SUPERWRAP_WRAPUP
#define qest_superwrap_delete            QEST_SUPERWRAP_DELETE
#endif


ProcessCreate     qest_superwrap_create;
ProcessInitialize qest_superwrap_init;
ProcessUpdate     qest_superwrap_update;
ProcessOneset     qest_superwrap_oneset;
ProcessTwosets    qest_superwrap_twosets;
ProcessWrapup     qest_superwrap_wrapup;
ProcessDelete     qest_superwrap_delete;


void superwrap_qest_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = qest_superwrap_create;
  THIS->initialize = qest_superwrap_init;
  THIS->update     = qest_superwrap_update;
  THIS->oneset     = qest_superwrap_oneset;
  THIS->twosets    = qest_superwrap_twosets;
  THIS->wrapup     = qest_superwrap_wrapup;
  THIS->delete     = qest_superwrap_delete;
}



/*------------------------------- RANDGTH -------------------------------*/
/*------------------------------- RANDGTH -------------------------------*/
/*------------------------------- RANDGTH -------------------------------*/


#ifdef NEED_UNDERSCORE
#define randgth_superwrap_create            randgth_superwrap_create_
#define randgth_superwrap_init              randgth_superwrap_init_
#define randgth_superwrap_update            randgth_superwrap_update_
#define randgth_superwrap_oneset            randgth_superwrap_oneset_ 
#define randgth_superwrap_twosets           randgth_superwrap_twosets_
#define randgth_superwrap_wrapup            randgth_superwrap_wrapup_
#define randgth_superwrap_delete            randgth_superwrap_delete_
#elif defined NEED_CAPITALS
#define randgth_superwrap_create            RANDGTH_SUPERWRAP_CREATE
#define randgth_superwrap_init              RANDGTH_SUPERWRAP_INIT
#define randgth_superwrap_update            RANDGTH_SUPERWRAP_UPDATE
#define randgth_superwrap_oneset            RANDGTH_SUPERWRAP_ONESET 
#define randgth_superwrap_twosets           RANDGTH_SUPERWRAP_TWOSETS
#define randgth_superwrap_wrapup            RANDGTH_SUPERWRAP_WRAPUP
#define randgth_superwrap_delete            RANDGTH_SUPERWRAP_DELETE
#endif


ProcessCreate     randgth_superwrap_create;
ProcessInitialize randgth_superwrap_init;
ProcessUpdate     randgth_superwrap_update;
ProcessOneset     randgth_superwrap_oneset;
ProcessTwosets    randgth_superwrap_twosets;
ProcessWrapup     randgth_superwrap_wrapup;
ProcessDelete     randgth_superwrap_delete;


void superwrap_randgth_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = randgth_superwrap_create;
  THIS->initialize = randgth_superwrap_init;
  THIS->update     = randgth_superwrap_update;
  THIS->oneset     = randgth_superwrap_oneset;
  THIS->twosets    = randgth_superwrap_twosets;
  THIS->wrapup     = randgth_superwrap_wrapup;
  THIS->delete     = randgth_superwrap_delete;
}



/*------------------------------- RANLINE -------------------------------*/
/*------------------------------- RANLINE -------------------------------*/
/*------------------------------- RANLINE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ranline_superwrap_create            ranline_superwrap_create_
#define ranline_superwrap_init              ranline_superwrap_init_
#define ranline_superwrap_update            ranline_superwrap_update_
#define ranline_superwrap_oneset            ranline_superwrap_oneset_ 
#define ranline_superwrap_twosets           ranline_superwrap_twosets_
#define ranline_superwrap_wrapup            ranline_superwrap_wrapup_
#define ranline_superwrap_delete            ranline_superwrap_delete_
#elif defined NEED_CAPITALS
#define ranline_superwrap_create            RANLINE_SUPERWRAP_CREATE
#define ranline_superwrap_init              RANLINE_SUPERWRAP_INIT
#define ranline_superwrap_update            RANLINE_SUPERWRAP_UPDATE
#define ranline_superwrap_oneset            RANLINE_SUPERWRAP_ONESET 
#define ranline_superwrap_twosets           RANLINE_SUPERWRAP_TWOSETS
#define ranline_superwrap_wrapup            RANLINE_SUPERWRAP_WRAPUP
#define ranline_superwrap_delete            RANLINE_SUPERWRAP_DELETE
#endif


ProcessCreate     ranline_superwrap_create;
ProcessInitialize ranline_superwrap_init;
ProcessUpdate     ranline_superwrap_update;
ProcessOneset     ranline_superwrap_oneset;
ProcessTwosets    ranline_superwrap_twosets;
ProcessWrapup     ranline_superwrap_wrapup;
ProcessDelete     ranline_superwrap_delete;


void superwrap_ranline_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ranline_superwrap_create;
  THIS->initialize = ranline_superwrap_init;
  THIS->update     = ranline_superwrap_update;
  THIS->oneset     = ranline_superwrap_oneset;
  THIS->twosets    = ranline_superwrap_twosets;
  THIS->wrapup     = ranline_superwrap_wrapup;
  THIS->delete     = ranline_superwrap_delete;
}



/*------------------------------- RCPOUT -------------------------------*/
/*------------------------------- RCPOUT -------------------------------*/
/*------------------------------- RCPOUT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define rcpout_superwrap_create            rcpout_superwrap_create_
#define rcpout_superwrap_init              rcpout_superwrap_init_
#define rcpout_superwrap_update            rcpout_superwrap_update_
#define rcpout_superwrap_oneset            rcpout_superwrap_oneset_ 
#define rcpout_superwrap_twosets           rcpout_superwrap_twosets_
#define rcpout_superwrap_wrapup            rcpout_superwrap_wrapup_
#define rcpout_superwrap_delete            rcpout_superwrap_delete_
#elif defined NEED_CAPITALS
#define rcpout_superwrap_create            RCPOUT_SUPERWRAP_CREATE
#define rcpout_superwrap_init              RCPOUT_SUPERWRAP_INIT
#define rcpout_superwrap_update            RCPOUT_SUPERWRAP_UPDATE
#define rcpout_superwrap_oneset            RCPOUT_SUPERWRAP_ONESET 
#define rcpout_superwrap_twosets           RCPOUT_SUPERWRAP_TWOSETS
#define rcpout_superwrap_wrapup            RCPOUT_SUPERWRAP_WRAPUP
#define rcpout_superwrap_delete            RCPOUT_SUPERWRAP_DELETE
#endif


ProcessCreate     rcpout_superwrap_create;
ProcessInitialize rcpout_superwrap_init;
ProcessUpdate     rcpout_superwrap_update;
ProcessOneset     rcpout_superwrap_oneset;
ProcessTwosets    rcpout_superwrap_twosets;
ProcessWrapup     rcpout_superwrap_wrapup;
ProcessDelete     rcpout_superwrap_delete;


void superwrap_rcpout_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = rcpout_superwrap_create;
  THIS->initialize = rcpout_superwrap_init;
  THIS->update     = rcpout_superwrap_update;
  THIS->oneset     = rcpout_superwrap_oneset;
  THIS->twosets    = rcpout_superwrap_twosets;
  THIS->wrapup     = rcpout_superwrap_wrapup;
  THIS->delete     = rcpout_superwrap_delete;
}



/*------------------------------- REG -------------------------------*/
/*------------------------------- REG -------------------------------*/
/*------------------------------- REG -------------------------------*/


#ifdef NEED_UNDERSCORE
#define reg_superwrap_create            reg_superwrap_create_
#define reg_superwrap_init              reg_superwrap_init_
#define reg_superwrap_update            reg_superwrap_update_
#define reg_superwrap_oneset            reg_superwrap_oneset_ 
#define reg_superwrap_twosets           reg_superwrap_twosets_
#define reg_superwrap_wrapup            reg_superwrap_wrapup_
#define reg_superwrap_delete            reg_superwrap_delete_
#elif defined NEED_CAPITALS
#define reg_superwrap_create            REG_SUPERWRAP_CREATE
#define reg_superwrap_init              REG_SUPERWRAP_INIT
#define reg_superwrap_update            REG_SUPERWRAP_UPDATE
#define reg_superwrap_oneset            REG_SUPERWRAP_ONESET 
#define reg_superwrap_twosets           REG_SUPERWRAP_TWOSETS
#define reg_superwrap_wrapup            REG_SUPERWRAP_WRAPUP
#define reg_superwrap_delete            REG_SUPERWRAP_DELETE
#endif


ProcessCreate     reg_superwrap_create;
ProcessInitialize reg_superwrap_init;
ProcessUpdate     reg_superwrap_update;
ProcessOneset     reg_superwrap_oneset;
ProcessTwosets    reg_superwrap_twosets;
ProcessWrapup     reg_superwrap_wrapup;
ProcessDelete     reg_superwrap_delete;


void superwrap_reg_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = reg_superwrap_create;
  THIS->initialize = reg_superwrap_init;
  THIS->update     = reg_superwrap_update;
  THIS->oneset     = reg_superwrap_oneset;
  THIS->twosets    = reg_superwrap_twosets;
  THIS->wrapup     = reg_superwrap_wrapup;
  THIS->delete     = reg_superwrap_delete;
}



/*------------------------------- REG2D -------------------------------*/
/*------------------------------- REG2D -------------------------------*/
/*------------------------------- REG2D -------------------------------*/


#ifdef NEED_UNDERSCORE
#define reg2d_superwrap_create            reg2d_superwrap_create_
#define reg2d_superwrap_init              reg2d_superwrap_init_
#define reg2d_superwrap_update            reg2d_superwrap_update_
#define reg2d_superwrap_oneset            reg2d_superwrap_oneset_ 
#define reg2d_superwrap_twosets           reg2d_superwrap_twosets_
#define reg2d_superwrap_wrapup            reg2d_superwrap_wrapup_
#define reg2d_superwrap_delete            reg2d_superwrap_delete_
#elif defined NEED_CAPITALS
#define reg2d_superwrap_create            REG2D_SUPERWRAP_CREATE
#define reg2d_superwrap_init              REG2D_SUPERWRAP_INIT
#define reg2d_superwrap_update            REG2D_SUPERWRAP_UPDATE
#define reg2d_superwrap_oneset            REG2D_SUPERWRAP_ONESET 
#define reg2d_superwrap_twosets           REG2D_SUPERWRAP_TWOSETS
#define reg2d_superwrap_wrapup            REG2D_SUPERWRAP_WRAPUP
#define reg2d_superwrap_delete            REG2D_SUPERWRAP_DELETE
#endif


ProcessCreate     reg2d_superwrap_create;
ProcessInitialize reg2d_superwrap_init;
ProcessUpdate     reg2d_superwrap_update;
ProcessOneset     reg2d_superwrap_oneset;
ProcessTwosets    reg2d_superwrap_twosets;
ProcessWrapup     reg2d_superwrap_wrapup;
ProcessDelete     reg2d_superwrap_delete;


void superwrap_reg2d_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = reg2d_superwrap_create;
  THIS->initialize = reg2d_superwrap_init;
  THIS->update     = reg2d_superwrap_update;
  THIS->oneset     = reg2d_superwrap_oneset;
  THIS->twosets    = reg2d_superwrap_twosets;
  THIS->wrapup     = reg2d_superwrap_wrapup;
  THIS->delete     = reg2d_superwrap_delete;
}



/*------------------------------- REGBIN -------------------------------*/
/*------------------------------- REGBIN -------------------------------*/
/*------------------------------- REGBIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define regbin_superwrap_create            regbin_superwrap_create_
#define regbin_superwrap_init              regbin_superwrap_init_
#define regbin_superwrap_update            regbin_superwrap_update_
#define regbin_superwrap_oneset            regbin_superwrap_oneset_ 
#define regbin_superwrap_twosets           regbin_superwrap_twosets_
#define regbin_superwrap_wrapup            regbin_superwrap_wrapup_
#define regbin_superwrap_delete            regbin_superwrap_delete_
#elif defined NEED_CAPITALS
#define regbin_superwrap_create            REGBIN_SUPERWRAP_CREATE
#define regbin_superwrap_init              REGBIN_SUPERWRAP_INIT
#define regbin_superwrap_update            REGBIN_SUPERWRAP_UPDATE
#define regbin_superwrap_oneset            REGBIN_SUPERWRAP_ONESET 
#define regbin_superwrap_twosets           REGBIN_SUPERWRAP_TWOSETS
#define regbin_superwrap_wrapup            REGBIN_SUPERWRAP_WRAPUP
#define regbin_superwrap_delete            REGBIN_SUPERWRAP_DELETE
#endif


ProcessCreate     regbin_superwrap_create;
ProcessInitialize regbin_superwrap_init;
ProcessUpdate     regbin_superwrap_update;
ProcessOneset     regbin_superwrap_oneset;
ProcessTwosets    regbin_superwrap_twosets;
ProcessWrapup     regbin_superwrap_wrapup;
ProcessDelete     regbin_superwrap_delete;


void superwrap_regbin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = regbin_superwrap_create;
  THIS->initialize = regbin_superwrap_init;
  THIS->update     = regbin_superwrap_update;
  THIS->oneset     = regbin_superwrap_oneset;
  THIS->twosets    = regbin_superwrap_twosets;
  THIS->wrapup     = regbin_superwrap_wrapup;
  THIS->delete     = regbin_superwrap_delete;
}



/*------------------------------- RES -------------------------------*/
/*------------------------------- RES -------------------------------*/
/*------------------------------- RES -------------------------------*/


#ifdef NEED_UNDERSCORE
#define res_superwrap_create            res_superwrap_create_
#define res_superwrap_init              res_superwrap_init_
#define res_superwrap_update            res_superwrap_update_
#define res_superwrap_oneset            res_superwrap_oneset_ 
#define res_superwrap_twosets           res_superwrap_twosets_
#define res_superwrap_wrapup            res_superwrap_wrapup_
#define res_superwrap_delete            res_superwrap_delete_
#elif defined NEED_CAPITALS
#define res_superwrap_create            RES_SUPERWRAP_CREATE
#define res_superwrap_init              RES_SUPERWRAP_INIT
#define res_superwrap_update            RES_SUPERWRAP_UPDATE
#define res_superwrap_oneset            RES_SUPERWRAP_ONESET 
#define res_superwrap_twosets           RES_SUPERWRAP_TWOSETS
#define res_superwrap_wrapup            RES_SUPERWRAP_WRAPUP
#define res_superwrap_delete            RES_SUPERWRAP_DELETE
#endif


ProcessCreate     res_superwrap_create;
ProcessInitialize res_superwrap_init;
ProcessUpdate     res_superwrap_update;
ProcessOneset     res_superwrap_oneset;
ProcessTwosets    res_superwrap_twosets;
ProcessWrapup     res_superwrap_wrapup;
ProcessDelete     res_superwrap_delete;


void superwrap_res_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = res_superwrap_create;
  THIS->initialize = res_superwrap_init;
  THIS->update     = res_superwrap_update;
  THIS->oneset     = res_superwrap_oneset;
  THIS->twosets    = res_superwrap_twosets;
  THIS->wrapup     = res_superwrap_wrapup;
  THIS->delete     = res_superwrap_delete;
}



/*------------------------------- RESTH -------------------------------*/
/*------------------------------- RESTH -------------------------------*/
/*------------------------------- RESTH -------------------------------*/


#ifdef NEED_UNDERSCORE
#define resth_superwrap_create            resth_superwrap_create_
#define resth_superwrap_init              resth_superwrap_init_
#define resth_superwrap_update            resth_superwrap_update_
#define resth_superwrap_oneset            resth_superwrap_oneset_ 
#define resth_superwrap_twosets           resth_superwrap_twosets_
#define resth_superwrap_wrapup            resth_superwrap_wrapup_
#define resth_superwrap_delete            resth_superwrap_delete_
#elif defined NEED_CAPITALS
#define resth_superwrap_create            RESTH_SUPERWRAP_CREATE
#define resth_superwrap_init              RESTH_SUPERWRAP_INIT
#define resth_superwrap_update            RESTH_SUPERWRAP_UPDATE
#define resth_superwrap_oneset            RESTH_SUPERWRAP_ONESET 
#define resth_superwrap_twosets           RESTH_SUPERWRAP_TWOSETS
#define resth_superwrap_wrapup            RESTH_SUPERWRAP_WRAPUP
#define resth_superwrap_delete            RESTH_SUPERWRAP_DELETE
#endif


ProcessCreate     resth_superwrap_create;
ProcessInitialize resth_superwrap_init;
ProcessUpdate     resth_superwrap_update;
ProcessOneset     resth_superwrap_oneset;
ProcessTwosets    resth_superwrap_twosets;
ProcessWrapup     resth_superwrap_wrapup;
ProcessDelete     resth_superwrap_delete;


void superwrap_resth_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = resth_superwrap_create;
  THIS->initialize = resth_superwrap_init;
  THIS->update     = resth_superwrap_update;
  THIS->oneset     = resth_superwrap_oneset;
  THIS->twosets    = resth_superwrap_twosets;
  THIS->wrapup     = resth_superwrap_wrapup;
  THIS->delete     = resth_superwrap_delete;
}



/*------------------------------- RFAB -------------------------------*/
/*------------------------------- RFAB -------------------------------*/
/*------------------------------- RFAB -------------------------------*/


#ifdef NEED_UNDERSCORE
#define rfab_superwrap_create            rfab_superwrap_create_
#define rfab_superwrap_init              rfab_superwrap_init_
#define rfab_superwrap_update            rfab_superwrap_update_
#define rfab_superwrap_oneset            rfab_superwrap_oneset_ 
#define rfab_superwrap_twosets           rfab_superwrap_twosets_
#define rfab_superwrap_wrapup            rfab_superwrap_wrapup_
#define rfab_superwrap_delete            rfab_superwrap_delete_
#elif defined NEED_CAPITALS
#define rfab_superwrap_create            RFAB_SUPERWRAP_CREATE
#define rfab_superwrap_init              RFAB_SUPERWRAP_INIT
#define rfab_superwrap_update            RFAB_SUPERWRAP_UPDATE
#define rfab_superwrap_oneset            RFAB_SUPERWRAP_ONESET 
#define rfab_superwrap_twosets           RFAB_SUPERWRAP_TWOSETS
#define rfab_superwrap_wrapup            RFAB_SUPERWRAP_WRAPUP
#define rfab_superwrap_delete            RFAB_SUPERWRAP_DELETE
#endif


ProcessCreate     rfab_superwrap_create;
ProcessInitialize rfab_superwrap_init;
ProcessUpdate     rfab_superwrap_update;
ProcessOneset     rfab_superwrap_oneset;
ProcessTwosets    rfab_superwrap_twosets;
ProcessWrapup     rfab_superwrap_wrapup;
ProcessDelete     rfab_superwrap_delete;


void superwrap_rfab_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = rfab_superwrap_create;
  THIS->initialize = rfab_superwrap_init;
  THIS->update     = rfab_superwrap_update;
  THIS->oneset     = rfab_superwrap_oneset;
  THIS->twosets    = rfab_superwrap_twosets;
  THIS->wrapup     = rfab_superwrap_wrapup;
  THIS->delete     = rfab_superwrap_delete;
}



/*------------------------------- RMUL -------------------------------*/
/*------------------------------- RMUL -------------------------------*/
/*------------------------------- RMUL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define rmul_superwrap_create            rmul_superwrap_create_
#define rmul_superwrap_init              rmul_superwrap_init_
#define rmul_superwrap_update            rmul_superwrap_update_
#define rmul_superwrap_oneset            rmul_superwrap_oneset_ 
#define rmul_superwrap_twosets           rmul_superwrap_twosets_
#define rmul_superwrap_wrapup            rmul_superwrap_wrapup_
#define rmul_superwrap_delete            rmul_superwrap_delete_
#elif defined NEED_CAPITALS
#define rmul_superwrap_create            RMUL_SUPERWRAP_CREATE
#define rmul_superwrap_init              RMUL_SUPERWRAP_INIT
#define rmul_superwrap_update            RMUL_SUPERWRAP_UPDATE
#define rmul_superwrap_oneset            RMUL_SUPERWRAP_ONESET 
#define rmul_superwrap_twosets           RMUL_SUPERWRAP_TWOSETS
#define rmul_superwrap_wrapup            RMUL_SUPERWRAP_WRAPUP
#define rmul_superwrap_delete            RMUL_SUPERWRAP_DELETE
#endif


ProcessCreate     rmul_superwrap_create;
ProcessInitialize rmul_superwrap_init;
ProcessUpdate     rmul_superwrap_update;
ProcessOneset     rmul_superwrap_oneset;
ProcessTwosets    rmul_superwrap_twosets;
ProcessWrapup     rmul_superwrap_wrapup;
ProcessDelete     rmul_superwrap_delete;


void superwrap_rmul_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = rmul_superwrap_create;
  THIS->initialize = rmul_superwrap_init;
  THIS->update     = rmul_superwrap_update;
  THIS->oneset     = rmul_superwrap_oneset;
  THIS->twosets    = rmul_superwrap_twosets;
  THIS->wrapup     = rmul_superwrap_wrapup;
  THIS->delete     = rmul_superwrap_delete;
}



/*------------------------------- RNSYN -------------------------------*/
/*------------------------------- RNSYN -------------------------------*/
/*------------------------------- RNSYN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define rnsyn_superwrap_create            rnsyn_superwrap_create_
#define rnsyn_superwrap_init              rnsyn_superwrap_init_
#define rnsyn_superwrap_update            rnsyn_superwrap_update_
#define rnsyn_superwrap_oneset            rnsyn_superwrap_oneset_ 
#define rnsyn_superwrap_twosets           rnsyn_superwrap_twosets_
#define rnsyn_superwrap_wrapup            rnsyn_superwrap_wrapup_
#define rnsyn_superwrap_delete            rnsyn_superwrap_delete_
#elif defined NEED_CAPITALS
#define rnsyn_superwrap_create            RNSYN_SUPERWRAP_CREATE
#define rnsyn_superwrap_init              RNSYN_SUPERWRAP_INIT
#define rnsyn_superwrap_update            RNSYN_SUPERWRAP_UPDATE
#define rnsyn_superwrap_oneset            RNSYN_SUPERWRAP_ONESET 
#define rnsyn_superwrap_twosets           RNSYN_SUPERWRAP_TWOSETS
#define rnsyn_superwrap_wrapup            RNSYN_SUPERWRAP_WRAPUP
#define rnsyn_superwrap_delete            RNSYN_SUPERWRAP_DELETE
#endif


ProcessCreate     rnsyn_superwrap_create;
ProcessInitialize rnsyn_superwrap_init;
ProcessUpdate     rnsyn_superwrap_update;
ProcessOneset     rnsyn_superwrap_oneset;
ProcessTwosets    rnsyn_superwrap_twosets;
ProcessWrapup     rnsyn_superwrap_wrapup;
ProcessDelete     rnsyn_superwrap_delete;


void superwrap_rnsyn_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = rnsyn_superwrap_create;
  THIS->initialize = rnsyn_superwrap_init;
  THIS->update     = rnsyn_superwrap_update;
  THIS->oneset     = rnsyn_superwrap_oneset;
  THIS->twosets    = rnsyn_superwrap_twosets;
  THIS->wrapup     = rnsyn_superwrap_wrapup;
  THIS->delete     = rnsyn_superwrap_delete;
}



/*------------------------------- RTC -------------------------------*/
/*------------------------------- RTC -------------------------------*/
/*------------------------------- RTC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define rtc_superwrap_create            rtc_superwrap_create_
#define rtc_superwrap_init              rtc_superwrap_init_
#define rtc_superwrap_update            rtc_superwrap_update_
#define rtc_superwrap_oneset            rtc_superwrap_oneset_ 
#define rtc_superwrap_twosets           rtc_superwrap_twosets_
#define rtc_superwrap_wrapup            rtc_superwrap_wrapup_
#define rtc_superwrap_delete            rtc_superwrap_delete_
#elif defined NEED_CAPITALS
#define rtc_superwrap_create            RTC_SUPERWRAP_CREATE
#define rtc_superwrap_init              RTC_SUPERWRAP_INIT
#define rtc_superwrap_update            RTC_SUPERWRAP_UPDATE
#define rtc_superwrap_oneset            RTC_SUPERWRAP_ONESET 
#define rtc_superwrap_twosets           RTC_SUPERWRAP_TWOSETS
#define rtc_superwrap_wrapup            RTC_SUPERWRAP_WRAPUP
#define rtc_superwrap_delete            RTC_SUPERWRAP_DELETE
#endif


ProcessCreate     rtc_superwrap_create;
ProcessInitialize rtc_superwrap_init;
ProcessUpdate     rtc_superwrap_update;
ProcessOneset     rtc_superwrap_oneset;
ProcessTwosets    rtc_superwrap_twosets;
ProcessWrapup     rtc_superwrap_wrapup;
ProcessDelete     rtc_superwrap_delete;


void superwrap_rtc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = rtc_superwrap_create;
  THIS->initialize = rtc_superwrap_init;
  THIS->update     = rtc_superwrap_update;
  THIS->oneset     = rtc_superwrap_oneset;
  THIS->twosets    = rtc_superwrap_twosets;
  THIS->wrapup     = rtc_superwrap_wrapup;
  THIS->delete     = rtc_superwrap_delete;
}



/*------------------------------- SCAB -------------------------------*/
/*------------------------------- SCAB -------------------------------*/
/*------------------------------- SCAB -------------------------------*/


#ifdef NEED_UNDERSCORE
#define scab_superwrap_create            scab_superwrap_create_
#define scab_superwrap_init              scab_superwrap_init_
#define scab_superwrap_update            scab_superwrap_update_
#define scab_superwrap_oneset            scab_superwrap_oneset_ 
#define scab_superwrap_twosets           scab_superwrap_twosets_
#define scab_superwrap_wrapup            scab_superwrap_wrapup_
#define scab_superwrap_delete            scab_superwrap_delete_
#elif defined NEED_CAPITALS
#define scab_superwrap_create            SCAB_SUPERWRAP_CREATE
#define scab_superwrap_init              SCAB_SUPERWRAP_INIT
#define scab_superwrap_update            SCAB_SUPERWRAP_UPDATE
#define scab_superwrap_oneset            SCAB_SUPERWRAP_ONESET 
#define scab_superwrap_twosets           SCAB_SUPERWRAP_TWOSETS
#define scab_superwrap_wrapup            SCAB_SUPERWRAP_WRAPUP
#define scab_superwrap_delete            SCAB_SUPERWRAP_DELETE
#endif


ProcessCreate     scab_superwrap_create;
ProcessInitialize scab_superwrap_init;
ProcessUpdate     scab_superwrap_update;
ProcessOneset     scab_superwrap_oneset;
ProcessTwosets    scab_superwrap_twosets;
ProcessWrapup     scab_superwrap_wrapup;
ProcessDelete     scab_superwrap_delete;


void superwrap_scab_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = scab_superwrap_create;
  THIS->initialize = scab_superwrap_init;
  THIS->update     = scab_superwrap_update;
  THIS->oneset     = scab_superwrap_oneset;
  THIS->twosets    = scab_superwrap_twosets;
  THIS->wrapup     = scab_superwrap_wrapup;
  THIS->delete     = scab_superwrap_delete;
}



/*------------------------------- SCALE -------------------------------*/
/*------------------------------- SCALE -------------------------------*/
/*------------------------------- SCALE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define scale_superwrap_create            scale_superwrap_create_
#define scale_superwrap_init              scale_superwrap_init_
#define scale_superwrap_update            scale_superwrap_update_
#define scale_superwrap_oneset            scale_superwrap_oneset_ 
#define scale_superwrap_twosets           scale_superwrap_twosets_
#define scale_superwrap_wrapup            scale_superwrap_wrapup_
#define scale_superwrap_delete            scale_superwrap_delete_
#elif defined NEED_CAPITALS
#define scale_superwrap_create            SCALE_SUPERWRAP_CREATE
#define scale_superwrap_init              SCALE_SUPERWRAP_INIT
#define scale_superwrap_update            SCALE_SUPERWRAP_UPDATE
#define scale_superwrap_oneset            SCALE_SUPERWRAP_ONESET 
#define scale_superwrap_twosets           SCALE_SUPERWRAP_TWOSETS
#define scale_superwrap_wrapup            SCALE_SUPERWRAP_WRAPUP
#define scale_superwrap_delete            SCALE_SUPERWRAP_DELETE
#endif


ProcessCreate     scale_superwrap_create;
ProcessInitialize scale_superwrap_init;
ProcessUpdate     scale_superwrap_update;
ProcessOneset     scale_superwrap_oneset;
ProcessTwosets    scale_superwrap_twosets;
ProcessWrapup     scale_superwrap_wrapup;
ProcessDelete     scale_superwrap_delete;


void superwrap_scale_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = scale_superwrap_create;
  THIS->initialize = scale_superwrap_init;
  THIS->update     = scale_superwrap_update;
  THIS->oneset     = scale_superwrap_oneset;
  THIS->twosets    = scale_superwrap_twosets;
  THIS->wrapup     = scale_superwrap_wrapup;
  THIS->delete     = scale_superwrap_delete;
}



/*------------------------------- SCDECON -------------------------------*/
/*------------------------------- SCDECON -------------------------------*/
/*------------------------------- SCDECON -------------------------------*/


#ifdef NEED_UNDERSCORE
#define scdecon_superwrap_create            scdecon_superwrap_create_
#define scdecon_superwrap_init              scdecon_superwrap_init_
#define scdecon_superwrap_update            scdecon_superwrap_update_
#define scdecon_superwrap_oneset            scdecon_superwrap_oneset_ 
#define scdecon_superwrap_twosets           scdecon_superwrap_twosets_
#define scdecon_superwrap_wrapup            scdecon_superwrap_wrapup_
#define scdecon_superwrap_delete            scdecon_superwrap_delete_
#elif defined NEED_CAPITALS
#define scdecon_superwrap_create            SCDECON_SUPERWRAP_CREATE
#define scdecon_superwrap_init              SCDECON_SUPERWRAP_INIT
#define scdecon_superwrap_update            SCDECON_SUPERWRAP_UPDATE
#define scdecon_superwrap_oneset            SCDECON_SUPERWRAP_ONESET 
#define scdecon_superwrap_twosets           SCDECON_SUPERWRAP_TWOSETS
#define scdecon_superwrap_wrapup            SCDECON_SUPERWRAP_WRAPUP
#define scdecon_superwrap_delete            SCDECON_SUPERWRAP_DELETE
#endif


ProcessCreate     scdecon_superwrap_create;
ProcessInitialize scdecon_superwrap_init;
ProcessUpdate     scdecon_superwrap_update;
ProcessOneset     scdecon_superwrap_oneset;
ProcessTwosets    scdecon_superwrap_twosets;
ProcessWrapup     scdecon_superwrap_wrapup;
ProcessDelete     scdecon_superwrap_delete;


void superwrap_scdecon_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = scdecon_superwrap_create;
  THIS->initialize = scdecon_superwrap_init;
  THIS->update     = scdecon_superwrap_update;
  THIS->oneset     = scdecon_superwrap_oneset;
  THIS->twosets    = scdecon_superwrap_twosets;
  THIS->wrapup     = scdecon_superwrap_wrapup;
  THIS->delete     = scdecon_superwrap_delete;
}



/*------------------------------- SDIP -------------------------------*/
/*------------------------------- SDIP -------------------------------*/
/*------------------------------- SDIP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define sdip_superwrap_create            sdip_superwrap_create_
#define sdip_superwrap_init              sdip_superwrap_init_
#define sdip_superwrap_update            sdip_superwrap_update_
#define sdip_superwrap_oneset            sdip_superwrap_oneset_ 
#define sdip_superwrap_twosets           sdip_superwrap_twosets_
#define sdip_superwrap_wrapup            sdip_superwrap_wrapup_
#define sdip_superwrap_delete            sdip_superwrap_delete_
#elif defined NEED_CAPITALS
#define sdip_superwrap_create            SDIP_SUPERWRAP_CREATE
#define sdip_superwrap_init              SDIP_SUPERWRAP_INIT
#define sdip_superwrap_update            SDIP_SUPERWRAP_UPDATE
#define sdip_superwrap_oneset            SDIP_SUPERWRAP_ONESET 
#define sdip_superwrap_twosets           SDIP_SUPERWRAP_TWOSETS
#define sdip_superwrap_wrapup            SDIP_SUPERWRAP_WRAPUP
#define sdip_superwrap_delete            SDIP_SUPERWRAP_DELETE
#endif


ProcessCreate     sdip_superwrap_create;
ProcessInitialize sdip_superwrap_init;
ProcessUpdate     sdip_superwrap_update;
ProcessOneset     sdip_superwrap_oneset;
ProcessTwosets    sdip_superwrap_twosets;
ProcessWrapup     sdip_superwrap_wrapup;
ProcessDelete     sdip_superwrap_delete;


void superwrap_sdip_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = sdip_superwrap_create;
  THIS->initialize = sdip_superwrap_init;
  THIS->update     = sdip_superwrap_update;
  THIS->oneset     = sdip_superwrap_oneset;
  THIS->twosets    = sdip_superwrap_twosets;
  THIS->wrapup     = sdip_superwrap_wrapup;
  THIS->delete     = sdip_superwrap_delete;
}



/*------------------------------- SELDMO -------------------------------*/
/*------------------------------- SELDMO -------------------------------*/
/*------------------------------- SELDMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define seldmo_superwrap_create            seldmo_superwrap_create_
#define seldmo_superwrap_init              seldmo_superwrap_init_
#define seldmo_superwrap_update            seldmo_superwrap_update_
#define seldmo_superwrap_oneset            seldmo_superwrap_oneset_ 
#define seldmo_superwrap_twosets           seldmo_superwrap_twosets_
#define seldmo_superwrap_wrapup            seldmo_superwrap_wrapup_
#define seldmo_superwrap_delete            seldmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define seldmo_superwrap_create            SELDMO_SUPERWRAP_CREATE
#define seldmo_superwrap_init              SELDMO_SUPERWRAP_INIT
#define seldmo_superwrap_update            SELDMO_SUPERWRAP_UPDATE
#define seldmo_superwrap_oneset            SELDMO_SUPERWRAP_ONESET 
#define seldmo_superwrap_twosets           SELDMO_SUPERWRAP_TWOSETS
#define seldmo_superwrap_wrapup            SELDMO_SUPERWRAP_WRAPUP
#define seldmo_superwrap_delete            SELDMO_SUPERWRAP_DELETE
#endif


ProcessCreate     seldmo_superwrap_create;
ProcessInitialize seldmo_superwrap_init;
ProcessUpdate     seldmo_superwrap_update;
ProcessOneset     seldmo_superwrap_oneset;
ProcessTwosets    seldmo_superwrap_twosets;
ProcessWrapup     seldmo_superwrap_wrapup;
ProcessDelete     seldmo_superwrap_delete;


void superwrap_seldmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = seldmo_superwrap_create;
  THIS->initialize = seldmo_superwrap_init;
  THIS->update     = seldmo_superwrap_update;
  THIS->oneset     = seldmo_superwrap_oneset;
  THIS->twosets    = seldmo_superwrap_twosets;
  THIS->wrapup     = seldmo_superwrap_wrapup;
  THIS->delete     = seldmo_superwrap_delete;
}



/*------------------------------- SELECT -------------------------------*/
/*------------------------------- SELECT -------------------------------*/
/*------------------------------- SELECT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define select_superwrap_create            select_superwrap_create_
#define select_superwrap_init              select_superwrap_init_
#define select_superwrap_update            select_superwrap_update_
#define select_superwrap_oneset            select_superwrap_oneset_ 
#define select_superwrap_twosets           select_superwrap_twosets_
#define select_superwrap_wrapup            select_superwrap_wrapup_
#define select_superwrap_delete            select_superwrap_delete_
#elif defined NEED_CAPITALS
#define select_superwrap_create            SELECT_SUPERWRAP_CREATE
#define select_superwrap_init              SELECT_SUPERWRAP_INIT
#define select_superwrap_update            SELECT_SUPERWRAP_UPDATE
#define select_superwrap_oneset            SELECT_SUPERWRAP_ONESET 
#define select_superwrap_twosets           SELECT_SUPERWRAP_TWOSETS
#define select_superwrap_wrapup            SELECT_SUPERWRAP_WRAPUP
#define select_superwrap_delete            SELECT_SUPERWRAP_DELETE
#endif


ProcessCreate     select_superwrap_create;
ProcessInitialize select_superwrap_init;
ProcessUpdate     select_superwrap_update;
ProcessOneset     select_superwrap_oneset;
ProcessTwosets    select_superwrap_twosets;
ProcessWrapup     select_superwrap_wrapup;
ProcessDelete     select_superwrap_delete;


void superwrap_select_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = select_superwrap_create;
  THIS->initialize = select_superwrap_init;
  THIS->update     = select_superwrap_update;
  THIS->oneset     = select_superwrap_oneset;
  THIS->twosets    = select_superwrap_twosets;
  THIS->wrapup     = select_superwrap_wrapup;
  THIS->delete     = select_superwrap_delete;
}



/*------------------------------- SETMUTE -------------------------------*/
/*------------------------------- SETMUTE -------------------------------*/
/*------------------------------- SETMUTE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define setmute_superwrap_create            setmute_superwrap_create_
#define setmute_superwrap_init              setmute_superwrap_init_
#define setmute_superwrap_update            setmute_superwrap_update_
#define setmute_superwrap_oneset            setmute_superwrap_oneset_ 
#define setmute_superwrap_twosets           setmute_superwrap_twosets_
#define setmute_superwrap_wrapup            setmute_superwrap_wrapup_
#define setmute_superwrap_delete            setmute_superwrap_delete_
#elif defined NEED_CAPITALS
#define setmute_superwrap_create            SETMUTE_SUPERWRAP_CREATE
#define setmute_superwrap_init              SETMUTE_SUPERWRAP_INIT
#define setmute_superwrap_update            SETMUTE_SUPERWRAP_UPDATE
#define setmute_superwrap_oneset            SETMUTE_SUPERWRAP_ONESET 
#define setmute_superwrap_twosets           SETMUTE_SUPERWRAP_TWOSETS
#define setmute_superwrap_wrapup            SETMUTE_SUPERWRAP_WRAPUP
#define setmute_superwrap_delete            SETMUTE_SUPERWRAP_DELETE
#endif


ProcessCreate     setmute_superwrap_create;
ProcessInitialize setmute_superwrap_init;
ProcessUpdate     setmute_superwrap_update;
ProcessOneset     setmute_superwrap_oneset;
ProcessTwosets    setmute_superwrap_twosets;
ProcessWrapup     setmute_superwrap_wrapup;
ProcessDelete     setmute_superwrap_delete;


void superwrap_setmute_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = setmute_superwrap_create;
  THIS->initialize = setmute_superwrap_init;
  THIS->update     = setmute_superwrap_update;
  THIS->oneset     = setmute_superwrap_oneset;
  THIS->twosets    = setmute_superwrap_twosets;
  THIS->wrapup     = setmute_superwrap_wrapup;
  THIS->delete     = setmute_superwrap_delete;
}



/*------------------------------- SETPOLY -------------------------------*/
/*------------------------------- SETPOLY -------------------------------*/
/*------------------------------- SETPOLY -------------------------------*/


#ifdef NEED_UNDERSCORE
#define setpoly_superwrap_create            setpoly_superwrap_create_
#define setpoly_superwrap_init              setpoly_superwrap_init_
#define setpoly_superwrap_update            setpoly_superwrap_update_
#define setpoly_superwrap_oneset            setpoly_superwrap_oneset_ 
#define setpoly_superwrap_twosets           setpoly_superwrap_twosets_
#define setpoly_superwrap_wrapup            setpoly_superwrap_wrapup_
#define setpoly_superwrap_delete            setpoly_superwrap_delete_
#elif defined NEED_CAPITALS
#define setpoly_superwrap_create            SETPOLY_SUPERWRAP_CREATE
#define setpoly_superwrap_init              SETPOLY_SUPERWRAP_INIT
#define setpoly_superwrap_update            SETPOLY_SUPERWRAP_UPDATE
#define setpoly_superwrap_oneset            SETPOLY_SUPERWRAP_ONESET 
#define setpoly_superwrap_twosets           SETPOLY_SUPERWRAP_TWOSETS
#define setpoly_superwrap_wrapup            SETPOLY_SUPERWRAP_WRAPUP
#define setpoly_superwrap_delete            SETPOLY_SUPERWRAP_DELETE
#endif


ProcessCreate     setpoly_superwrap_create;
ProcessInitialize setpoly_superwrap_init;
ProcessUpdate     setpoly_superwrap_update;
ProcessOneset     setpoly_superwrap_oneset;
ProcessTwosets    setpoly_superwrap_twosets;
ProcessWrapup     setpoly_superwrap_wrapup;
ProcessDelete     setpoly_superwrap_delete;


void superwrap_setpoly_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = setpoly_superwrap_create;
  THIS->initialize = setpoly_superwrap_init;
  THIS->update     = setpoly_superwrap_update;
  THIS->oneset     = setpoly_superwrap_oneset;
  THIS->twosets    = setpoly_superwrap_twosets;
  THIS->wrapup     = setpoly_superwrap_wrapup;
  THIS->delete     = setpoly_superwrap_delete;
}



/*------------------------------- SETWORD -------------------------------*/
/*------------------------------- SETWORD -------------------------------*/
/*------------------------------- SETWORD -------------------------------*/


#ifdef NEED_UNDERSCORE
#define setword_superwrap_create            setword_superwrap_create_
#define setword_superwrap_init              setword_superwrap_init_
#define setword_superwrap_update            setword_superwrap_update_
#define setword_superwrap_oneset            setword_superwrap_oneset_ 
#define setword_superwrap_twosets           setword_superwrap_twosets_
#define setword_superwrap_wrapup            setword_superwrap_wrapup_
#define setword_superwrap_delete            setword_superwrap_delete_
#elif defined NEED_CAPITALS
#define setword_superwrap_create            SETWORD_SUPERWRAP_CREATE
#define setword_superwrap_init              SETWORD_SUPERWRAP_INIT
#define setword_superwrap_update            SETWORD_SUPERWRAP_UPDATE
#define setword_superwrap_oneset            SETWORD_SUPERWRAP_ONESET 
#define setword_superwrap_twosets           SETWORD_SUPERWRAP_TWOSETS
#define setword_superwrap_wrapup            SETWORD_SUPERWRAP_WRAPUP
#define setword_superwrap_delete            SETWORD_SUPERWRAP_DELETE
#endif


ProcessCreate     setword_superwrap_create;
ProcessInitialize setword_superwrap_init;
ProcessUpdate     setword_superwrap_update;
ProcessOneset     setword_superwrap_oneset;
ProcessTwosets    setword_superwrap_twosets;
ProcessWrapup     setword_superwrap_wrapup;
ProcessDelete     setword_superwrap_delete;


void superwrap_setword_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = setword_superwrap_create;
  THIS->initialize = setword_superwrap_init;
  THIS->update     = setword_superwrap_update;
  THIS->oneset     = setword_superwrap_oneset;
  THIS->twosets    = setword_superwrap_twosets;
  THIS->wrapup     = setword_superwrap_wrapup;
  THIS->delete     = setword_superwrap_delete;
}



/*------------------------------- SHFT -------------------------------*/
/*------------------------------- SHFT -------------------------------*/
/*------------------------------- SHFT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define shft_superwrap_create            shft_superwrap_create_
#define shft_superwrap_init              shft_superwrap_init_
#define shft_superwrap_update            shft_superwrap_update_
#define shft_superwrap_oneset            shft_superwrap_oneset_ 
#define shft_superwrap_twosets           shft_superwrap_twosets_
#define shft_superwrap_wrapup            shft_superwrap_wrapup_
#define shft_superwrap_delete            shft_superwrap_delete_
#elif defined NEED_CAPITALS
#define shft_superwrap_create            SHFT_SUPERWRAP_CREATE
#define shft_superwrap_init              SHFT_SUPERWRAP_INIT
#define shft_superwrap_update            SHFT_SUPERWRAP_UPDATE
#define shft_superwrap_oneset            SHFT_SUPERWRAP_ONESET 
#define shft_superwrap_twosets           SHFT_SUPERWRAP_TWOSETS
#define shft_superwrap_wrapup            SHFT_SUPERWRAP_WRAPUP
#define shft_superwrap_delete            SHFT_SUPERWRAP_DELETE
#endif


ProcessCreate     shft_superwrap_create;
ProcessInitialize shft_superwrap_init;
ProcessUpdate     shft_superwrap_update;
ProcessOneset     shft_superwrap_oneset;
ProcessTwosets    shft_superwrap_twosets;
ProcessWrapup     shft_superwrap_wrapup;
ProcessDelete     shft_superwrap_delete;


void superwrap_shft_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = shft_superwrap_create;
  THIS->initialize = shft_superwrap_init;
  THIS->update     = shft_superwrap_update;
  THIS->oneset     = shft_superwrap_oneset;
  THIS->twosets    = shft_superwrap_twosets;
  THIS->wrapup     = shft_superwrap_wrapup;
  THIS->delete     = shft_superwrap_delete;
}



/*------------------------------- SISC -------------------------------*/
/*------------------------------- SISC -------------------------------*/
/*------------------------------- SISC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define sisc_superwrap_create            sisc_superwrap_create_
#define sisc_superwrap_init              sisc_superwrap_init_
#define sisc_superwrap_update            sisc_superwrap_update_
#define sisc_superwrap_oneset            sisc_superwrap_oneset_ 
#define sisc_superwrap_twosets           sisc_superwrap_twosets_
#define sisc_superwrap_wrapup            sisc_superwrap_wrapup_
#define sisc_superwrap_delete            sisc_superwrap_delete_
#elif defined NEED_CAPITALS
#define sisc_superwrap_create            SISC_SUPERWRAP_CREATE
#define sisc_superwrap_init              SISC_SUPERWRAP_INIT
#define sisc_superwrap_update            SISC_SUPERWRAP_UPDATE
#define sisc_superwrap_oneset            SISC_SUPERWRAP_ONESET 
#define sisc_superwrap_twosets           SISC_SUPERWRAP_TWOSETS
#define sisc_superwrap_wrapup            SISC_SUPERWRAP_WRAPUP
#define sisc_superwrap_delete            SISC_SUPERWRAP_DELETE
#endif


ProcessCreate     sisc_superwrap_create;
ProcessInitialize sisc_superwrap_init;
ProcessUpdate     sisc_superwrap_update;
ProcessOneset     sisc_superwrap_oneset;
ProcessTwosets    sisc_superwrap_twosets;
ProcessWrapup     sisc_superwrap_wrapup;
ProcessDelete     sisc_superwrap_delete;


void superwrap_sisc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = sisc_superwrap_create;
  THIS->initialize = sisc_superwrap_init;
  THIS->update     = sisc_superwrap_update;
  THIS->oneset     = sisc_superwrap_oneset;
  THIS->twosets    = sisc_superwrap_twosets;
  THIS->wrapup     = sisc_superwrap_wrapup;
  THIS->delete     = sisc_superwrap_delete;
}



/*------------------------------- SLAB -------------------------------*/
/*------------------------------- SLAB -------------------------------*/
/*------------------------------- SLAB -------------------------------*/


#ifdef NEED_UNDERSCORE
#define slab_superwrap_create            slab_superwrap_create_
#define slab_superwrap_init              slab_superwrap_init_
#define slab_superwrap_update            slab_superwrap_update_
#define slab_superwrap_oneset            slab_superwrap_oneset_ 
#define slab_superwrap_twosets           slab_superwrap_twosets_
#define slab_superwrap_wrapup            slab_superwrap_wrapup_
#define slab_superwrap_delete            slab_superwrap_delete_
#elif defined NEED_CAPITALS
#define slab_superwrap_create            SLAB_SUPERWRAP_CREATE
#define slab_superwrap_init              SLAB_SUPERWRAP_INIT
#define slab_superwrap_update            SLAB_SUPERWRAP_UPDATE
#define slab_superwrap_oneset            SLAB_SUPERWRAP_ONESET 
#define slab_superwrap_twosets           SLAB_SUPERWRAP_TWOSETS
#define slab_superwrap_wrapup            SLAB_SUPERWRAP_WRAPUP
#define slab_superwrap_delete            SLAB_SUPERWRAP_DELETE
#endif


ProcessCreate     slab_superwrap_create;
ProcessInitialize slab_superwrap_init;
ProcessUpdate     slab_superwrap_update;
ProcessOneset     slab_superwrap_oneset;
ProcessTwosets    slab_superwrap_twosets;
ProcessWrapup     slab_superwrap_wrapup;
ProcessDelete     slab_superwrap_delete;


void superwrap_slab_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = slab_superwrap_create;
  THIS->initialize = slab_superwrap_init;
  THIS->update     = slab_superwrap_update;
  THIS->oneset     = slab_superwrap_oneset;
  THIS->twosets    = slab_superwrap_twosets;
  THIS->wrapup     = slab_superwrap_wrapup;
  THIS->delete     = slab_superwrap_delete;
}



/*------------------------------- SLICE -------------------------------*/
/*------------------------------- SLICE -------------------------------*/
/*------------------------------- SLICE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define slice_superwrap_create            slice_superwrap_create_
#define slice_superwrap_init              slice_superwrap_init_
#define slice_superwrap_update            slice_superwrap_update_
#define slice_superwrap_oneset            slice_superwrap_oneset_ 
#define slice_superwrap_twosets           slice_superwrap_twosets_
#define slice_superwrap_wrapup            slice_superwrap_wrapup_
#define slice_superwrap_delete            slice_superwrap_delete_
#elif defined NEED_CAPITALS
#define slice_superwrap_create            SLICE_SUPERWRAP_CREATE
#define slice_superwrap_init              SLICE_SUPERWRAP_INIT
#define slice_superwrap_update            SLICE_SUPERWRAP_UPDATE
#define slice_superwrap_oneset            SLICE_SUPERWRAP_ONESET 
#define slice_superwrap_twosets           SLICE_SUPERWRAP_TWOSETS
#define slice_superwrap_wrapup            SLICE_SUPERWRAP_WRAPUP
#define slice_superwrap_delete            SLICE_SUPERWRAP_DELETE
#endif


ProcessCreate     slice_superwrap_create;
ProcessInitialize slice_superwrap_init;
ProcessUpdate     slice_superwrap_update;
ProcessOneset     slice_superwrap_oneset;
ProcessTwosets    slice_superwrap_twosets;
ProcessWrapup     slice_superwrap_wrapup;
ProcessDelete     slice_superwrap_delete;


void superwrap_slice_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = slice_superwrap_create;
  THIS->initialize = slice_superwrap_init;
  THIS->update     = slice_superwrap_update;
  THIS->oneset     = slice_superwrap_oneset;
  THIS->twosets    = slice_superwrap_twosets;
  THIS->wrapup     = slice_superwrap_wrapup;
  THIS->delete     = slice_superwrap_delete;
}



/*------------------------------- SLICER -------------------------------*/
/*------------------------------- SLICER -------------------------------*/
/*------------------------------- SLICER -------------------------------*/


#ifdef NEED_UNDERSCORE
#define slicer_superwrap_create            slicer_superwrap_create_
#define slicer_superwrap_init              slicer_superwrap_init_
#define slicer_superwrap_update            slicer_superwrap_update_
#define slicer_superwrap_oneset            slicer_superwrap_oneset_ 
#define slicer_superwrap_twosets           slicer_superwrap_twosets_
#define slicer_superwrap_wrapup            slicer_superwrap_wrapup_
#define slicer_superwrap_delete            slicer_superwrap_delete_
#elif defined NEED_CAPITALS
#define slicer_superwrap_create            SLICER_SUPERWRAP_CREATE
#define slicer_superwrap_init              SLICER_SUPERWRAP_INIT
#define slicer_superwrap_update            SLICER_SUPERWRAP_UPDATE
#define slicer_superwrap_oneset            SLICER_SUPERWRAP_ONESET 
#define slicer_superwrap_twosets           SLICER_SUPERWRAP_TWOSETS
#define slicer_superwrap_wrapup            SLICER_SUPERWRAP_WRAPUP
#define slicer_superwrap_delete            SLICER_SUPERWRAP_DELETE
#endif


ProcessCreate     slicer_superwrap_create;
ProcessInitialize slicer_superwrap_init;
ProcessUpdate     slicer_superwrap_update;
ProcessOneset     slicer_superwrap_oneset;
ProcessTwosets    slicer_superwrap_twosets;
ProcessWrapup     slicer_superwrap_wrapup;
ProcessDelete     slicer_superwrap_delete;


void superwrap_slicer_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = slicer_superwrap_create;
  THIS->initialize = slicer_superwrap_init;
  THIS->update     = slicer_superwrap_update;
  THIS->oneset     = slicer_superwrap_oneset;
  THIS->twosets    = slicer_superwrap_twosets;
  THIS->wrapup     = slicer_superwrap_wrapup;
  THIS->delete     = slicer_superwrap_delete;
}



/*------------------------------- SLST -------------------------------*/
/*------------------------------- SLST -------------------------------*/
/*------------------------------- SLST -------------------------------*/


#ifdef NEED_UNDERSCORE
#define slst_superwrap_create            slst_superwrap_create_
#define slst_superwrap_init              slst_superwrap_init_
#define slst_superwrap_update            slst_superwrap_update_
#define slst_superwrap_oneset            slst_superwrap_oneset_ 
#define slst_superwrap_twosets           slst_superwrap_twosets_
#define slst_superwrap_wrapup            slst_superwrap_wrapup_
#define slst_superwrap_delete            slst_superwrap_delete_
#elif defined NEED_CAPITALS
#define slst_superwrap_create            SLST_SUPERWRAP_CREATE
#define slst_superwrap_init              SLST_SUPERWRAP_INIT
#define slst_superwrap_update            SLST_SUPERWRAP_UPDATE
#define slst_superwrap_oneset            SLST_SUPERWRAP_ONESET 
#define slst_superwrap_twosets           SLST_SUPERWRAP_TWOSETS
#define slst_superwrap_wrapup            SLST_SUPERWRAP_WRAPUP
#define slst_superwrap_delete            SLST_SUPERWRAP_DELETE
#endif


ProcessCreate     slst_superwrap_create;
ProcessInitialize slst_superwrap_init;
ProcessUpdate     slst_superwrap_update;
ProcessOneset     slst_superwrap_oneset;
ProcessTwosets    slst_superwrap_twosets;
ProcessWrapup     slst_superwrap_wrapup;
ProcessDelete     slst_superwrap_delete;


void superwrap_slst_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = slst_superwrap_create;
  THIS->initialize = slst_superwrap_init;
  THIS->update     = slst_superwrap_update;
  THIS->oneset     = slst_superwrap_oneset;
  THIS->twosets    = slst_superwrap_twosets;
  THIS->wrapup     = slst_superwrap_wrapup;
  THIS->delete     = slst_superwrap_delete;
}



/*------------------------------- SPCT -------------------------------*/
/*------------------------------- SPCT -------------------------------*/
/*------------------------------- SPCT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define spct_superwrap_create            spct_superwrap_create_
#define spct_superwrap_init              spct_superwrap_init_
#define spct_superwrap_update            spct_superwrap_update_
#define spct_superwrap_oneset            spct_superwrap_oneset_ 
#define spct_superwrap_twosets           spct_superwrap_twosets_
#define spct_superwrap_wrapup            spct_superwrap_wrapup_
#define spct_superwrap_delete            spct_superwrap_delete_
#elif defined NEED_CAPITALS
#define spct_superwrap_create            SPCT_SUPERWRAP_CREATE
#define spct_superwrap_init              SPCT_SUPERWRAP_INIT
#define spct_superwrap_update            SPCT_SUPERWRAP_UPDATE
#define spct_superwrap_oneset            SPCT_SUPERWRAP_ONESET 
#define spct_superwrap_twosets           SPCT_SUPERWRAP_TWOSETS
#define spct_superwrap_wrapup            SPCT_SUPERWRAP_WRAPUP
#define spct_superwrap_delete            SPCT_SUPERWRAP_DELETE
#endif


ProcessCreate     spct_superwrap_create;
ProcessInitialize spct_superwrap_init;
ProcessUpdate     spct_superwrap_update;
ProcessOneset     spct_superwrap_oneset;
ProcessTwosets    spct_superwrap_twosets;
ProcessWrapup     spct_superwrap_wrapup;
ProcessDelete     spct_superwrap_delete;


void superwrap_spct_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = spct_superwrap_create;
  THIS->initialize = spct_superwrap_init;
  THIS->update     = spct_superwrap_update;
  THIS->oneset     = spct_superwrap_oneset;
  THIS->twosets    = spct_superwrap_twosets;
  THIS->wrapup     = spct_superwrap_wrapup;
  THIS->delete     = spct_superwrap_delete;
}



/*------------------------------- SPIKE -------------------------------*/
/*------------------------------- SPIKE -------------------------------*/
/*------------------------------- SPIKE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define spike_superwrap_create            spike_superwrap_create_
#define spike_superwrap_init              spike_superwrap_init_
#define spike_superwrap_update            spike_superwrap_update_
#define spike_superwrap_oneset            spike_superwrap_oneset_ 
#define spike_superwrap_twosets           spike_superwrap_twosets_
#define spike_superwrap_wrapup            spike_superwrap_wrapup_
#define spike_superwrap_delete            spike_superwrap_delete_
#elif defined NEED_CAPITALS
#define spike_superwrap_create            SPIKE_SUPERWRAP_CREATE
#define spike_superwrap_init              SPIKE_SUPERWRAP_INIT
#define spike_superwrap_update            SPIKE_SUPERWRAP_UPDATE
#define spike_superwrap_oneset            SPIKE_SUPERWRAP_ONESET 
#define spike_superwrap_twosets           SPIKE_SUPERWRAP_TWOSETS
#define spike_superwrap_wrapup            SPIKE_SUPERWRAP_WRAPUP
#define spike_superwrap_delete            SPIKE_SUPERWRAP_DELETE
#endif


ProcessCreate     spike_superwrap_create;
ProcessInitialize spike_superwrap_init;
ProcessUpdate     spike_superwrap_update;
ProcessOneset     spike_superwrap_oneset;
ProcessTwosets    spike_superwrap_twosets;
ProcessWrapup     spike_superwrap_wrapup;
ProcessDelete     spike_superwrap_delete;


void superwrap_spike_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = spike_superwrap_create;
  THIS->initialize = spike_superwrap_init;
  THIS->update     = spike_superwrap_update;
  THIS->oneset     = spike_superwrap_oneset;
  THIS->twosets    = spike_superwrap_twosets;
  THIS->wrapup     = spike_superwrap_wrapup;
  THIS->delete     = spike_superwrap_delete;
}


/*------------------------------- TXINTERP -------------------------------*/
/*------------------------------- TXINTERP -------------------------------*/
/*------------------------------- TXINTERP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define txinterp_superwrap_create            txinterp_superwrap_create_
#define txinterp_superwrap_init              txinterp_superwrap_init_
#define txinterp_superwrap_update            txinterp_superwrap_update_
#define txinterp_superwrap_oneset            txinterp_superwrap_oneset_ 
#define txinterp_superwrap_twosets           txinterp_superwrap_twosets_
#define txinterp_superwrap_wrapup            txinterp_superwrap_wrapup_
#define txinterp_superwrap_delete            txinterp_superwrap_delete_
#elif defined NEED_CAPITALS
#define txinterp_superwrap_create            TXINTERP_SUPERWRAP_CREATE
#define txinterp_superwrap_init              TXINTERP_SUPERWRAP_INIT
#define txinterp_superwrap_update            TXINTERP_SUPERWRAP_UPDATE
#define txinterp_superwrap_oneset            TXINTERP_SUPERWRAP_ONESET 
#define txinterp_superwrap_twosets           TXINTERP_SUPERWRAP_TWOSETS
#define txinterp_superwrap_wrapup            TXINTERP_SUPERWRAP_WRAPUP
#define txinterp_superwrap_delete            TXINTERP_SUPERWRAP_DELETE
#endif


ProcessCreate     txinterp_superwrap_create;
ProcessInitialize txinterp_superwrap_init;
ProcessUpdate     txinterp_superwrap_update;
ProcessOneset     txinterp_superwrap_oneset;
ProcessTwosets    txinterp_superwrap_twosets;
ProcessWrapup     txinterp_superwrap_wrapup;
ProcessDelete     txinterp_superwrap_delete;


void superwrap_txinterp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = txinterp_superwrap_create;
  THIS->initialize = txinterp_superwrap_init;
  THIS->update     = txinterp_superwrap_update;
  THIS->oneset     = txinterp_superwrap_oneset;
  THIS->twosets    = txinterp_superwrap_twosets;
  THIS->wrapup     = txinterp_superwrap_wrapup;
  THIS->delete     = txinterp_superwrap_delete;
}


/*------------------------------- SPLT -------------------------------*/
/*------------------------------- SPLT -------------------------------*/
/*------------------------------- SPLT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define splt_superwrap_create            splt_superwrap_create_
#define splt_superwrap_init              splt_superwrap_init_
#define splt_superwrap_update            splt_superwrap_update_
#define splt_superwrap_oneset            splt_superwrap_oneset_ 
#define splt_superwrap_twosets           splt_superwrap_twosets_
#define splt_superwrap_wrapup            splt_superwrap_wrapup_
#define splt_superwrap_delete            splt_superwrap_delete_
#elif defined NEED_CAPITALS
#define splt_superwrap_create            SPLT_SUPERWRAP_CREATE
#define splt_superwrap_init              SPLT_SUPERWRAP_INIT
#define splt_superwrap_update            SPLT_SUPERWRAP_UPDATE
#define splt_superwrap_oneset            SPLT_SUPERWRAP_ONESET 
#define splt_superwrap_twosets           SPLT_SUPERWRAP_TWOSETS
#define splt_superwrap_wrapup            SPLT_SUPERWRAP_WRAPUP
#define splt_superwrap_delete            SPLT_SUPERWRAP_DELETE
#endif


ProcessCreate     splt_superwrap_create;
ProcessInitialize splt_superwrap_init;
ProcessUpdate     splt_superwrap_update;
ProcessOneset     splt_superwrap_oneset;
ProcessTwosets    splt_superwrap_twosets;
ProcessWrapup     splt_superwrap_wrapup;
ProcessDelete     splt_superwrap_delete;


void superwrap_splt_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = splt_superwrap_create;
  THIS->initialize = splt_superwrap_init;
  THIS->update     = splt_superwrap_update;
  THIS->oneset     = splt_superwrap_oneset;
  THIS->twosets    = splt_superwrap_twosets;
  THIS->wrapup     = splt_superwrap_wrapup;
  THIS->delete     = splt_superwrap_delete;
}


/*------------------------------- SPSRPS -------------------------------*/
/*------------------------------- SPSRPS -------------------------------*/
/*------------------------------- SPSRPS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define spsrps_superwrap_create            spsrps_superwrap_create_
#define spsrps_superwrap_init              spsrps_superwrap_init_
#define spsrps_superwrap_update            spsrps_superwrap_update_
#define spsrps_superwrap_oneset            spsrps_superwrap_oneset_
#define spsrps_superwrap_twosets           spsrps_superwrap_twosets_
#define spsrps_superwrap_wrapup            spsrps_superwrap_wrapup_
#define spsrps_superwrap_delete            spsrps_superwrap_delete_
#elif defined NEED_CAPITALS
#define spsrps_superwrap_create            SPSRPS_SUPERWRAP_CREATE
#define spsrps_superwrap_init              SPSRPS_SUPERWRAP_INIT
#define spsrps_superwrap_update            SPSRPS_SUPERWRAP_UPDATE
#define spsrps_superwrap_oneset            SPSRPS_SUPERWRAP_ONESET 
#define spsrps_superwrap_twosets           SPSRPS_SUPERWRAP_TWOSETS
#define spsrps_superwrap_wrapup            SPSRPS_SUPERWRAP_WRAPUP
#define spsrps_superwrap_delete            SPSRPS_SUPERWRAP_DELETE
#endif


ProcessCreate     spsrps_superwrap_create;
ProcessInitialize spsrps_superwrap_init;
ProcessUpdate     spsrps_superwrap_update;
ProcessOneset     spsrps_superwrap_oneset;
ProcessTwosets    spsrps_superwrap_twosets;
ProcessWrapup     spsrps_superwrap_wrapup;
ProcessDelete     spsrps_superwrap_delete;


void superwrap_spsrps_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = spsrps_superwrap_create;
  THIS->initialize = spsrps_superwrap_init;
  THIS->update     = spsrps_superwrap_update;
  THIS->oneset     = spsrps_superwrap_oneset;
  THIS->twosets    = spsrps_superwrap_twosets;
  THIS->wrapup     = spsrps_superwrap_wrapup;
  THIS->delete     = spsrps_superwrap_delete;
}




/*------------------------------- SPTI -------------------------------*/
/*------------------------------- SPTI -------------------------------*/
/*------------------------------- SPTI -------------------------------*/


#ifdef NEED_UNDERSCORE
#define spti_superwrap_create            spti_superwrap_create_
#define spti_superwrap_init              spti_superwrap_init_
#define spti_superwrap_update            spti_superwrap_update_
#define spti_superwrap_oneset            spti_superwrap_oneset_ 
#define spti_superwrap_twosets           spti_superwrap_twosets_
#define spti_superwrap_wrapup            spti_superwrap_wrapup_
#define spti_superwrap_delete            spti_superwrap_delete_
#elif defined NEED_CAPITALS
#define spti_superwrap_create            SPTI_SUPERWRAP_CREATE
#define spti_superwrap_init              SPTI_SUPERWRAP_INIT
#define spti_superwrap_update            SPTI_SUPERWRAP_UPDATE
#define spti_superwrap_oneset            SPTI_SUPERWRAP_ONESET 
#define spti_superwrap_twosets           SPTI_SUPERWRAP_TWOSETS
#define spti_superwrap_wrapup            SPTI_SUPERWRAP_WRAPUP
#define spti_superwrap_delete            SPTI_SUPERWRAP_DELETE
#endif


ProcessCreate     spti_superwrap_create;
ProcessInitialize spti_superwrap_init;
ProcessUpdate     spti_superwrap_update;
ProcessOneset     spti_superwrap_oneset;
ProcessTwosets    spti_superwrap_twosets;
ProcessWrapup     spti_superwrap_wrapup;
ProcessDelete     spti_superwrap_delete;


void superwrap_spti_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = spti_superwrap_create;
  THIS->initialize = spti_superwrap_init;
  THIS->update     = spti_superwrap_update;
  THIS->oneset     = spti_superwrap_oneset;
  THIS->twosets    = spti_superwrap_twosets;
  THIS->wrapup     = spti_superwrap_wrapup;
  THIS->delete     = spti_superwrap_delete;
}



/*------------------------------- STK -------------------------------*/
/*------------------------------- STK -------------------------------*/
/*------------------------------- STK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define stk_superwrap_create            stk_superwrap_create_
#define stk_superwrap_init              stk_superwrap_init_
#define stk_superwrap_update            stk_superwrap_update_
#define stk_superwrap_oneset            stk_superwrap_oneset_ 
#define stk_superwrap_twosets           stk_superwrap_twosets_
#define stk_superwrap_wrapup            stk_superwrap_wrapup_
#define stk_superwrap_delete            stk_superwrap_delete_
#elif defined NEED_CAPITALS
#define stk_superwrap_create            STK_SUPERWRAP_CREATE
#define stk_superwrap_init              STK_SUPERWRAP_INIT
#define stk_superwrap_update            STK_SUPERWRAP_UPDATE
#define stk_superwrap_oneset            STK_SUPERWRAP_ONESET 
#define stk_superwrap_twosets           STK_SUPERWRAP_TWOSETS
#define stk_superwrap_wrapup            STK_SUPERWRAP_WRAPUP
#define stk_superwrap_delete            STK_SUPERWRAP_DELETE
#endif


ProcessCreate     stk_superwrap_create;
ProcessInitialize stk_superwrap_init;
ProcessUpdate     stk_superwrap_update;
ProcessOneset     stk_superwrap_oneset;
ProcessTwosets    stk_superwrap_twosets;
ProcessWrapup     stk_superwrap_wrapup;
ProcessDelete     stk_superwrap_delete;


void superwrap_stk_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = stk_superwrap_create;
  THIS->initialize = stk_superwrap_init;
  THIS->update     = stk_superwrap_update;
  THIS->oneset     = stk_superwrap_oneset;
  THIS->twosets    = stk_superwrap_twosets;
  THIS->wrapup     = stk_superwrap_wrapup;
  THIS->delete     = stk_superwrap_delete;
}



/*------------------------------- STRETCH -------------------------------*/
/*------------------------------- STRETCH -------------------------------*/
/*------------------------------- STRETCH -------------------------------*/


#ifdef NEED_UNDERSCORE
#define stretch_superwrap_create            stretch_superwrap_create_
#define stretch_superwrap_init              stretch_superwrap_init_
#define stretch_superwrap_update            stretch_superwrap_update_
#define stretch_superwrap_oneset            stretch_superwrap_oneset_ 
#define stretch_superwrap_twosets           stretch_superwrap_twosets_
#define stretch_superwrap_wrapup            stretch_superwrap_wrapup_
#define stretch_superwrap_delete            stretch_superwrap_delete_
#elif defined NEED_CAPITALS
#define stretch_superwrap_create            STRETCH_SUPERWRAP_CREATE
#define stretch_superwrap_init              STRETCH_SUPERWRAP_INIT
#define stretch_superwrap_update            STRETCH_SUPERWRAP_UPDATE
#define stretch_superwrap_oneset            STRETCH_SUPERWRAP_ONESET 
#define stretch_superwrap_twosets           STRETCH_SUPERWRAP_TWOSETS
#define stretch_superwrap_wrapup            STRETCH_SUPERWRAP_WRAPUP
#define stretch_superwrap_delete            STRETCH_SUPERWRAP_DELETE
#endif


ProcessCreate     stretch_superwrap_create;
ProcessInitialize stretch_superwrap_init;
ProcessUpdate     stretch_superwrap_update;
ProcessOneset     stretch_superwrap_oneset;
ProcessTwosets    stretch_superwrap_twosets;
ProcessWrapup     stretch_superwrap_wrapup;
ProcessDelete     stretch_superwrap_delete;


void superwrap_stretch_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = stretch_superwrap_create;
  THIS->initialize = stretch_superwrap_init;
  THIS->update     = stretch_superwrap_update;
  THIS->oneset     = stretch_superwrap_oneset;
  THIS->twosets    = stretch_superwrap_twosets;
  THIS->wrapup     = stretch_superwrap_wrapup;
  THIS->delete     = stretch_superwrap_delete;
}


/*------------------------------- SUPROCESS -------------------------------*/
/*------------------------------- SUPROCESS -------------------------------*/
/*------------------------------- SUPROCESS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define suprocess_superwrap_create            suprocess_superwrap_create_
#define suprocess_superwrap_init              suprocess_superwrap_init_
#define suprocess_superwrap_update            suprocess_superwrap_update_
#define suprocess_superwrap_oneset            suprocess_superwrap_oneset_
#define suprocess_superwrap_twosets           suprocess_superwrap_twosets_
#define suprocess_superwrap_wrapup            suprocess_superwrap_wrapup_
#define suprocess_superwrap_delete            suprocess_superwrap_delete_
#elif defined NEED_CAPITALS
#define suprocess_superwrap_create            SUPROCESS_SUPERWRAP_CREATE
#define suprocess_superwrap_init              SUPROCESS_SUPERWRAP_INIT
#define suprocess_superwrap_update            SUPROCESS_SUPERWRAP_UPDATE
#define suprocess_superwrap_oneset            SUPROCESS_SUPERWRAP_ONESET
#define suprocess_superwrap_twosets           SUPROCESS_SUPERWRAP_TWOSETS
#define suprocess_superwrap_wrapup            SUPROCESS_SUPERWRAP_WRAPUP
#define suprocess_superwrap_delete            SUPROCESS_SUPERWRAP_DELETE
#endif


ProcessCreate     suprocess_superwrap_create;
ProcessInitialize suprocess_superwrap_init;
ProcessUpdate     suprocess_superwrap_update;
ProcessOneset     suprocess_superwrap_oneset;
ProcessTwosets    suprocess_superwrap_twosets;
ProcessWrapup     suprocess_superwrap_wrapup;
ProcessDelete     suprocess_superwrap_delete;


void superwrap_suprocess_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = suprocess_superwrap_create;
  THIS->initialize = suprocess_superwrap_init;
  THIS->update     = suprocess_superwrap_update;
  THIS->oneset     = suprocess_superwrap_oneset;
  THIS->twosets    = suprocess_superwrap_twosets;
  THIS->wrapup     = suprocess_superwrap_wrapup;
  THIS->delete     = suprocess_superwrap_delete;
}


/*------------------------------- SVA -------------------------------*/
/*------------------------------- SVA -------------------------------*/
/*------------------------------- SVA -------------------------------*/


#ifdef NEED_UNDERSCORE
#define sva_superwrap_create            sva_superwrap_create_
#define sva_superwrap_init              sva_superwrap_init_
#define sva_superwrap_update            sva_superwrap_update_
#define sva_superwrap_oneset            sva_superwrap_oneset_ 
#define sva_superwrap_twosets           sva_superwrap_twosets_
#define sva_superwrap_wrapup            sva_superwrap_wrapup_
#define sva_superwrap_delete            sva_superwrap_delete_
#elif defined NEED_CAPITALS
#define sva_superwrap_create            SVA_SUPERWRAP_CREATE
#define sva_superwrap_init              SVA_SUPERWRAP_INIT
#define sva_superwrap_update            SVA_SUPERWRAP_UPDATE
#define sva_superwrap_oneset            SVA_SUPERWRAP_ONESET 
#define sva_superwrap_twosets           SVA_SUPERWRAP_TWOSETS
#define sva_superwrap_wrapup            SVA_SUPERWRAP_WRAPUP
#define sva_superwrap_delete            SVA_SUPERWRAP_DELETE
#endif


ProcessCreate     sva_superwrap_create;
ProcessInitialize sva_superwrap_init;
ProcessUpdate     sva_superwrap_update;
ProcessOneset     sva_superwrap_oneset;
ProcessTwosets    sva_superwrap_twosets;
ProcessWrapup     sva_superwrap_wrapup;
ProcessDelete     sva_superwrap_delete;


void superwrap_sva_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = sva_superwrap_create;
  THIS->initialize = sva_superwrap_init;
  THIS->update     = sva_superwrap_update;
  THIS->oneset     = sva_superwrap_oneset;
  THIS->twosets    = sva_superwrap_twosets;
  THIS->wrapup     = sva_superwrap_wrapup;
  THIS->delete     = sva_superwrap_delete;
}



/*------------------------------- SYNBP -------------------------------*/
/*------------------------------- SYNBP -------------------------------*/
/*------------------------------- SYNBP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define synbp_superwrap_create            synbp_superwrap_create_
#define synbp_superwrap_init              synbp_superwrap_init_
#define synbp_superwrap_update            synbp_superwrap_update_
#define synbp_superwrap_oneset            synbp_superwrap_oneset_ 
#define synbp_superwrap_twosets           synbp_superwrap_twosets_
#define synbp_superwrap_wrapup            synbp_superwrap_wrapup_
#define synbp_superwrap_delete            synbp_superwrap_delete_
#elif defined NEED_CAPITALS
#define synbp_superwrap_create            SYNBP_SUPERWRAP_CREATE
#define synbp_superwrap_init              SYNBP_SUPERWRAP_INIT
#define synbp_superwrap_update            SYNBP_SUPERWRAP_UPDATE
#define synbp_superwrap_oneset            SYNBP_SUPERWRAP_ONESET 
#define synbp_superwrap_twosets           SYNBP_SUPERWRAP_TWOSETS
#define synbp_superwrap_wrapup            SYNBP_SUPERWRAP_WRAPUP
#define synbp_superwrap_delete            SYNBP_SUPERWRAP_DELETE
#endif


ProcessCreate     synbp_superwrap_create;
ProcessInitialize synbp_superwrap_init;
ProcessUpdate     synbp_superwrap_update;
ProcessOneset     synbp_superwrap_oneset;
ProcessTwosets    synbp_superwrap_twosets;
ProcessWrapup     synbp_superwrap_wrapup;
ProcessDelete     synbp_superwrap_delete;


void superwrap_synbp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = synbp_superwrap_create;
  THIS->initialize = synbp_superwrap_init;
  THIS->update     = synbp_superwrap_update;
  THIS->oneset     = synbp_superwrap_oneset;
  THIS->twosets    = synbp_superwrap_twosets;
  THIS->wrapup     = synbp_superwrap_wrapup;
  THIS->delete     = synbp_superwrap_delete;
}



/*------------------------------- TABLESAVE -------------------------------*/
/*------------------------------- TABLESAVE -------------------------------*/
/*------------------------------- TABLESAVE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tablesave_superwrap_create            tablesave_superwrap_create_
#define tablesave_superwrap_init              tablesave_superwrap_init_
#define tablesave_superwrap_update            tablesave_superwrap_update_
#define tablesave_superwrap_oneset            tablesave_superwrap_oneset_ 
#define tablesave_superwrap_twosets           tablesave_superwrap_twosets_
#define tablesave_superwrap_wrapup            tablesave_superwrap_wrapup_
#define tablesave_superwrap_delete            tablesave_superwrap_delete_
#elif defined NEED_CAPITALS
#define tablesave_superwrap_create            TABLESAVE_SUPERWRAP_CREATE
#define tablesave_superwrap_init              TABLESAVE_SUPERWRAP_INIT
#define tablesave_superwrap_update            TABLESAVE_SUPERWRAP_UPDATE
#define tablesave_superwrap_oneset            TABLESAVE_SUPERWRAP_ONESET 
#define tablesave_superwrap_twosets           TABLESAVE_SUPERWRAP_TWOSETS
#define tablesave_superwrap_wrapup            TABLESAVE_SUPERWRAP_WRAPUP
#define tablesave_superwrap_delete            TABLESAVE_SUPERWRAP_DELETE
#endif


ProcessCreate     tablesave_superwrap_create;
ProcessInitialize tablesave_superwrap_init;
ProcessUpdate     tablesave_superwrap_update;
ProcessOneset     tablesave_superwrap_oneset;
ProcessTwosets    tablesave_superwrap_twosets;
ProcessWrapup     tablesave_superwrap_wrapup;
ProcessDelete     tablesave_superwrap_delete;


void superwrap_tablesave_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tablesave_superwrap_create;
  THIS->initialize = tablesave_superwrap_init;
  THIS->update     = tablesave_superwrap_update;
  THIS->oneset     = tablesave_superwrap_oneset;
  THIS->twosets    = tablesave_superwrap_twosets;
  THIS->wrapup     = tablesave_superwrap_wrapup;
  THIS->delete     = tablesave_superwrap_delete;
}



/*------------------------------- TABLESORT -------------------------------*/
/*------------------------------- TABLESORT -------------------------------*/
/*------------------------------- TABLESORT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tablesort_superwrap_create            tablesort_superwrap_create_
#define tablesort_superwrap_init              tablesort_superwrap_init_
#define tablesort_superwrap_update            tablesort_superwrap_update_
#define tablesort_superwrap_oneset            tablesort_superwrap_oneset_ 
#define tablesort_superwrap_twosets           tablesort_superwrap_twosets_
#define tablesort_superwrap_wrapup            tablesort_superwrap_wrapup_
#define tablesort_superwrap_delete            tablesort_superwrap_delete_
#elif defined NEED_CAPITALS
#define tablesort_superwrap_create            TABLESORT_SUPERWRAP_CREATE
#define tablesort_superwrap_init              TABLESORT_SUPERWRAP_INIT
#define tablesort_superwrap_update            TABLESORT_SUPERWRAP_UPDATE
#define tablesort_superwrap_oneset            TABLESORT_SUPERWRAP_ONESET 
#define tablesort_superwrap_twosets           TABLESORT_SUPERWRAP_TWOSETS
#define tablesort_superwrap_wrapup            TABLESORT_SUPERWRAP_WRAPUP
#define tablesort_superwrap_delete            TABLESORT_SUPERWRAP_DELETE
#endif


ProcessCreate     tablesort_superwrap_create;
ProcessInitialize tablesort_superwrap_init;
ProcessUpdate     tablesort_superwrap_update;
ProcessOneset     tablesort_superwrap_oneset;
ProcessTwosets    tablesort_superwrap_twosets;
ProcessWrapup     tablesort_superwrap_wrapup;
ProcessDelete     tablesort_superwrap_delete;


void superwrap_tablesort_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tablesort_superwrap_create;
  THIS->initialize = tablesort_superwrap_init;
  THIS->update     = tablesort_superwrap_update;
  THIS->oneset     = tablesort_superwrap_oneset;
  THIS->twosets    = tablesort_superwrap_twosets;
  THIS->wrapup     = tablesort_superwrap_wrapup;
  THIS->delete     = tablesort_superwrap_delete;
}



/*------------------------------- TDC -------------------------------*/
/*------------------------------- TDC -------------------------------*/
/*------------------------------- TDC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tdc_superwrap_create            tdc_superwrap_create_
#define tdc_superwrap_init              tdc_superwrap_init_
#define tdc_superwrap_update            tdc_superwrap_update_
#define tdc_superwrap_oneset            tdc_superwrap_oneset_ 
#define tdc_superwrap_twosets           tdc_superwrap_twosets_
#define tdc_superwrap_wrapup            tdc_superwrap_wrapup_
#define tdc_superwrap_delete            tdc_superwrap_delete_
#elif defined NEED_CAPITALS
#define tdc_superwrap_create            TDC_SUPERWRAP_CREATE
#define tdc_superwrap_init              TDC_SUPERWRAP_INIT
#define tdc_superwrap_update            TDC_SUPERWRAP_UPDATE
#define tdc_superwrap_oneset            TDC_SUPERWRAP_ONESET 
#define tdc_superwrap_twosets           TDC_SUPERWRAP_TWOSETS
#define tdc_superwrap_wrapup            TDC_SUPERWRAP_WRAPUP
#define tdc_superwrap_delete            TDC_SUPERWRAP_DELETE
#endif


ProcessCreate     tdc_superwrap_create;
ProcessInitialize tdc_superwrap_init;
ProcessUpdate     tdc_superwrap_update;
ProcessOneset     tdc_superwrap_oneset;
ProcessTwosets    tdc_superwrap_twosets;
ProcessWrapup     tdc_superwrap_wrapup;
ProcessDelete     tdc_superwrap_delete;


void superwrap_tdc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tdc_superwrap_create;
  THIS->initialize = tdc_superwrap_init;
  THIS->update     = tdc_superwrap_update;
  THIS->oneset     = tdc_superwrap_oneset;
  THIS->twosets    = tdc_superwrap_twosets;
  THIS->wrapup     = tdc_superwrap_wrapup;
  THIS->delete     = tdc_superwrap_delete;
}



/*------------------------------- TDMP -------------------------------*/
/*------------------------------- TDMP -------------------------------*/
/*------------------------------- TDMP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tdmp_superwrap_create            tdmp_superwrap_create_
#define tdmp_superwrap_init              tdmp_superwrap_init_
#define tdmp_superwrap_update            tdmp_superwrap_update_
#define tdmp_superwrap_oneset            tdmp_superwrap_oneset_ 
#define tdmp_superwrap_twosets           tdmp_superwrap_twosets_
#define tdmp_superwrap_wrapup            tdmp_superwrap_wrapup_
#define tdmp_superwrap_delete            tdmp_superwrap_delete_
#elif defined NEED_CAPITALS
#define tdmp_superwrap_create            TDMP_SUPERWRAP_CREATE
#define tdmp_superwrap_init              TDMP_SUPERWRAP_INIT
#define tdmp_superwrap_update            TDMP_SUPERWRAP_UPDATE
#define tdmp_superwrap_oneset            TDMP_SUPERWRAP_ONESET 
#define tdmp_superwrap_twosets           TDMP_SUPERWRAP_TWOSETS
#define tdmp_superwrap_wrapup            TDMP_SUPERWRAP_WRAPUP
#define tdmp_superwrap_delete            TDMP_SUPERWRAP_DELETE
#endif


ProcessCreate     tdmp_superwrap_create;
ProcessInitialize tdmp_superwrap_init;
ProcessUpdate     tdmp_superwrap_update;
ProcessOneset     tdmp_superwrap_oneset;
ProcessTwosets    tdmp_superwrap_twosets;
ProcessWrapup     tdmp_superwrap_wrapup;
ProcessDelete     tdmp_superwrap_delete;


void superwrap_tdmp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tdmp_superwrap_create;
  THIS->initialize = tdmp_superwrap_init;
  THIS->update     = tdmp_superwrap_update;
  THIS->oneset     = tdmp_superwrap_oneset;
  THIS->twosets    = tdmp_superwrap_twosets;
  THIS->wrapup     = tdmp_superwrap_wrapup;
  THIS->delete     = tdmp_superwrap_delete;
}



/*------------------------------- TELAV -------------------------------*/
/*------------------------------- TELAV -------------------------------*/
/*------------------------------- TELAV -------------------------------*/


#ifdef NEED_UNDERSCORE
#define telav_superwrap_create            telav_superwrap_create_
#define telav_superwrap_init              telav_superwrap_init_
#define telav_superwrap_update            telav_superwrap_update_
#define telav_superwrap_oneset            telav_superwrap_oneset_ 
#define telav_superwrap_twosets           telav_superwrap_twosets_
#define telav_superwrap_wrapup            telav_superwrap_wrapup_
#define telav_superwrap_delete            telav_superwrap_delete_
#elif defined NEED_CAPITALS
#define telav_superwrap_create            TELAV_SUPERWRAP_CREATE
#define telav_superwrap_init              TELAV_SUPERWRAP_INIT
#define telav_superwrap_update            TELAV_SUPERWRAP_UPDATE
#define telav_superwrap_oneset            TELAV_SUPERWRAP_ONESET 
#define telav_superwrap_twosets           TELAV_SUPERWRAP_TWOSETS
#define telav_superwrap_wrapup            TELAV_SUPERWRAP_WRAPUP
#define telav_superwrap_delete            TELAV_SUPERWRAP_DELETE
#endif


ProcessCreate     telav_superwrap_create;
ProcessInitialize telav_superwrap_init;
ProcessUpdate     telav_superwrap_update;
ProcessOneset     telav_superwrap_oneset;
ProcessTwosets    telav_superwrap_twosets;
ProcessWrapup     telav_superwrap_wrapup;
ProcessDelete     telav_superwrap_delete;


void superwrap_telav_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = telav_superwrap_create;
  THIS->initialize = telav_superwrap_init;
  THIS->update     = telav_superwrap_update;
  THIS->oneset     = telav_superwrap_oneset;
  THIS->twosets    = telav_superwrap_twosets;
  THIS->wrapup     = telav_superwrap_wrapup;
  THIS->delete     = telav_superwrap_delete;
}



/*------------------------------- TFATT -------------------------------*/
/*------------------------------- TFATT -------------------------------*/
/*------------------------------- TFATT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tfatt_superwrap_create            tfatt_superwrap_create_
#define tfatt_superwrap_init              tfatt_superwrap_init_
#define tfatt_superwrap_update            tfatt_superwrap_update_
#define tfatt_superwrap_oneset            tfatt_superwrap_oneset_ 
#define tfatt_superwrap_twosets           tfatt_superwrap_twosets_
#define tfatt_superwrap_wrapup            tfatt_superwrap_wrapup_
#define tfatt_superwrap_delete            tfatt_superwrap_delete_
#elif defined NEED_CAPITALS
#define tfatt_superwrap_create            TFATT_SUPERWRAP_CREATE
#define tfatt_superwrap_init              TFATT_SUPERWRAP_INIT
#define tfatt_superwrap_update            TFATT_SUPERWRAP_UPDATE
#define tfatt_superwrap_oneset            TFATT_SUPERWRAP_ONESET 
#define tfatt_superwrap_twosets           TFATT_SUPERWRAP_TWOSETS
#define tfatt_superwrap_wrapup            TFATT_SUPERWRAP_WRAPUP
#define tfatt_superwrap_delete            TFATT_SUPERWRAP_DELETE
#endif


ProcessCreate     tfatt_superwrap_create;
ProcessInitialize tfatt_superwrap_init;
ProcessUpdate     tfatt_superwrap_update;
ProcessOneset     tfatt_superwrap_oneset;
ProcessTwosets    tfatt_superwrap_twosets;
ProcessWrapup     tfatt_superwrap_wrapup;
ProcessDelete     tfatt_superwrap_delete;


void superwrap_tfatt_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tfatt_superwrap_create;
  THIS->initialize = tfatt_superwrap_init;
  THIS->update     = tfatt_superwrap_update;
  THIS->oneset     = tfatt_superwrap_oneset;
  THIS->twosets    = tfatt_superwrap_twosets;
  THIS->wrapup     = tfatt_superwrap_wrapup;
  THIS->delete     = tfatt_superwrap_delete;
}



/*------------------------------- TPICK -------------------------------*/
/*------------------------------- TPICK -------------------------------*/
/*------------------------------- TPICK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tpick_superwrap_create            tpick_superwrap_create_
#define tpick_superwrap_init              tpick_superwrap_init_
#define tpick_superwrap_update            tpick_superwrap_update_
#define tpick_superwrap_oneset            tpick_superwrap_oneset_ 
#define tpick_superwrap_twosets           tpick_superwrap_twosets_
#define tpick_superwrap_wrapup            tpick_superwrap_wrapup_
#define tpick_superwrap_delete            tpick_superwrap_delete_
#elif defined NEED_CAPITALS
#define tpick_superwrap_create            TPICK_SUPERWRAP_CREATE
#define tpick_superwrap_init              TPICK_SUPERWRAP_INIT
#define tpick_superwrap_update            TPICK_SUPERWRAP_UPDATE
#define tpick_superwrap_oneset            TPICK_SUPERWRAP_ONESET 
#define tpick_superwrap_twosets           TPICK_SUPERWRAP_TWOSETS
#define tpick_superwrap_wrapup            TPICK_SUPERWRAP_WRAPUP
#define tpick_superwrap_delete            TPICK_SUPERWRAP_DELETE
#endif


ProcessCreate     tpick_superwrap_create;
ProcessInitialize tpick_superwrap_init;
ProcessUpdate     tpick_superwrap_update;
ProcessOneset     tpick_superwrap_oneset;
ProcessTwosets    tpick_superwrap_twosets;
ProcessWrapup     tpick_superwrap_wrapup;
ProcessDelete     tpick_superwrap_delete;


void superwrap_tpick_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tpick_superwrap_create;
  THIS->initialize = tpick_superwrap_init;
  THIS->update     = tpick_superwrap_update;
  THIS->oneset     = tpick_superwrap_oneset;
  THIS->twosets    = tpick_superwrap_twosets;
  THIS->wrapup     = tpick_superwrap_wrapup;
  THIS->delete     = tpick_superwrap_delete;
}



/*------------------------------- TPOW -------------------------------*/
/*------------------------------- TPOW -------------------------------*/
/*------------------------------- TPOW -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tpow_superwrap_create            tpow_superwrap_create_
#define tpow_superwrap_init              tpow_superwrap_init_
#define tpow_superwrap_update            tpow_superwrap_update_
#define tpow_superwrap_oneset            tpow_superwrap_oneset_ 
#define tpow_superwrap_twosets           tpow_superwrap_twosets_
#define tpow_superwrap_wrapup            tpow_superwrap_wrapup_
#define tpow_superwrap_delete            tpow_superwrap_delete_
#elif defined NEED_CAPITALS
#define tpow_superwrap_create            TPOW_SUPERWRAP_CREATE
#define tpow_superwrap_init              TPOW_SUPERWRAP_INIT
#define tpow_superwrap_update            TPOW_SUPERWRAP_UPDATE
#define tpow_superwrap_oneset            TPOW_SUPERWRAP_ONESET 
#define tpow_superwrap_twosets           TPOW_SUPERWRAP_TWOSETS
#define tpow_superwrap_wrapup            TPOW_SUPERWRAP_WRAPUP
#define tpow_superwrap_delete            TPOW_SUPERWRAP_DELETE
#endif


ProcessCreate     tpow_superwrap_create;
ProcessInitialize tpow_superwrap_init;
ProcessUpdate     tpow_superwrap_update;
ProcessOneset     tpow_superwrap_oneset;
ProcessTwosets    tpow_superwrap_twosets;
ProcessWrapup     tpow_superwrap_wrapup;
ProcessDelete     tpow_superwrap_delete;


void superwrap_tpow_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tpow_superwrap_create;
  THIS->initialize = tpow_superwrap_init;
  THIS->update     = tpow_superwrap_update;
  THIS->oneset     = tpow_superwrap_oneset;
  THIS->twosets    = tpow_superwrap_twosets;
  THIS->wrapup     = tpow_superwrap_wrapup;
  THIS->delete     = tpow_superwrap_delete;
}



/*------------------------------- TREDIT -------------------------------*/
/*------------------------------- TREDIT -------------------------------*/
/*------------------------------- TREDIT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tredit_superwrap_create            tredit_superwrap_create_
#define tredit_superwrap_init              tredit_superwrap_init_
#define tredit_superwrap_update            tredit_superwrap_update_
#define tredit_superwrap_oneset            tredit_superwrap_oneset_ 
#define tredit_superwrap_twosets           tredit_superwrap_twosets_
#define tredit_superwrap_wrapup            tredit_superwrap_wrapup_
#define tredit_superwrap_delete            tredit_superwrap_delete_
#elif defined NEED_CAPITALS
#define tredit_superwrap_create            TREDIT_SUPERWRAP_CREATE
#define tredit_superwrap_init              TREDIT_SUPERWRAP_INIT
#define tredit_superwrap_update            TREDIT_SUPERWRAP_UPDATE
#define tredit_superwrap_oneset            TREDIT_SUPERWRAP_ONESET 
#define tredit_superwrap_twosets           TREDIT_SUPERWRAP_TWOSETS
#define tredit_superwrap_wrapup            TREDIT_SUPERWRAP_WRAPUP
#define tredit_superwrap_delete            TREDIT_SUPERWRAP_DELETE
#endif


ProcessCreate     tredit_superwrap_create;
ProcessInitialize tredit_superwrap_init;
ProcessUpdate     tredit_superwrap_update;
ProcessOneset     tredit_superwrap_oneset;
ProcessTwosets    tredit_superwrap_twosets;
ProcessWrapup     tredit_superwrap_wrapup;
ProcessDelete     tredit_superwrap_delete;


void superwrap_tredit_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tredit_superwrap_create;
  THIS->initialize = tredit_superwrap_init;
  THIS->update     = tredit_superwrap_update;
  THIS->oneset     = tredit_superwrap_oneset;
  THIS->twosets    = tredit_superwrap_twosets;
  THIS->wrapup     = tredit_superwrap_wrapup;
  THIS->delete     = tredit_superwrap_delete;
}



/*------------------------------- TRIN -------------------------------*/
/*------------------------------- TRIN -------------------------------*/
/*------------------------------- TRIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define trin_superwrap_create            trin_superwrap_create_
#define trin_superwrap_init              trin_superwrap_init_
#define trin_superwrap_update            trin_superwrap_update_
#define trin_superwrap_oneset            trin_superwrap_oneset_ 
#define trin_superwrap_twosets           trin_superwrap_twosets_
#define trin_superwrap_wrapup            trin_superwrap_wrapup_
#define trin_superwrap_delete            trin_superwrap_delete_
#elif defined NEED_CAPITALS
#define trin_superwrap_create            TRIN_SUPERWRAP_CREATE
#define trin_superwrap_init              TRIN_SUPERWRAP_INIT
#define trin_superwrap_update            TRIN_SUPERWRAP_UPDATE
#define trin_superwrap_oneset            TRIN_SUPERWRAP_ONESET 
#define trin_superwrap_twosets           TRIN_SUPERWRAP_TWOSETS
#define trin_superwrap_wrapup            TRIN_SUPERWRAP_WRAPUP
#define trin_superwrap_delete            TRIN_SUPERWRAP_DELETE
#endif


ProcessCreate     trin_superwrap_create;
ProcessInitialize trin_superwrap_init;
ProcessUpdate     trin_superwrap_update;
ProcessOneset     trin_superwrap_oneset;
ProcessTwosets    trin_superwrap_twosets;
ProcessWrapup     trin_superwrap_wrapup;
ProcessDelete     trin_superwrap_delete;


void superwrap_trin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = trin_superwrap_create;
  THIS->initialize = trin_superwrap_init;
  THIS->update     = trin_superwrap_update;
  THIS->oneset     = trin_superwrap_oneset;
  THIS->twosets    = trin_superwrap_twosets;
  THIS->wrapup     = trin_superwrap_wrapup;
  THIS->delete     = trin_superwrap_delete;
}



/*------------------------------- TRINSORT -------------------------------*/
/*------------------------------- TRINSORT -------------------------------*/
/*------------------------------- TRINSORT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define trinsort_superwrap_create            trinsort_superwrap_create_
#define trinsort_superwrap_init              trinsort_superwrap_init_
#define trinsort_superwrap_update            trinsort_superwrap_update_
#define trinsort_superwrap_oneset            trinsort_superwrap_oneset_ 
#define trinsort_superwrap_twosets           trinsort_superwrap_twosets_
#define trinsort_superwrap_wrapup            trinsort_superwrap_wrapup_
#define trinsort_superwrap_delete            trinsort_superwrap_delete_
#elif defined NEED_CAPITALS
#define trinsort_superwrap_create            TRINSORT_SUPERWRAP_CREATE
#define trinsort_superwrap_init              TRINSORT_SUPERWRAP_INIT
#define trinsort_superwrap_update            TRINSORT_SUPERWRAP_UPDATE
#define trinsort_superwrap_oneset            TRINSORT_SUPERWRAP_ONESET 
#define trinsort_superwrap_twosets           TRINSORT_SUPERWRAP_TWOSETS
#define trinsort_superwrap_wrapup            TRINSORT_SUPERWRAP_WRAPUP
#define trinsort_superwrap_delete            TRINSORT_SUPERWRAP_DELETE
#endif


ProcessCreate     trinsort_superwrap_create;
ProcessInitialize trinsort_superwrap_init;
ProcessUpdate     trinsort_superwrap_update;
ProcessOneset     trinsort_superwrap_oneset;
ProcessTwosets    trinsort_superwrap_twosets;
ProcessWrapup     trinsort_superwrap_wrapup;
ProcessDelete     trinsort_superwrap_delete;


void superwrap_trinsort_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = trinsort_superwrap_create;
  THIS->initialize = trinsort_superwrap_init;
  THIS->update     = trinsort_superwrap_update;
  THIS->oneset     = trinsort_superwrap_oneset;
  THIS->twosets    = trinsort_superwrap_twosets;
  THIS->wrapup     = trinsort_superwrap_wrapup;
  THIS->delete     = trinsort_superwrap_delete;
}



/*------------------------------- TRMO -------------------------------*/
/*------------------------------- TRMO -------------------------------*/
/*------------------------------- TRMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define trmo_superwrap_create            trmo_superwrap_create_
#define trmo_superwrap_init              trmo_superwrap_init_
#define trmo_superwrap_update            trmo_superwrap_update_
#define trmo_superwrap_oneset            trmo_superwrap_oneset_ 
#define trmo_superwrap_twosets           trmo_superwrap_twosets_
#define trmo_superwrap_wrapup            trmo_superwrap_wrapup_
#define trmo_superwrap_delete            trmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define trmo_superwrap_create            TRMO_SUPERWRAP_CREATE
#define trmo_superwrap_init              TRMO_SUPERWRAP_INIT
#define trmo_superwrap_update            TRMO_SUPERWRAP_UPDATE
#define trmo_superwrap_oneset            TRMO_SUPERWRAP_ONESET 
#define trmo_superwrap_twosets           TRMO_SUPERWRAP_TWOSETS
#define trmo_superwrap_wrapup            TRMO_SUPERWRAP_WRAPUP
#define trmo_superwrap_delete            TRMO_SUPERWRAP_DELETE
#endif


ProcessCreate     trmo_superwrap_create;
ProcessInitialize trmo_superwrap_init;
ProcessUpdate     trmo_superwrap_update;
ProcessOneset     trmo_superwrap_oneset;
ProcessTwosets    trmo_superwrap_twosets;
ProcessWrapup     trmo_superwrap_wrapup;
ProcessDelete     trmo_superwrap_delete;


void superwrap_trmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = trmo_superwrap_create;
  THIS->initialize = trmo_superwrap_init;
  THIS->update     = trmo_superwrap_update;
  THIS->oneset     = trmo_superwrap_oneset;
  THIS->twosets    = trmo_superwrap_twosets;
  THIS->wrapup     = trmo_superwrap_wrapup;
  THIS->delete     = trmo_superwrap_delete;
}



/*------------------------------- TROT -------------------------------*/
/*------------------------------- TROT -------------------------------*/
/*------------------------------- TROT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define trot_superwrap_create            trot_superwrap_create_
#define trot_superwrap_init              trot_superwrap_init_
#define trot_superwrap_update            trot_superwrap_update_
#define trot_superwrap_oneset            trot_superwrap_oneset_ 
#define trot_superwrap_twosets           trot_superwrap_twosets_
#define trot_superwrap_wrapup            trot_superwrap_wrapup_
#define trot_superwrap_delete            trot_superwrap_delete_
#elif defined NEED_CAPITALS
#define trot_superwrap_create            TROT_SUPERWRAP_CREATE
#define trot_superwrap_init              TROT_SUPERWRAP_INIT
#define trot_superwrap_update            TROT_SUPERWRAP_UPDATE
#define trot_superwrap_oneset            TROT_SUPERWRAP_ONESET 
#define trot_superwrap_twosets           TROT_SUPERWRAP_TWOSETS
#define trot_superwrap_wrapup            TROT_SUPERWRAP_WRAPUP
#define trot_superwrap_delete            TROT_SUPERWRAP_DELETE
#endif


ProcessCreate     trot_superwrap_create;
ProcessInitialize trot_superwrap_init;
ProcessUpdate     trot_superwrap_update;
ProcessOneset     trot_superwrap_oneset;
ProcessTwosets    trot_superwrap_twosets;
ProcessWrapup     trot_superwrap_wrapup;
ProcessDelete     trot_superwrap_delete;


void superwrap_trot_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = trot_superwrap_create;
  THIS->initialize = trot_superwrap_init;
  THIS->update     = trot_superwrap_update;
  THIS->oneset     = trot_superwrap_oneset;
  THIS->twosets    = trot_superwrap_twosets;
  THIS->wrapup     = trot_superwrap_wrapup;
  THIS->delete     = trot_superwrap_delete;
}



/*------------------------------- TRSTATS -------------------------------*/
/*------------------------------- TRSTATS -------------------------------*/
/*------------------------------- TRSTATS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define trstats_superwrap_create            trstats_superwrap_create_
#define trstats_superwrap_init              trstats_superwrap_init_
#define trstats_superwrap_update            trstats_superwrap_update_
#define trstats_superwrap_oneset            trstats_superwrap_oneset_ 
#define trstats_superwrap_twosets           trstats_superwrap_twosets_
#define trstats_superwrap_wrapup            trstats_superwrap_wrapup_
#define trstats_superwrap_delete            trstats_superwrap_delete_
#elif defined NEED_CAPITALS
#define trstats_superwrap_create            TRSTATS_SUPERWRAP_CREATE
#define trstats_superwrap_init              TRSTATS_SUPERWRAP_INIT
#define trstats_superwrap_update            TRSTATS_SUPERWRAP_UPDATE
#define trstats_superwrap_oneset            TRSTATS_SUPERWRAP_ONESET 
#define trstats_superwrap_twosets           TRSTATS_SUPERWRAP_TWOSETS
#define trstats_superwrap_wrapup            TRSTATS_SUPERWRAP_WRAPUP
#define trstats_superwrap_delete            TRSTATS_SUPERWRAP_DELETE
#endif


ProcessCreate     trstats_superwrap_create;
ProcessInitialize trstats_superwrap_init;
ProcessUpdate     trstats_superwrap_update;
ProcessOneset     trstats_superwrap_oneset;
ProcessTwosets    trstats_superwrap_twosets;
ProcessWrapup     trstats_superwrap_wrapup;
ProcessDelete     trstats_superwrap_delete;


void superwrap_trstats_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = trstats_superwrap_create;
  THIS->initialize = trstats_superwrap_init;
  THIS->update     = trstats_superwrap_update;
  THIS->oneset     = trstats_superwrap_oneset;
  THIS->twosets    = trstats_superwrap_twosets;
  THIS->wrapup     = trstats_superwrap_wrapup;
  THIS->delete     = trstats_superwrap_delete;
}



/*------------------------------- TSEL -------------------------------*/
/*------------------------------- TSEL -------------------------------*/
/*------------------------------- TSEL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tsel_superwrap_create            tsel_superwrap_create_
#define tsel_superwrap_init              tsel_superwrap_init_
#define tsel_superwrap_update            tsel_superwrap_update_
#define tsel_superwrap_oneset            tsel_superwrap_oneset_ 
#define tsel_superwrap_twosets           tsel_superwrap_twosets_
#define tsel_superwrap_wrapup            tsel_superwrap_wrapup_
#define tsel_superwrap_delete            tsel_superwrap_delete_
#elif defined NEED_CAPITALS
#define tsel_superwrap_create            TSEL_SUPERWRAP_CREATE
#define tsel_superwrap_init              TSEL_SUPERWRAP_INIT
#define tsel_superwrap_update            TSEL_SUPERWRAP_UPDATE
#define tsel_superwrap_oneset            TSEL_SUPERWRAP_ONESET 
#define tsel_superwrap_twosets           TSEL_SUPERWRAP_TWOSETS
#define tsel_superwrap_wrapup            TSEL_SUPERWRAP_WRAPUP
#define tsel_superwrap_delete            TSEL_SUPERWRAP_DELETE
#endif


ProcessCreate     tsel_superwrap_create;
ProcessInitialize tsel_superwrap_init;
ProcessUpdate     tsel_superwrap_update;
ProcessOneset     tsel_superwrap_oneset;
ProcessTwosets    tsel_superwrap_twosets;
ProcessWrapup     tsel_superwrap_wrapup;
ProcessDelete     tsel_superwrap_delete;


void superwrap_tsel_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tsel_superwrap_create;
  THIS->initialize = tsel_superwrap_init;
  THIS->update     = tsel_superwrap_update;
  THIS->oneset     = tsel_superwrap_oneset;
  THIS->twosets    = tsel_superwrap_twosets;
  THIS->wrapup     = tsel_superwrap_wrapup;
  THIS->delete     = tsel_superwrap_delete;
}



/*------------------------------- TSLC -------------------------------*/
/*------------------------------- TSLC -------------------------------*/
/*------------------------------- TSLC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tslc_superwrap_create            tslc_superwrap_create_
#define tslc_superwrap_init              tslc_superwrap_init_
#define tslc_superwrap_update            tslc_superwrap_update_
#define tslc_superwrap_oneset            tslc_superwrap_oneset_ 
#define tslc_superwrap_twosets           tslc_superwrap_twosets_
#define tslc_superwrap_wrapup            tslc_superwrap_wrapup_
#define tslc_superwrap_delete            tslc_superwrap_delete_
#elif defined NEED_CAPITALS
#define tslc_superwrap_create            TSLC_SUPERWRAP_CREATE
#define tslc_superwrap_init              TSLC_SUPERWRAP_INIT
#define tslc_superwrap_update            TSLC_SUPERWRAP_UPDATE
#define tslc_superwrap_oneset            TSLC_SUPERWRAP_ONESET 
#define tslc_superwrap_twosets           TSLC_SUPERWRAP_TWOSETS
#define tslc_superwrap_wrapup            TSLC_SUPERWRAP_WRAPUP
#define tslc_superwrap_delete            TSLC_SUPERWRAP_DELETE
#endif


ProcessCreate     tslc_superwrap_create;
ProcessInitialize tslc_superwrap_init;
ProcessUpdate     tslc_superwrap_update;
ProcessOneset     tslc_superwrap_oneset;
ProcessTwosets    tslc_superwrap_twosets;
ProcessWrapup     tslc_superwrap_wrapup;
ProcessDelete     tslc_superwrap_delete;


void superwrap_tslc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tslc_superwrap_create;
  THIS->initialize = tslc_superwrap_init;
  THIS->update     = tslc_superwrap_update;
  THIS->oneset     = tslc_superwrap_oneset;
  THIS->twosets    = tslc_superwrap_twosets;
  THIS->wrapup     = tslc_superwrap_wrapup;
  THIS->delete     = tslc_superwrap_delete;
}



/*------------------------------- TSLICE -------------------------------*/
/*------------------------------- TSLICE -------------------------------*/
/*------------------------------- TSLICE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tslice_superwrap_create            tslice_superwrap_create_
#define tslice_superwrap_init              tslice_superwrap_init_
#define tslice_superwrap_update            tslice_superwrap_update_
#define tslice_superwrap_oneset            tslice_superwrap_oneset_ 
#define tslice_superwrap_twosets           tslice_superwrap_twosets_
#define tslice_superwrap_wrapup            tslice_superwrap_wrapup_
#define tslice_superwrap_delete            tslice_superwrap_delete_
#elif defined NEED_CAPITALS
#define tslice_superwrap_create            TSLICE_SUPERWRAP_CREATE
#define tslice_superwrap_init              TSLICE_SUPERWRAP_INIT
#define tslice_superwrap_update            TSLICE_SUPERWRAP_UPDATE
#define tslice_superwrap_oneset            TSLICE_SUPERWRAP_ONESET 
#define tslice_superwrap_twosets           TSLICE_SUPERWRAP_TWOSETS
#define tslice_superwrap_wrapup            TSLICE_SUPERWRAP_WRAPUP
#define tslice_superwrap_delete            TSLICE_SUPERWRAP_DELETE
#endif


ProcessCreate     tslice_superwrap_create;
ProcessInitialize tslice_superwrap_init;
ProcessUpdate     tslice_superwrap_update;
ProcessOneset     tslice_superwrap_oneset;
ProcessTwosets    tslice_superwrap_twosets;
ProcessWrapup     tslice_superwrap_wrapup;
ProcessDelete     tslice_superwrap_delete;


void superwrap_tslice_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tslice_superwrap_create;
  THIS->initialize = tslice_superwrap_init;
  THIS->update     = tslice_superwrap_update;
  THIS->oneset     = tslice_superwrap_oneset;
  THIS->twosets    = tslice_superwrap_twosets;
  THIS->wrapup     = tslice_superwrap_wrapup;
  THIS->delete     = tslice_superwrap_delete;
}



/*------------------------------- TSMUTE -------------------------------*/
/*------------------------------- TSMUTE -------------------------------*/
/*------------------------------- TSMUTE -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tsmute_superwrap_create            tsmute_superwrap_create_
#define tsmute_superwrap_init              tsmute_superwrap_init_
#define tsmute_superwrap_update            tsmute_superwrap_update_
#define tsmute_superwrap_oneset            tsmute_superwrap_oneset_ 
#define tsmute_superwrap_twosets           tsmute_superwrap_twosets_
#define tsmute_superwrap_wrapup            tsmute_superwrap_wrapup_
#define tsmute_superwrap_delete            tsmute_superwrap_delete_
#elif defined NEED_CAPITALS
#define tsmute_superwrap_create            TSMUTE_SUPERWRAP_CREATE
#define tsmute_superwrap_init              TSMUTE_SUPERWRAP_INIT
#define tsmute_superwrap_update            TSMUTE_SUPERWRAP_UPDATE
#define tsmute_superwrap_oneset            TSMUTE_SUPERWRAP_ONESET 
#define tsmute_superwrap_twosets           TSMUTE_SUPERWRAP_TWOSETS
#define tsmute_superwrap_wrapup            TSMUTE_SUPERWRAP_WRAPUP
#define tsmute_superwrap_delete            TSMUTE_SUPERWRAP_DELETE
#endif


ProcessCreate     tsmute_superwrap_create;
ProcessInitialize tsmute_superwrap_init;
ProcessUpdate     tsmute_superwrap_update;
ProcessOneset     tsmute_superwrap_oneset;
ProcessTwosets    tsmute_superwrap_twosets;
ProcessWrapup     tsmute_superwrap_wrapup;
ProcessDelete     tsmute_superwrap_delete;


void superwrap_tsmute_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tsmute_superwrap_create;
  THIS->initialize = tsmute_superwrap_init;
  THIS->update     = tsmute_superwrap_update;
  THIS->oneset     = tsmute_superwrap_oneset;
  THIS->twosets    = tsmute_superwrap_twosets;
  THIS->wrapup     = tsmute_superwrap_wrapup;
  THIS->delete     = tsmute_superwrap_delete;
}



/*------------------------------- TSORT -------------------------------*/
/*------------------------------- TSORT -------------------------------*/
/*------------------------------- TSORT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tsort_superwrap_create            tsort_superwrap_create_
#define tsort_superwrap_init              tsort_superwrap_init_
#define tsort_superwrap_update            tsort_superwrap_update_
#define tsort_superwrap_oneset            tsort_superwrap_oneset_ 
#define tsort_superwrap_twosets           tsort_superwrap_twosets_
#define tsort_superwrap_wrapup            tsort_superwrap_wrapup_
#define tsort_superwrap_delete            tsort_superwrap_delete_
#elif defined NEED_CAPITALS
#define tsort_superwrap_create            TSORT_SUPERWRAP_CREATE
#define tsort_superwrap_init              TSORT_SUPERWRAP_INIT
#define tsort_superwrap_update            TSORT_SUPERWRAP_UPDATE
#define tsort_superwrap_oneset            TSORT_SUPERWRAP_ONESET 
#define tsort_superwrap_twosets           TSORT_SUPERWRAP_TWOSETS
#define tsort_superwrap_wrapup            TSORT_SUPERWRAP_WRAPUP
#define tsort_superwrap_delete            TSORT_SUPERWRAP_DELETE
#endif


ProcessCreate     tsort_superwrap_create;
ProcessInitialize tsort_superwrap_init;
ProcessUpdate     tsort_superwrap_update;
ProcessOneset     tsort_superwrap_oneset;
ProcessTwosets    tsort_superwrap_twosets;
ProcessWrapup     tsort_superwrap_wrapup;
ProcessDelete     tsort_superwrap_delete;


void superwrap_tsort_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tsort_superwrap_create;
  THIS->initialize = tsort_superwrap_init;
  THIS->update     = tsort_superwrap_update;
  THIS->oneset     = tsort_superwrap_oneset;
  THIS->twosets    = tsort_superwrap_twosets;
  THIS->wrapup     = tsort_superwrap_wrapup;
  THIS->delete     = tsort_superwrap_delete;
}



/*------------------------------- PARALLELSORT -------------------------------*/
/*------------------------------- PARALLELSORT -------------------------------*/
/*------------------------------- PARALLELSORT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define parallelsort_superwrap_create            parallelsort_superwrap_create_
#define parallelsort_superwrap_init              parallelsort_superwrap_init_
#define parallelsort_superwrap_update            parallelsort_superwrap_update_
#define parallelsort_superwrap_oneset            parallelsort_superwrap_oneset_ 
#define parallelsort_superwrap_twosets           parallelsort_superwrap_twosets_
#define parallelsort_superwrap_wrapup            parallelsort_superwrap_wrapup_
#define parallelsort_superwrap_delete            parallelsort_superwrap_delete_
#elif defined NEED_CAPITALS
#define parallelsort_superwrap_create            PARALLELSORT_SUPERWRAP_CREATE
#define parallelsort_superwrap_init              PARALLELSORT_SUPERWRAP_INIT
#define parallelsort_superwrap_update            PARALLELSORT_SUPERWRAP_UPDATE
#define parallelsort_superwrap_oneset            PARALLELSORT_SUPERWRAP_ONESET 
#define parallelsort_superwrap_twosets           PARALLELSORT_SUPERWRAP_TWOSETS
#define parallelsort_superwrap_wrapup            PARALLELSORT_SUPERWRAP_WRAPUP
#define parallelsort_superwrap_delete            PARALLELSORT_SUPERWRAP_DELETE
#endif


ProcessCreate     parallelsort_superwrap_create;
ProcessInitialize parallelsort_superwrap_init;
ProcessUpdate     parallelsort_superwrap_update;
ProcessOneset     parallelsort_superwrap_oneset;
ProcessTwosets    parallelsort_superwrap_twosets;
ProcessWrapup     parallelsort_superwrap_wrapup;
ProcessDelete     parallelsort_superwrap_delete;


void superwrap_parallelsort_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = parallelsort_superwrap_create;
  THIS->initialize = parallelsort_superwrap_init;
  THIS->update     = parallelsort_superwrap_update;
  THIS->oneset     = parallelsort_superwrap_oneset;
  THIS->twosets    = parallelsort_superwrap_twosets;
  THIS->wrapup     = parallelsort_superwrap_wrapup;
  THIS->delete     = parallelsort_superwrap_delete;
}



/*------------------------------- TSVF -------------------------------*/
/*------------------------------- TSVF -------------------------------*/
/*------------------------------- TSVF -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tsvf_superwrap_create            tsvf_superwrap_create_
#define tsvf_superwrap_init              tsvf_superwrap_init_
#define tsvf_superwrap_update            tsvf_superwrap_update_
#define tsvf_superwrap_oneset            tsvf_superwrap_oneset_ 
#define tsvf_superwrap_twosets           tsvf_superwrap_twosets_
#define tsvf_superwrap_wrapup            tsvf_superwrap_wrapup_
#define tsvf_superwrap_delete            tsvf_superwrap_delete_
#elif defined NEED_CAPITALS
#define tsvf_superwrap_create            TSVF_SUPERWRAP_CREATE
#define tsvf_superwrap_init              TSVF_SUPERWRAP_INIT
#define tsvf_superwrap_update            TSVF_SUPERWRAP_UPDATE
#define tsvf_superwrap_oneset            TSVF_SUPERWRAP_ONESET 
#define tsvf_superwrap_twosets           TSVF_SUPERWRAP_TWOSETS
#define tsvf_superwrap_wrapup            TSVF_SUPERWRAP_WRAPUP
#define tsvf_superwrap_delete            TSVF_SUPERWRAP_DELETE
#endif


ProcessCreate     tsvf_superwrap_create;
ProcessInitialize tsvf_superwrap_init;
ProcessUpdate     tsvf_superwrap_update;
ProcessOneset     tsvf_superwrap_oneset;
ProcessTwosets    tsvf_superwrap_twosets;
ProcessWrapup     tsvf_superwrap_wrapup;
ProcessDelete     tsvf_superwrap_delete;


void superwrap_tsvf_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tsvf_superwrap_create;
  THIS->initialize = tsvf_superwrap_init;
  THIS->update     = tsvf_superwrap_update;
  THIS->oneset     = tsvf_superwrap_oneset;
  THIS->twosets    = tsvf_superwrap_twosets;
  THIS->wrapup     = tsvf_superwrap_wrapup;
  THIS->delete     = tsvf_superwrap_delete;
}



/*------------------------------- TTMO -------------------------------*/
/*------------------------------- TTMO -------------------------------*/
/*------------------------------- TTMO -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ttmo_superwrap_create            ttmo_superwrap_create_
#define ttmo_superwrap_init              ttmo_superwrap_init_
#define ttmo_superwrap_update            ttmo_superwrap_update_
#define ttmo_superwrap_oneset            ttmo_superwrap_oneset_ 
#define ttmo_superwrap_twosets           ttmo_superwrap_twosets_
#define ttmo_superwrap_wrapup            ttmo_superwrap_wrapup_
#define ttmo_superwrap_delete            ttmo_superwrap_delete_
#elif defined NEED_CAPITALS
#define ttmo_superwrap_create            TTMO_SUPERWRAP_CREATE
#define ttmo_superwrap_init              TTMO_SUPERWRAP_INIT
#define ttmo_superwrap_update            TTMO_SUPERWRAP_UPDATE
#define ttmo_superwrap_oneset            TTMO_SUPERWRAP_ONESET 
#define ttmo_superwrap_twosets           TTMO_SUPERWRAP_TWOSETS
#define ttmo_superwrap_wrapup            TTMO_SUPERWRAP_WRAPUP
#define ttmo_superwrap_delete            TTMO_SUPERWRAP_DELETE
#endif


ProcessCreate     ttmo_superwrap_create;
ProcessInitialize ttmo_superwrap_init;
ProcessUpdate     ttmo_superwrap_update;
ProcessOneset     ttmo_superwrap_oneset;
ProcessTwosets    ttmo_superwrap_twosets;
ProcessWrapup     ttmo_superwrap_wrapup;
ProcessDelete     ttmo_superwrap_delete;


void superwrap_ttmo_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ttmo_superwrap_create;
  THIS->initialize = ttmo_superwrap_init;
  THIS->update     = ttmo_superwrap_update;
  THIS->oneset     = ttmo_superwrap_oneset;
  THIS->twosets    = ttmo_superwrap_twosets;
  THIS->wrapup     = ttmo_superwrap_wrapup;
  THIS->delete     = ttmo_superwrap_delete;
}



/*------------------------------- TTRIN -------------------------------*/
/*------------------------------- TTRIN -------------------------------*/
/*------------------------------- TTRIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ttrin_superwrap_create            ttrin_superwrap_create_
#define ttrin_superwrap_init              ttrin_superwrap_init_
#define ttrin_superwrap_update            ttrin_superwrap_update_
#define ttrin_superwrap_oneset            ttrin_superwrap_oneset_ 
#define ttrin_superwrap_twosets           ttrin_superwrap_twosets_
#define ttrin_superwrap_wrapup            ttrin_superwrap_wrapup_
#define ttrin_superwrap_delete            ttrin_superwrap_delete_
#elif defined NEED_CAPITALS
#define ttrin_superwrap_create            TTRIN_SUPERWRAP_CREATE
#define ttrin_superwrap_init              TTRIN_SUPERWRAP_INIT
#define ttrin_superwrap_update            TTRIN_SUPERWRAP_UPDATE
#define ttrin_superwrap_oneset            TTRIN_SUPERWRAP_ONESET 
#define ttrin_superwrap_twosets           TTRIN_SUPERWRAP_TWOSETS
#define ttrin_superwrap_wrapup            TTRIN_SUPERWRAP_WRAPUP
#define ttrin_superwrap_delete            TTRIN_SUPERWRAP_DELETE
#endif


ProcessCreate     ttrin_superwrap_create;
ProcessInitialize ttrin_superwrap_init;
ProcessUpdate     ttrin_superwrap_update;
ProcessOneset     ttrin_superwrap_oneset;
ProcessTwosets    ttrin_superwrap_twosets;
ProcessWrapup     ttrin_superwrap_wrapup;
ProcessDelete     ttrin_superwrap_delete;


void superwrap_ttrin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ttrin_superwrap_create;
  THIS->initialize = ttrin_superwrap_init;
  THIS->update     = ttrin_superwrap_update;
  THIS->oneset     = ttrin_superwrap_oneset;
  THIS->twosets    = ttrin_superwrap_twosets;
  THIS->wrapup     = ttrin_superwrap_wrapup;
  THIS->delete     = ttrin_superwrap_delete;
}



/*------------------------------- TTROT -------------------------------*/
/*------------------------------- TTROT -------------------------------*/
/*------------------------------- TTROT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ttrot_superwrap_create            ttrot_superwrap_create_
#define ttrot_superwrap_init              ttrot_superwrap_init_
#define ttrot_superwrap_update            ttrot_superwrap_update_
#define ttrot_superwrap_oneset            ttrot_superwrap_oneset_ 
#define ttrot_superwrap_twosets           ttrot_superwrap_twosets_
#define ttrot_superwrap_wrapup            ttrot_superwrap_wrapup_
#define ttrot_superwrap_delete            ttrot_superwrap_delete_
#elif defined NEED_CAPITALS
#define ttrot_superwrap_create            TTROT_SUPERWRAP_CREATE
#define ttrot_superwrap_init              TTROT_SUPERWRAP_INIT
#define ttrot_superwrap_update            TTROT_SUPERWRAP_UPDATE
#define ttrot_superwrap_oneset            TTROT_SUPERWRAP_ONESET 
#define ttrot_superwrap_twosets           TTROT_SUPERWRAP_TWOSETS
#define ttrot_superwrap_wrapup            TTROT_SUPERWRAP_WRAPUP
#define ttrot_superwrap_delete            TTROT_SUPERWRAP_DELETE
#endif


ProcessCreate     ttrot_superwrap_create;
ProcessInitialize ttrot_superwrap_init;
ProcessUpdate     ttrot_superwrap_update;
ProcessOneset     ttrot_superwrap_oneset;
ProcessTwosets    ttrot_superwrap_twosets;
ProcessWrapup     ttrot_superwrap_wrapup;
ProcessDelete     ttrot_superwrap_delete;


void superwrap_ttrot_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ttrot_superwrap_create;
  THIS->initialize = ttrot_superwrap_init;
  THIS->update     = ttrot_superwrap_update;
  THIS->oneset     = ttrot_superwrap_oneset;
  THIS->twosets    = ttrot_superwrap_twosets;
  THIS->wrapup     = ttrot_superwrap_wrapup;
  THIS->delete     = ttrot_superwrap_delete;
}



/*------------------------------- TVF -------------------------------*/
/*------------------------------- TVF -------------------------------*/
/*------------------------------- TVF -------------------------------*/


#ifdef NEED_UNDERSCORE
#define tvf_superwrap_create            tvf_superwrap_create_
#define tvf_superwrap_init              tvf_superwrap_init_
#define tvf_superwrap_update            tvf_superwrap_update_
#define tvf_superwrap_oneset            tvf_superwrap_oneset_ 
#define tvf_superwrap_twosets           tvf_superwrap_twosets_
#define tvf_superwrap_wrapup            tvf_superwrap_wrapup_
#define tvf_superwrap_delete            tvf_superwrap_delete_
#elif defined NEED_CAPITALS
#define tvf_superwrap_create            TVF_SUPERWRAP_CREATE
#define tvf_superwrap_init              TVF_SUPERWRAP_INIT
#define tvf_superwrap_update            TVF_SUPERWRAP_UPDATE
#define tvf_superwrap_oneset            TVF_SUPERWRAP_ONESET 
#define tvf_superwrap_twosets           TVF_SUPERWRAP_TWOSETS
#define tvf_superwrap_wrapup            TVF_SUPERWRAP_WRAPUP
#define tvf_superwrap_delete            TVF_SUPERWRAP_DELETE
#endif


ProcessCreate     tvf_superwrap_create;
ProcessInitialize tvf_superwrap_init;
ProcessUpdate     tvf_superwrap_update;
ProcessOneset     tvf_superwrap_oneset;
ProcessTwosets    tvf_superwrap_twosets;
ProcessWrapup     tvf_superwrap_wrapup;
ProcessDelete     tvf_superwrap_delete;


void superwrap_tvf_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = tvf_superwrap_create;
  THIS->initialize = tvf_superwrap_init;
  THIS->update     = tvf_superwrap_update;
  THIS->oneset     = tvf_superwrap_oneset;
  THIS->twosets    = tvf_superwrap_twosets;
  THIS->wrapup     = tvf_superwrap_wrapup;
  THIS->delete     = tvf_superwrap_delete;
}



/*------------------------------- UNGATHER -------------------------------*/
/*------------------------------- UNGATHER -------------------------------*/
/*------------------------------- UNGATHER -------------------------------*/


#ifdef NEED_UNDERSCORE
#define ungather_superwrap_create            ungather_superwrap_create_
#define ungather_superwrap_init              ungather_superwrap_init_
#define ungather_superwrap_update            ungather_superwrap_update_
#define ungather_superwrap_oneset            ungather_superwrap_oneset_ 
#define ungather_superwrap_twosets           ungather_superwrap_twosets_
#define ungather_superwrap_wrapup            ungather_superwrap_wrapup_
#define ungather_superwrap_delete            ungather_superwrap_delete_
#elif defined NEED_CAPITALS
#define ungather_superwrap_create            UNGATHER_SUPERWRAP_CREATE
#define ungather_superwrap_init              UNGATHER_SUPERWRAP_INIT
#define ungather_superwrap_update            UNGATHER_SUPERWRAP_UPDATE
#define ungather_superwrap_oneset            UNGATHER_SUPERWRAP_ONESET 
#define ungather_superwrap_twosets           UNGATHER_SUPERWRAP_TWOSETS
#define ungather_superwrap_wrapup            UNGATHER_SUPERWRAP_WRAPUP
#define ungather_superwrap_delete            UNGATHER_SUPERWRAP_DELETE
#endif


ProcessCreate     ungather_superwrap_create;
ProcessInitialize ungather_superwrap_init;
ProcessUpdate     ungather_superwrap_update;
ProcessOneset     ungather_superwrap_oneset;
ProcessTwosets    ungather_superwrap_twosets;
ProcessWrapup     ungather_superwrap_wrapup;
ProcessDelete     ungather_superwrap_delete;


void superwrap_ungather_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = ungather_superwrap_create;
  THIS->initialize = ungather_superwrap_init;
  THIS->update     = ungather_superwrap_update;
  THIS->oneset     = ungather_superwrap_oneset;
  THIS->twosets    = ungather_superwrap_twosets;
  THIS->wrapup     = ungather_superwrap_wrapup;
  THIS->delete     = ungather_superwrap_delete;
}



/*------------------------------- UTEL -------------------------------*/
/*------------------------------- UTEL -------------------------------*/
/*------------------------------- UTEL -------------------------------*/


#ifdef NEED_UNDERSCORE
#define utel_superwrap_create            utel_superwrap_create_
#define utel_superwrap_init              utel_superwrap_init_
#define utel_superwrap_update            utel_superwrap_update_
#define utel_superwrap_oneset            utel_superwrap_oneset_ 
#define utel_superwrap_twosets           utel_superwrap_twosets_
#define utel_superwrap_wrapup            utel_superwrap_wrapup_
#define utel_superwrap_delete            utel_superwrap_delete_
#elif defined NEED_CAPITALS
#define utel_superwrap_create            UTEL_SUPERWRAP_CREATE
#define utel_superwrap_init              UTEL_SUPERWRAP_INIT
#define utel_superwrap_update            UTEL_SUPERWRAP_UPDATE
#define utel_superwrap_oneset            UTEL_SUPERWRAP_ONESET 
#define utel_superwrap_twosets           UTEL_SUPERWRAP_TWOSETS
#define utel_superwrap_wrapup            UTEL_SUPERWRAP_WRAPUP
#define utel_superwrap_delete            UTEL_SUPERWRAP_DELETE
#endif


ProcessCreate     utel_superwrap_create;
ProcessInitialize utel_superwrap_init;
ProcessUpdate     utel_superwrap_update;
ProcessOneset     utel_superwrap_oneset;
ProcessTwosets    utel_superwrap_twosets;
ProcessWrapup     utel_superwrap_wrapup;
ProcessDelete     utel_superwrap_delete;


void superwrap_utel_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = utel_superwrap_create;
  THIS->initialize = utel_superwrap_init;
  THIS->update     = utel_superwrap_update;
  THIS->oneset     = utel_superwrap_oneset;
  THIS->twosets    = utel_superwrap_twosets;
  THIS->wrapup     = utel_superwrap_wrapup;
  THIS->delete     = utel_superwrap_delete;
}



/*------------------------------- VALUEDUMP -------------------------------*/
/*------------------------------- VALUEDUMP -------------------------------*/
/*------------------------------- VALUEDUMP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define valuedump_superwrap_create            valuedump_superwrap_create_
#define valuedump_superwrap_init              valuedump_superwrap_init_
#define valuedump_superwrap_update            valuedump_superwrap_update_
#define valuedump_superwrap_oneset            valuedump_superwrap_oneset_ 
#define valuedump_superwrap_twosets           valuedump_superwrap_twosets_
#define valuedump_superwrap_wrapup            valuedump_superwrap_wrapup_
#define valuedump_superwrap_delete            valuedump_superwrap_delete_
#elif defined NEED_CAPITALS
#define valuedump_superwrap_create            VALUEDUMP_SUPERWRAP_CREATE
#define valuedump_superwrap_init              VALUEDUMP_SUPERWRAP_INIT
#define valuedump_superwrap_update            VALUEDUMP_SUPERWRAP_UPDATE
#define valuedump_superwrap_oneset            VALUEDUMP_SUPERWRAP_ONESET 
#define valuedump_superwrap_twosets           VALUEDUMP_SUPERWRAP_TWOSETS
#define valuedump_superwrap_wrapup            VALUEDUMP_SUPERWRAP_WRAPUP
#define valuedump_superwrap_delete            VALUEDUMP_SUPERWRAP_DELETE
#endif


ProcessCreate     valuedump_superwrap_create;
ProcessInitialize valuedump_superwrap_init;
ProcessUpdate     valuedump_superwrap_update;
ProcessOneset     valuedump_superwrap_oneset;
ProcessTwosets    valuedump_superwrap_twosets;
ProcessWrapup     valuedump_superwrap_wrapup;
ProcessDelete     valuedump_superwrap_delete;


void superwrap_valuedump_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = valuedump_superwrap_create;
  THIS->initialize = valuedump_superwrap_init;
  THIS->update     = valuedump_superwrap_update;
  THIS->oneset     = valuedump_superwrap_oneset;
  THIS->twosets    = valuedump_superwrap_twosets;
  THIS->wrapup     = valuedump_superwrap_wrapup;
  THIS->delete     = valuedump_superwrap_delete;
}



/*------------------------------- VC -------------------------------*/
/*------------------------------- VC -------------------------------*/
/*------------------------------- VC -------------------------------*/


#ifdef NEED_UNDERSCORE
#define vc_superwrap_create            vc_superwrap_create_
#define vc_superwrap_init              vc_superwrap_init_
#define vc_superwrap_update            vc_superwrap_update_
#define vc_superwrap_oneset            vc_superwrap_oneset_ 
#define vc_superwrap_twosets           vc_superwrap_twosets_
#define vc_superwrap_wrapup            vc_superwrap_wrapup_
#define vc_superwrap_delete            vc_superwrap_delete_
#elif defined NEED_CAPITALS
#define vc_superwrap_create            VC_SUPERWRAP_CREATE
#define vc_superwrap_init              VC_SUPERWRAP_INIT
#define vc_superwrap_update            VC_SUPERWRAP_UPDATE
#define vc_superwrap_oneset            VC_SUPERWRAP_ONESET 
#define vc_superwrap_twosets           VC_SUPERWRAP_TWOSETS
#define vc_superwrap_wrapup            VC_SUPERWRAP_WRAPUP
#define vc_superwrap_delete            VC_SUPERWRAP_DELETE
#endif


ProcessCreate     vc_superwrap_create;
ProcessInitialize vc_superwrap_init;
ProcessUpdate     vc_superwrap_update;
ProcessOneset     vc_superwrap_oneset;
ProcessTwosets    vc_superwrap_twosets;
ProcessWrapup     vc_superwrap_wrapup;
ProcessDelete     vc_superwrap_delete;


void superwrap_vc_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = vc_superwrap_create;
  THIS->initialize = vc_superwrap_init;
  THIS->update     = vc_superwrap_update;
  THIS->oneset     = vc_superwrap_oneset;
  THIS->twosets    = vc_superwrap_twosets;
  THIS->wrapup     = vc_superwrap_wrapup;
  THIS->delete     = vc_superwrap_delete;
}



/*------------------------------- VELEDIT -------------------------------*/
/*------------------------------- VELEDIT -------------------------------*/
/*------------------------------- VELEDIT -------------------------------*/


#ifdef NEED_UNDERSCORE
#define veledit_superwrap_create            veledit_superwrap_create_
#define veledit_superwrap_init              veledit_superwrap_init_
#define veledit_superwrap_update            veledit_superwrap_update_
#define veledit_superwrap_oneset            veledit_superwrap_oneset_ 
#define veledit_superwrap_twosets           veledit_superwrap_twosets_
#define veledit_superwrap_wrapup            veledit_superwrap_wrapup_
#define veledit_superwrap_delete            veledit_superwrap_delete_
#elif defined NEED_CAPITALS
#define veledit_superwrap_create            VELEDIT_SUPERWRAP_CREATE
#define veledit_superwrap_init              VELEDIT_SUPERWRAP_INIT
#define veledit_superwrap_update            VELEDIT_SUPERWRAP_UPDATE
#define veledit_superwrap_oneset            VELEDIT_SUPERWRAP_ONESET 
#define veledit_superwrap_twosets           VELEDIT_SUPERWRAP_TWOSETS
#define veledit_superwrap_wrapup            VELEDIT_SUPERWRAP_WRAPUP
#define veledit_superwrap_delete            VELEDIT_SUPERWRAP_DELETE
#endif


ProcessCreate     veledit_superwrap_create;
ProcessInitialize veledit_superwrap_init;
ProcessUpdate     veledit_superwrap_update;
ProcessOneset     veledit_superwrap_oneset;
ProcessTwosets    veledit_superwrap_twosets;
ProcessWrapup     veledit_superwrap_wrapup;
ProcessDelete     veledit_superwrap_delete;


void superwrap_veledit_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = veledit_superwrap_create;
  THIS->initialize = veledit_superwrap_init;
  THIS->update     = veledit_superwrap_update;
  THIS->oneset     = veledit_superwrap_oneset;
  THIS->twosets    = veledit_superwrap_twosets;
  THIS->wrapup     = veledit_superwrap_wrapup;
  THIS->delete     = veledit_superwrap_delete;
}



/*------------------------------- VPICK -------------------------------*/
/*------------------------------- VPICK -------------------------------*/
/*------------------------------- VPICK -------------------------------*/


#ifdef NEED_UNDERSCORE
#define vpick_superwrap_create            vpick_superwrap_create_
#define vpick_superwrap_init              vpick_superwrap_init_
#define vpick_superwrap_update            vpick_superwrap_update_
#define vpick_superwrap_oneset            vpick_superwrap_oneset_ 
#define vpick_superwrap_twosets           vpick_superwrap_twosets_
#define vpick_superwrap_wrapup            vpick_superwrap_wrapup_
#define vpick_superwrap_delete            vpick_superwrap_delete_
#elif defined NEED_CAPITALS
#define vpick_superwrap_create            VPICK_SUPERWRAP_CREATE
#define vpick_superwrap_init              VPICK_SUPERWRAP_INIT
#define vpick_superwrap_update            VPICK_SUPERWRAP_UPDATE
#define vpick_superwrap_oneset            VPICK_SUPERWRAP_ONESET 
#define vpick_superwrap_twosets           VPICK_SUPERWRAP_TWOSETS
#define vpick_superwrap_wrapup            VPICK_SUPERWRAP_WRAPUP
#define vpick_superwrap_delete            VPICK_SUPERWRAP_DELETE
#endif


ProcessCreate     vpick_superwrap_create;
ProcessInitialize vpick_superwrap_init;
ProcessUpdate     vpick_superwrap_update;
ProcessOneset     vpick_superwrap_oneset;
ProcessTwosets    vpick_superwrap_twosets;
ProcessWrapup     vpick_superwrap_wrapup;
ProcessDelete     vpick_superwrap_delete;


void superwrap_vpick_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = vpick_superwrap_create;
  THIS->initialize = vpick_superwrap_init;
  THIS->update     = vpick_superwrap_update;
  THIS->oneset     = vpick_superwrap_oneset;
  THIS->twosets    = vpick_superwrap_twosets;
  THIS->wrapup     = vpick_superwrap_wrapup;
  THIS->delete     = vpick_superwrap_delete;
}



/*------------------------------- VTRIM -------------------------------*/
/*------------------------------- VTRIM -------------------------------*/
/*------------------------------- VTRIM -------------------------------*/


#ifdef NEED_UNDERSCORE
#define vtrim_superwrap_create            vtrim_superwrap_create_
#define vtrim_superwrap_init              vtrim_superwrap_init_
#define vtrim_superwrap_update            vtrim_superwrap_update_
#define vtrim_superwrap_oneset            vtrim_superwrap_oneset_ 
#define vtrim_superwrap_twosets           vtrim_superwrap_twosets_
#define vtrim_superwrap_wrapup            vtrim_superwrap_wrapup_
#define vtrim_superwrap_delete            vtrim_superwrap_delete_
#elif defined NEED_CAPITALS
#define vtrim_superwrap_create            VTRIM_SUPERWRAP_CREATE
#define vtrim_superwrap_init              VTRIM_SUPERWRAP_INIT
#define vtrim_superwrap_update            VTRIM_SUPERWRAP_UPDATE
#define vtrim_superwrap_oneset            VTRIM_SUPERWRAP_ONESET 
#define vtrim_superwrap_twosets           VTRIM_SUPERWRAP_TWOSETS
#define vtrim_superwrap_wrapup            VTRIM_SUPERWRAP_WRAPUP
#define vtrim_superwrap_delete            VTRIM_SUPERWRAP_DELETE
#endif


ProcessCreate     vtrim_superwrap_create;
ProcessInitialize vtrim_superwrap_init;
ProcessUpdate     vtrim_superwrap_update;
ProcessOneset     vtrim_superwrap_oneset;
ProcessTwosets    vtrim_superwrap_twosets;
ProcessWrapup     vtrim_superwrap_wrapup;
ProcessDelete     vtrim_superwrap_delete;


void superwrap_vtrim_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = vtrim_superwrap_create;
  THIS->initialize = vtrim_superwrap_init;
  THIS->update     = vtrim_superwrap_update;
  THIS->oneset     = vtrim_superwrap_oneset;
  THIS->twosets    = vtrim_superwrap_twosets;
  THIS->wrapup     = vtrim_superwrap_wrapup;
  THIS->delete     = vtrim_superwrap_delete;
}



/*------------------------------- VTRIN -------------------------------*/
/*------------------------------- VTRIN -------------------------------*/
/*------------------------------- VTRIN -------------------------------*/


#ifdef NEED_UNDERSCORE
#define vtrin_superwrap_create            vtrin_superwrap_create_
#define vtrin_superwrap_init              vtrin_superwrap_init_
#define vtrin_superwrap_update            vtrin_superwrap_update_
#define vtrin_superwrap_oneset            vtrin_superwrap_oneset_ 
#define vtrin_superwrap_twosets           vtrin_superwrap_twosets_
#define vtrin_superwrap_wrapup            vtrin_superwrap_wrapup_
#define vtrin_superwrap_delete            vtrin_superwrap_delete_
#elif defined NEED_CAPITALS
#define vtrin_superwrap_create            VTRIN_SUPERWRAP_CREATE
#define vtrin_superwrap_init              VTRIN_SUPERWRAP_INIT
#define vtrin_superwrap_update            VTRIN_SUPERWRAP_UPDATE
#define vtrin_superwrap_oneset            VTRIN_SUPERWRAP_ONESET 
#define vtrin_superwrap_twosets           VTRIN_SUPERWRAP_TWOSETS
#define vtrin_superwrap_wrapup            VTRIN_SUPERWRAP_WRAPUP
#define vtrin_superwrap_delete            VTRIN_SUPERWRAP_DELETE
#endif


ProcessCreate     vtrin_superwrap_create;
ProcessInitialize vtrin_superwrap_init;
ProcessUpdate     vtrin_superwrap_update;
ProcessOneset     vtrin_superwrap_oneset;
ProcessTwosets    vtrin_superwrap_twosets;
ProcessWrapup     vtrin_superwrap_wrapup;
ProcessDelete     vtrin_superwrap_delete;


void superwrap_vtrin_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = vtrin_superwrap_create;
  THIS->initialize = vtrin_superwrap_init;
  THIS->update     = vtrin_superwrap_update;
  THIS->oneset     = vtrin_superwrap_oneset;
  THIS->twosets    = vtrin_superwrap_twosets;
  THIS->wrapup     = vtrin_superwrap_wrapup;
  THIS->delete     = vtrin_superwrap_delete;
}



/*------------------------------- XP -------------------------------*/
/*------------------------------- XP -------------------------------*/
/*------------------------------- XP -------------------------------*/


#ifdef NEED_UNDERSCORE
#define xp_superwrap_create            xp_superwrap_create_
#define xp_superwrap_init              xp_superwrap_init_
#define xp_superwrap_update            xp_superwrap_update_
#define xp_superwrap_oneset            xp_superwrap_oneset_ 
#define xp_superwrap_twosets           xp_superwrap_twosets_
#define xp_superwrap_wrapup            xp_superwrap_wrapup_
#define xp_superwrap_delete            xp_superwrap_delete_
#elif defined NEED_CAPITALS
#define xp_superwrap_create            XP_SUPERWRAP_CREATE
#define xp_superwrap_init              XP_SUPERWRAP_INIT
#define xp_superwrap_update            XP_SUPERWRAP_UPDATE
#define xp_superwrap_oneset            XP_SUPERWRAP_ONESET 
#define xp_superwrap_twosets           XP_SUPERWRAP_TWOSETS
#define xp_superwrap_wrapup            XP_SUPERWRAP_WRAPUP
#define xp_superwrap_delete            XP_SUPERWRAP_DELETE
#endif


ProcessCreate     xp_superwrap_create;
ProcessInitialize xp_superwrap_init;
ProcessUpdate     xp_superwrap_update;
ProcessOneset     xp_superwrap_oneset;
ProcessTwosets    xp_superwrap_twosets;
ProcessWrapup     xp_superwrap_wrapup;
ProcessDelete     xp_superwrap_delete;


void superwrap_xp_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = xp_superwrap_create;
  THIS->initialize = xp_superwrap_init;
  THIS->update     = xp_superwrap_update;
  THIS->oneset     = xp_superwrap_oneset;
  THIS->twosets    = xp_superwrap_twosets;
  THIS->wrapup     = xp_superwrap_wrapup;
  THIS->delete     = xp_superwrap_delete;
}


/*------------------------------- XPS -------------------------------*/
/*------------------------------- XPS -------------------------------*/
/*------------------------------- XPS -------------------------------*/


#ifdef NEED_UNDERSCORE
#define xps_superwrap_create            xps_superwrap_create_
#define xps_superwrap_init              xps_superwrap_init_
#define xps_superwrap_update            xps_superwrap_update_
#define xps_superwrap_oneset            xps_superwrap_oneset_ 
#define xps_superwrap_twosets           xps_superwrap_twosets_
#define xps_superwrap_wrapup            xps_superwrap_wrapup_
#define xps_superwrap_delete            xps_superwrap_delete_
#elif defined NEED_CAPITALS
#define xps_superwrap_create            XPS_SUPERWRAP_CREATE
#define xps_superwrap_init              XPS_SUPERWRAP_INIT
#define xps_superwrap_update            XPS_SUPERWRAP_UPDATE
#define xps_superwrap_oneset            XPS_SUPERWRAP_ONESET 
#define xps_superwrap_twosets           XPS_SUPERWRAP_TWOSETS
#define xps_superwrap_wrapup            XPS_SUPERWRAP_WRAPUP
#define xps_superwrap_delete            XPS_SUPERWRAP_DELETE
#endif


ProcessCreate     xps_superwrap_create;
ProcessInitialize xps_superwrap_init;
ProcessUpdate     xps_superwrap_update;
ProcessOneset     xps_superwrap_oneset;
ProcessTwosets    xps_superwrap_twosets;
ProcessWrapup     xps_superwrap_wrapup;
ProcessDelete     xps_superwrap_delete;


void superwrap_xps_startup (SuperMiddleStruct *THIS)
{
  THIS->create     = xps_superwrap_create;
  THIS->initialize = xps_superwrap_init;
  THIS->update     = xps_superwrap_update;
  THIS->oneset     = xps_superwrap_oneset;
  THIS->twosets    = xps_superwrap_twosets;
  THIS->wrapup     = xps_superwrap_wrapup;
  THIS->delete     = xps_superwrap_delete;
}

